/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         VLparse
#define yylex           VLlex
#define yyerror         VLerror
#define yydebug         VLdebug
#define yynerrs         VLnerrs

#define yylval          VLlval
#define yychar          VLchar
#define yylloc          VLlloc

/* Copy the first part of user declarations.  */
#line 2 "parse.y" /* yacc.c:339  */

/*
 * Copyright (c) 1998-2012 Stephen Williams (steve@icarus.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

# include "config.h"

# include  "parse_misc.h"
# include  "compiler.h"
# include  "pform.h"
# include  "Statement.h"
# include  "PSpec.h"
# include  <stack>
# include  <cstring>
# include  <sstream>

class PSpecPath;

extern void lex_start_table();
extern void lex_end_table();

static svector<PExpr*>* param_active_range = 0;
static bool param_active_signed = false;
static ivl_variable_type_t param_active_type = IVL_VT_LOGIC;

/* Port declaration lists use this structure for context. */
static struct {
      NetNet::Type port_net_type;
      NetNet::PortType port_type;
      ivl_variable_type_t var_type;
      bool sign_flag;
      svector<PExpr*>* range;
} port_declaration_context = {NetNet::NONE, NetNet::NOT_A_PORT,
                              IVL_VT_NO_TYPE, false, 0};

/* The task and function rules need to briefly hold the pointer to the
   task/function that is currently in progress. */
static PTask* current_task = 0;
static PFunction* current_function = 0;
static stack<PBlock*> current_block_stack;

/* This is used to keep track of the extra arguments after the notifier
 * in the $setuphold and $recrem timing checks. This allows us to print
 * a warning message that the delayed signals will not be created. We
 * need to do this since not driving these signals creates real
 * simulation issues. */
static unsigned args_after_notifier;

/* Later version of bison (including 1.35) will not compile in stack
   extension if the output is compiled with C++ and either the YYSTYPE
   or YYLTYPE are provided by the source code. However, I can get the
   old behavior back by defining these symbols. */
# define YYSTYPE_IS_TRIVIAL 1
# define YYLTYPE_IS_TRIVIAL 1

/* Recent version of bison expect that the user supply a
   YYLLOC_DEFAULT macro that makes up a yylloc value from existing
   values. I need to supply an explicit version to account for the
   text field, that otherwise won't be copied. */
# define YYLLOC_DEFAULT(Current, Rhs, N)  do {       \
  (Current).first_line   = (Rhs)[1].first_line;      \
  (Current).first_column = (Rhs)[1].first_column;    \
  (Current).last_line    = (Rhs)[N].last_line;       \
  (Current).last_column  = (Rhs)[N].last_column;     \
  (Current).text         = (Rhs)[1].text;   } while (0)

/*
 * These are some common strength pairs that are used as defaults when
 * the user is not otherwise specific.
 */
const static struct str_pair_t pull_strength = { PGate::PULL,  PGate::PULL };
const static struct str_pair_t str_strength = { PGate::STRONG, PGate::STRONG };

static list<pair<perm_string,PExpr*> >* make_port_list(char*id, PExpr*expr)
{
      list<pair<perm_string,PExpr*> >*tmp = new list<pair<perm_string,PExpr*> >;
      tmp->push_back(make_pair(lex_strings.make(id), expr));
      delete[]id;
      return tmp;
}
static list<pair<perm_string,PExpr*> >* make_port_list(list<pair<perm_string,
                                                                 PExpr*> >*tmp,
                                                       char*id, PExpr*expr)
{
      tmp->push_back(make_pair(lex_strings.make(id), expr));
      delete[]id;
      return tmp;
}

static list<perm_string>* list_from_identifier(char*id)
{
      list<perm_string>*tmp = new list<perm_string>;
      tmp->push_back(lex_strings.make(id));
      delete[]id;
      return tmp;
}

static list<perm_string>* list_from_identifier(list<perm_string>*tmp, char*id)
{
      tmp->push_back(lex_strings.make(id));
      delete[]id;
      return tmp;
}

static svector<PExpr*>* copy_range(svector<PExpr*>* orig)
{
      svector<PExpr*>*copy = 0;

      if (orig) {
	    copy = new svector<PExpr*>(2);
	    (*copy)[0] = (*orig)[0];
	    (*copy)[1] = (*orig)[1];
      }

      return copy;
}

template <class T> void append(vector<T>&out, const vector<T>&in)
{
      for (size_t idx = 0 ; idx < in.size() ; idx += 1)
	    out.push_back(in[idx]);
}

/*
 * This is a shorthand for making a PECallFunction that takes a single
 * arg. This is used by some of the code that detects built-ins.
 */
static PECallFunction*make_call_function(perm_string tn, PExpr*arg)
{
      svector<PExpr*> parms(1);
      parms[0] = arg;
      PECallFunction*tmp = new PECallFunction(tn, parms);
      return tmp;
}

static PECallFunction*make_call_function(perm_string tn, PExpr*arg1, PExpr*arg2)
{
      svector<PExpr*> parms(2);
      parms[0] = arg1;
      parms[1] = arg2;
      PECallFunction*tmp = new PECallFunction(tn, parms);
      return tmp;
}


#line 236 "parse.cc" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parse.hh".  */
#ifndef YY_VL_PARSE_HH_INCLUDED
# define YY_VL_PARSE_HH_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int VLdebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENTIFIER = 258,
    SYSTEM_IDENTIFIER = 259,
    STRING = 260,
    DISCIPLINE_IDENTIFIER = 261,
    PATHPULSE_IDENTIFIER = 262,
    BASED_NUMBER = 263,
    DEC_NUMBER = 264,
    REALTIME = 265,
    K_LE = 266,
    K_GE = 267,
    K_EG = 268,
    K_EQ = 269,
    K_NE = 270,
    K_CEQ = 271,
    K_CNE = 272,
    K_LS = 273,
    K_RS = 274,
    K_RSS = 275,
    K_SG = 276,
    K_CONTRIBUTE = 277,
    K_PO_POS = 278,
    K_PO_NEG = 279,
    K_POW = 280,
    K_PSTAR = 281,
    K_STARP = 282,
    K_LOR = 283,
    K_LAND = 284,
    K_NAND = 285,
    K_NOR = 286,
    K_NXOR = 287,
    K_TRIGGER = 288,
    K_edge_descriptor = 289,
    K_always = 290,
    K_and = 291,
    K_assign = 292,
    K_begin = 293,
    K_buf = 294,
    K_bufif0 = 295,
    K_bufif1 = 296,
    K_case = 297,
    K_casex = 298,
    K_casez = 299,
    K_cmos = 300,
    K_deassign = 301,
    K_default = 302,
    K_defparam = 303,
    K_disable = 304,
    K_edge = 305,
    K_else = 306,
    K_end = 307,
    K_endcase = 308,
    K_endfunction = 309,
    K_endmodule = 310,
    K_endprimitive = 311,
    K_endspecify = 312,
    K_endtable = 313,
    K_endtask = 314,
    K_event = 315,
    K_for = 316,
    K_force = 317,
    K_forever = 318,
    K_fork = 319,
    K_function = 320,
    K_highz0 = 321,
    K_highz1 = 322,
    K_if = 323,
    K_ifnone = 324,
    K_initial = 325,
    K_inout = 326,
    K_input = 327,
    K_integer = 328,
    K_join = 329,
    K_large = 330,
    K_macromodule = 331,
    K_medium = 332,
    K_module = 333,
    K_nand = 334,
    K_negedge = 335,
    K_nmos = 336,
    K_nor = 337,
    K_not = 338,
    K_notif0 = 339,
    K_notif1 = 340,
    K_or = 341,
    K_output = 342,
    K_parameter = 343,
    K_pmos = 344,
    K_posedge = 345,
    K_primitive = 346,
    K_pull0 = 347,
    K_pull1 = 348,
    K_pulldown = 349,
    K_pullup = 350,
    K_rcmos = 351,
    K_real = 352,
    K_realtime = 353,
    K_reg = 354,
    K_release = 355,
    K_repeat = 356,
    K_rnmos = 357,
    K_rpmos = 358,
    K_rtran = 359,
    K_rtranif0 = 360,
    K_rtranif1 = 361,
    K_scalared = 362,
    K_small = 363,
    K_specify = 364,
    K_specparam = 365,
    K_strong0 = 366,
    K_strong1 = 367,
    K_supply0 = 368,
    K_supply1 = 369,
    K_table = 370,
    K_task = 371,
    K_time = 372,
    K_tran = 373,
    K_tranif0 = 374,
    K_tranif1 = 375,
    K_tri = 376,
    K_tri0 = 377,
    K_tri1 = 378,
    K_triand = 379,
    K_trior = 380,
    K_trireg = 381,
    K_vectored = 382,
    K_wait = 383,
    K_wand = 384,
    K_weak0 = 385,
    K_weak1 = 386,
    K_while = 387,
    K_wire = 388,
    K_wor = 389,
    K_xnor = 390,
    K_xor = 391,
    K_Shold = 392,
    K_Snochange = 393,
    K_Speriod = 394,
    K_Srecovery = 395,
    K_Ssetup = 396,
    K_Ssetuphold = 397,
    K_Sskew = 398,
    K_Swidth = 399,
    KK_attribute = 400,
    K_bool = 401,
    K_logic = 402,
    K_automatic = 403,
    K_endgenerate = 404,
    K_generate = 405,
    K_genvar = 406,
    K_localparam = 407,
    K_noshowcancelled = 408,
    K_pulsestyle_onevent = 409,
    K_pulsestyle_ondetect = 410,
    K_showcancelled = 411,
    K_signed = 412,
    K_unsigned = 413,
    K_Sfullskew = 414,
    K_Srecrem = 415,
    K_Sremoval = 416,
    K_Stimeskew = 417,
    K_cell = 418,
    K_config = 419,
    K_design = 420,
    K_endconfig = 421,
    K_incdir = 422,
    K_include = 423,
    K_instance = 424,
    K_liblist = 425,
    K_library = 426,
    K_use = 427,
    K_wone = 428,
    K_uwire = 429,
    K_always_comb = 430,
    K_always_ff = 431,
    K_always_latch = 432,
    K_assert = 433,
    K_abs = 434,
    K_abstol = 435,
    K_access = 436,
    K_acos = 437,
    K_acosh = 438,
    K_analog = 439,
    K_asin = 440,
    K_asinh = 441,
    K_atan = 442,
    K_atan2 = 443,
    K_atanh = 444,
    K_ceil = 445,
    K_continuous = 446,
    K_cos = 447,
    K_cosh = 448,
    K_ddt_nature = 449,
    K_discipline = 450,
    K_discrete = 451,
    K_domain = 452,
    K_enddiscipline = 453,
    K_endnature = 454,
    K_exclude = 455,
    K_exp = 456,
    K_floor = 457,
    K_flow = 458,
    K_from = 459,
    K_ground = 460,
    K_hypot = 461,
    K_idt_nature = 462,
    K_inf = 463,
    K_ln = 464,
    K_log = 465,
    K_max = 466,
    K_min = 467,
    K_nature = 468,
    K_potential = 469,
    K_pow = 470,
    K_sin = 471,
    K_sinh = 472,
    K_sqrt = 473,
    K_string = 474,
    K_tan = 475,
    K_tanh = 476,
    K_units = 477,
    K_TAND = 478,
    UNARY_PREC = 479,
    less_than_K_else = 480
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 163 "parse.y" /* yacc.c:355  */

      bool flag;

      char letter;

	/* text items are C strings allocated by the lexor using
	   strdup. They can be put into lists with the texts type. */
      char*text;
      list<perm_string>*perm_strings;

      list<pair<perm_string,PExpr*> >*port_list;

      pform_name_t*pform_name;

      ivl_discipline_t discipline;

      hname_t*hier;

      list<string>*strings;

      struct str_pair_t drive;

      PCase::Item*citem;
      svector<PCase::Item*>*citems;

      lgate*gate;
      svector<lgate>*gates;

      Module::port_t *mport;
      LexicalScope::range_t* value_range;
      vector<Module::port_t*>*mports;

      named_pexpr_t*named_pexpr;
      svector<named_pexpr_t*>*named_pexprs;
      struct parmvalue_t*parmvalue;

      PExpr*expr;
      svector<PExpr*>*exprs;

      svector<PEEvent*>*event_expr;

      NetNet::Type nettype;
      PGBuiltin::Type gatetype;
      NetNet::PortType porttype;
      ivl_variable_type_t datatype;

      PWire*wire;
      svector<PWire*>*wires;

      PEventStatement*event_statement;
      Statement*statement;
      svector<Statement*>*statement_list;

      PTaskFuncArg function_type;

      net_decl_assign_t*net_decl_assign;

      verinum* number;

      verireal* realtime;

      PSpecPath* specpath;
      list<index_component_t> *dimensions;

#line 567 "parse.cc" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE VLlval;
extern YYLTYPE VLlloc;
int VLparse (void);

#endif /* !YY_VL_PARSE_HH_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 596 "parse.cc" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  26
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   11371

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  271
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  185
/* YYNRULES -- Number of rules.  */
#define YYNRULES  730
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1784

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   480

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   247,     2,   243,     2,   235,   228,     2,
     238,   242,   233,   231,   239,   232,   244,   234,   252,   253,
       2,     2,     2,     2,     2,     2,     2,     2,   225,   241,
     229,   240,   230,   224,   245,     2,   260,     2,     2,     2,
     257,     2,     2,     2,     2,     2,     2,   263,   265,     2,
     267,   268,   262,     2,     2,     2,     2,     2,     2,     2,
       2,   250,     2,   251,   227,   270,     2,     2,   255,     2,
       2,     2,   256,     2,   259,     2,     2,     2,   258,     2,
     264,     2,   266,   269,   261,     2,     2,     2,     2,     2,
     254,     2,     2,   248,   226,   249,   246,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   236,
     237
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   394,   394,   394,   397,   398,   401,   403,   405,   413,
     414,   421,   422,   426,   427,   428,   429,   441,   447,   456,
     463,   481,   494,   508,   513,   522,   524,   527,   531,   532,
     537,   542,   547,   551,   555,   559,   563,   570,   571,   575,
     576,   580,   587,   592,   597,   604,   610,   618,   619,   620,
     624,   625,   629,   636,   637,   641,   645,   650,   658,   663,
     668,   674,   684,   685,   689,   694,   702,   706,   712,   723,
     733,   742,   743,   744,   745,   746,   747,   759,   759,   763,
     762,   769,   770,   774,   776,   778,   780,   786,   785,   793,
     794,   798,   800,   801,   803,   805,   810,   820,   823,   826,
     828,   832,   833,   835,   837,   838,   841,   843,   847,   849,
     853,   855,   860,   864,   868,   872,   876,   880,   887,   888,
     892,   893,   894,   895,   899,   900,   901,   902,   906,   914,
     920,   927,   929,   935,   944,   951,   958,   972,   974,   979,
     981,   983,   988,   993,   998,  1003,  1008,  1013,  1018,  1023,
    1028,  1033,  1038,  1043,  1048,  1053,  1058,  1063,  1068,  1073,
    1078,  1083,  1088,  1093,  1098,  1103,  1108,  1113,  1118,  1123,
    1128,  1133,  1138,  1143,  1148,  1153,  1158,  1163,  1168,  1173,
    1178,  1186,  1188,  1235,  1240,  1246,  1251,  1259,  1264,  1272,
    1278,  1283,  1288,  1299,  1310,  1316,  1323,  1328,  1337,  1344,
    1351,  1358,  1365,  1372,  1379,  1386,  1393,  1400,  1407,  1414,
    1421,  1428,  1435,  1442,  1449,  1456,  1463,  1470,  1477,  1488,
    1494,  1500,  1508,  1513,  1519,  1526,  1542,  1544,  1559,  1561,
    1568,  1578,  1591,  1602,  1619,  1630,  1645,  1658,  1673,  1681,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1705,  1706,  1707,  1708,  1709,  1710,  1711,  1712,
    1713,  1714,  1715,  1716,  1726,  1731,  1737,  1746,  1756,  1766,
    1782,  1784,  1789,  1791,  1793,  1795,  1817,  1823,  1831,  1837,
    1842,  1861,  1866,  1874,  1891,  1908,  1925,  1942,  1967,  1968,
    1971,  1971,  1978,  1984,  1996,  2005,  2011,  2021,  2025,  2020,
    2047,  2047,  2050,  2051,  2055,  2056,  2057,  2063,  2065,  2069,
    2070,  2071,  2082,  2102,  2121,  2136,  2142,  2149,  2152,  2172,
    2178,  2184,  2195,  2201,  2205,  2211,  2215,  2219,  2223,  2228,
    2232,  2239,  2243,  2248,  2252,  2256,  2260,  2264,  2268,  2276,
    2284,  2295,  2300,  2304,  2309,  2321,  2320,  2335,  2334,  2350,
    2349,  2365,  2377,  2376,  2391,  2390,  2405,  2418,  2420,  2426,
    2423,  2433,  2430,  2437,  2442,  2441,  2448,  2455,  2455,  2468,
    2471,  2475,  2484,  2491,  2496,  2502,  2508,  2517,  2524,  2529,
    2530,  2533,  2536,  2537,  2541,  2541,  2543,  2543,  2548,  2549,
    2553,  2554,  2564,  2565,  2566,  2570,  2570,  2581,  2592,  2598,
    2604,  2605,  2606,  2609,  2609,  2612,  2613,  2614,  2615,  2616,
    2617,  2618,  2619,  2620,  2621,  2622,  2627,  2631,  2636,  2640,
    2645,  2650,  2655,  2667,  2679,  2692,  2693,  2697,  2698,  2702,
    2711,  2719,  2719,  2722,  2724,  2729,  2731,  2733,  2735,  2737,
    2742,  2743,  2744,  2745,  2748,  2748,  2767,  2773,  2779,  2791,
    2802,  2808,  2812,  2819,  2829,  2834,  2857,  2865,  2876,  2885,
    2894,  2895,  2911,  2919,  2942,  2964,  2978,  2980,  2993,  3000,
    3008,  3018,  3024,  3032,  3033,  3034,  3038,  3047,  3048,  3051,
    3052,  3056,  3064,  3076,  3077,  3078,  3079,  3080,  3081,  3082,
    3091,  3107,  3117,  3123,  3132,  3147,  3156,  3162,  3171,  3190,
    3196,  3205,  3206,  3209,  3212,  3220,  3228,  3236,  3241,  3246,
    3250,  3255,  3259,  3263,  3268,  3272,  3276,  3281,  3285,  3289,
    3294,  3297,  3300,  3303,  3306,  3312,  3313,  3317,  3319,  3326,
    3326,  3329,  3333,  3337,  3341,  3348,  3349,  3350,  3354,  3356,
    3361,  3369,  3372,  3375,  3382,  3388,  3394,  3400,  3409,  3414,
    3452,  3456,  3464,  3465,  3469,  3470,  3471,  3475,  3477,  3479,
    3483,  3487,  3489,  3493,  3497,  3506,  3507,  3512,  3513,  3517,
    3519,  3521,  3523,  3532,  3544,  3550,  3560,  3565,  3577,  3582,
    3590,  3589,  3605,  3613,  3618,  3626,  3625,  3641,  3644,  3650,
    3656,  3661,  3666,  3671,  3676,  3681,  3683,  3685,  3687,  3692,
    3697,  3701,  3705,  3711,  3716,  3721,  3725,  3730,  3734,  3741,
    3752,  3759,  3766,  3771,  3776,  3781,  3786,  3793,  3800,  3805,
    3811,  3816,  3821,  3829,  3836,  3843,  3855,  3862,  3869,  3877,
    3889,  3893,  3898,  3906,  3908,  3913,  3920,  3921,  3925,  3926,
    3930,  3939,  3948,  3961,  3976,  3991,  4009,  4023,  4037,  4054,
    4062,  4070,  4081,  4087,  4092,  4095,  4100,  4114,  4127,  4143,
    4164,  4185,  4209,  4229,  4249,  4272,  4285,  4298,  4314,  4320,
    4322,  4336,  4341,  4349,  4349,  4355,  4356,  4360,  4373,  4379,
    4388,  4394,  4403,  4417,  4428,  4429,  4433,  4439,  4451,  4452,
    4453,  4454,  4455,  4456,  4457,  4458,  4459,  4460,  4461,  4462,
    4463,  4464,  4465,  4466,  4467,  4468,  4469,  4470,  4471,  4472,
    4473,  4477,  4478,  4479,  4480,  4487,  4489,  4497,  4505,  4516,
    4518,  4527,  4533,  4541,  4541,  4544,  4545,  4549,  4555,  4568,
    4583
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENTIFIER", "SYSTEM_IDENTIFIER",
  "STRING", "DISCIPLINE_IDENTIFIER", "PATHPULSE_IDENTIFIER",
  "BASED_NUMBER", "DEC_NUMBER", "REALTIME", "K_LE", "K_GE", "K_EG", "K_EQ",
  "K_NE", "K_CEQ", "K_CNE", "K_LS", "K_RS", "K_RSS", "K_SG",
  "K_CONTRIBUTE", "K_PO_POS", "K_PO_NEG", "K_POW", "K_PSTAR", "K_STARP",
  "K_LOR", "K_LAND", "K_NAND", "K_NOR", "K_NXOR", "K_TRIGGER",
  "K_edge_descriptor", "K_always", "K_and", "K_assign", "K_begin", "K_buf",
  "K_bufif0", "K_bufif1", "K_case", "K_casex", "K_casez", "K_cmos",
  "K_deassign", "K_default", "K_defparam", "K_disable", "K_edge", "K_else",
  "K_end", "K_endcase", "K_endfunction", "K_endmodule", "K_endprimitive",
  "K_endspecify", "K_endtable", "K_endtask", "K_event", "K_for", "K_force",
  "K_forever", "K_fork", "K_function", "K_highz0", "K_highz1", "K_if",
  "K_ifnone", "K_initial", "K_inout", "K_input", "K_integer", "K_join",
  "K_large", "K_macromodule", "K_medium", "K_module", "K_nand",
  "K_negedge", "K_nmos", "K_nor", "K_not", "K_notif0", "K_notif1", "K_or",
  "K_output", "K_parameter", "K_pmos", "K_posedge", "K_primitive",
  "K_pull0", "K_pull1", "K_pulldown", "K_pullup", "K_rcmos", "K_real",
  "K_realtime", "K_reg", "K_release", "K_repeat", "K_rnmos", "K_rpmos",
  "K_rtran", "K_rtranif0", "K_rtranif1", "K_scalared", "K_small",
  "K_specify", "K_specparam", "K_strong0", "K_strong1", "K_supply0",
  "K_supply1", "K_table", "K_task", "K_time", "K_tran", "K_tranif0",
  "K_tranif1", "K_tri", "K_tri0", "K_tri1", "K_triand", "K_trior",
  "K_trireg", "K_vectored", "K_wait", "K_wand", "K_weak0", "K_weak1",
  "K_while", "K_wire", "K_wor", "K_xnor", "K_xor", "K_Shold",
  "K_Snochange", "K_Speriod", "K_Srecovery", "K_Ssetup", "K_Ssetuphold",
  "K_Sskew", "K_Swidth", "KK_attribute", "K_bool", "K_logic",
  "K_automatic", "K_endgenerate", "K_generate", "K_genvar", "K_localparam",
  "K_noshowcancelled", "K_pulsestyle_onevent", "K_pulsestyle_ondetect",
  "K_showcancelled", "K_signed", "K_unsigned", "K_Sfullskew", "K_Srecrem",
  "K_Sremoval", "K_Stimeskew", "K_cell", "K_config", "K_design",
  "K_endconfig", "K_incdir", "K_include", "K_instance", "K_liblist",
  "K_library", "K_use", "K_wone", "K_uwire", "K_always_comb",
  "K_always_ff", "K_always_latch", "K_assert", "K_abs", "K_abstol",
  "K_access", "K_acos", "K_acosh", "K_analog", "K_asin", "K_asinh",
  "K_atan", "K_atan2", "K_atanh", "K_ceil", "K_continuous", "K_cos",
  "K_cosh", "K_ddt_nature", "K_discipline", "K_discrete", "K_domain",
  "K_enddiscipline", "K_endnature", "K_exclude", "K_exp", "K_floor",
  "K_flow", "K_from", "K_ground", "K_hypot", "K_idt_nature", "K_inf",
  "K_ln", "K_log", "K_max", "K_min", "K_nature", "K_potential", "K_pow",
  "K_sin", "K_sinh", "K_sqrt", "K_string", "K_tan", "K_tanh", "K_units",
  "K_TAND", "'?'", "':'", "'|'", "'^'", "'&'", "'<'", "'>'", "'+'", "'-'",
  "'*'", "'/'", "'%'", "UNARY_PREC", "less_than_K_else", "'('", "','",
  "'='", "';'", "')'", "'#'", "'.'", "'@'", "'~'", "'!'", "'{'", "'}'",
  "'['", "']'", "'0'", "'1'", "'x'", "'b'", "'f'", "'F'", "'l'", "'h'",
  "'B'", "'r'", "'R'", "'M'", "'n'", "'N'", "'p'", "'P'", "'Q'", "'q'",
  "'_'", "$accept", "main", "source_file", "number", "real_or_realtime",
  "attribute_list_opt", "attribute_instance_list", "attribute_list",
  "attribute", "block_item_decl", "block_item_decls",
  "block_item_decls_opt", "case_item", "case_items", "charge_strength",
  "charge_strength_opt", "defparam_assign", "defparam_assign_list",
  "delay1", "delay3", "delay3_opt", "delay_value_list", "delay_value",
  "delay_value_simple", "description", "optional_semicolon",
  "discipline_declaration", "$@1", "discipline_items", "discipline_item",
  "nature_declaration", "$@2", "nature_items", "nature_item",
  "config_declaration", "lib_cell_identifiers",
  "list_of_config_rule_statements", "config_rule_statement", "opt_config",
  "lib_cell_id", "list_of_libraries", "drive_strength",
  "drive_strength_opt", "dr_strength0", "dr_strength1", "event_control",
  "event_expression_list", "event_expression", "branch_probe_expression",
  "expression", "expr_mintypmax", "expression_list_with_nuls",
  "expression_list_proper", "expr_primary", "function_item_list",
  "function_item", "gate_instance", "gate_instance_list", "gatetype",
  "switchtype", "hierarchy_identifier", "list_of_identifiers",
  "list_of_port_identifiers", "list_of_ports", "list_of_port_declarations",
  "port_declaration", "net_type_opt", "signed_opt", "lpvalue",
  "cont_assign", "cont_assign_list", "module", "$@3", "$@4",
  "module_start", "module_attribute_foreign", "module_port_list_opt",
  "module_parameter_port_list_opt", "module_parameter_port_list",
  "module_item", "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12",
  "$@13", "automatic_opt", "generate_if", "generate_case_items",
  "generate_case_item", "$@14", "$@15", "module_item_list",
  "module_item_list_opt", "generate_block", "generate_block_opt",
  "net_decl_assign", "net_decl_assigns", "primitive_type",
  "primitive_type_opt", "net_type", "var_type", "param_type",
  "parameter_assign_list", "localparam_assign_list", "parameter_assign",
  "localparam_assign", "parameter_value_ranges_opt",
  "parameter_value_ranges", "parameter_value_range",
  "value_range_expression", "from_exclude", "parameter_value_opt",
  "parameter_value_byname", "parameter_value_byname_list", "port",
  "port_opt", "port_reference", "port_reference_list", "port_name",
  "port_name_list", "port_type", "range", "range_opt", "dimensions_opt",
  "dimensions", "function_range_or_type_opt", "register_variable",
  "register_variable_list", "real_variable", "real_variable_list",
  "net_variable", "net_variable_list", "specify_item", "specify_item_list",
  "specify_edge_path_decl", "edge_operator", "specify_edge_path",
  "polarity_operator", "specify_simple_path_decl", "specify_simple_path",
  "specify_path_identifiers", "specparam", "specparam_list",
  "spec_polarity", "spec_reference_event", "edge_descriptor_list",
  "spec_notifier_opt", "spec_notifier", "statement", "$@16", "$@17",
  "statement_list_or_null", "statement_list", "statement_or_null",
  "analog_statement", "task_item", "reg_opt", "task_port_item",
  "task_item_list", "task_item_list_opt", "task_port_decl",
  "task_port_decl_list", "udp_body", "$@18", "udp_entry_list",
  "udp_comb_entry", "udp_comb_entry_list", "udp_sequ_entry_list",
  "udp_sequ_entry", "udp_initial", "udp_init_opt", "udp_input_list",
  "udp_input_sym", "udp_output_sym", "udp_port_decl", "udp_port_decls",
  "udp_port_list", "udp_reg_opt", "udp_initial_expr_opt",
  "udp_input_declaration_list", "udp_primitive", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,    63,    58,   124,    94,    38,    60,
      62,    43,    45,    42,    47,    37,   479,   480,    40,    44,
      61,    59,    41,    35,    46,    64,   126,    33,   123,   125,
      91,    93,    48,    49,   120,    98,   102,    70,   108,   104,
      66,   114,    82,    77,   110,    78,   112,    80,    81,   113,
      95
};
# endif

#define YYPACT_NINF -1394

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1394)))

#define YYTABLE_NINF -714

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     482,   414,    52,  -130,   219,   239,   406,   470,   632,    31,
     469, -1394, -1394, -1394, -1394, -1394, -1394,   270, -1394,    19,
   -1394,   294,   552,   326,   354,   354, -1394, -1394, -1394, -1394,
     612,   538,  5064, -1394,   619,   247,   409,   494, -1394, -1394,
   -1394, -1394, -1394,    20, -1394,   487, -1394, -1394,   656, -1394,
    5607,  5607,  5607,   501,   518,   523,   533,   541,   566,   595,
     606,   614,   631,   653,   661,   684,   700,   726,   744,   749,
     758,   794,   807,   808,   813,   814,   825,  5607,  2894,  5607,
    5607,  5607,  5064,  5310,  2976,  5064, -1394, 10373, -1394,   387,
   -1394, -1394,   577,   -40,   705, -1394,   366,   563,   672, -1394,
    4366, -1394, -1394, -1394, -1394,  5064,  5064,  5064,  5064,  5064,
    5064,  5064,  5064,  5064,  5064,  5064,  5064,  5064,  5064,  5064,
    5064,  5064,  5064,  5064,  5064,  5064,  5064,  5064,  5064, -1394,
   -1394, -1394, -1394, -1394, -1394,  9937,   771,  5607,  5607,  5607,
   -1394, -1394, -1394,  6124,   121,  5064,  5064,  5064,  5064,  5064,
    5064,  5064,  5064,  5064,  5064,  5064,  5064,  5064,  5064,  5064,
    5064,  5064,  5064,  5064,  5064,  5064,  5064,  5064,  5064,  5064,
    5064,  4436,  1014,  5064, -1394,  1061,  1082,   834,   861,    45,
     -19,  1101,  1102,   524, -1394,   836,   875,   876,   886,   907,
    1010, -1394,   898,   903, -1394, 10373,   568,  6228,  6373,  6395,
    6417,  6457,  6479,  9272,  6501,  6523,  6545,  6646,  6774,  6796,
    9329,  6818,  6875,  9351,  9373,  9395,  6897,  6919,  6941,  6963,
    7047,  5064, -1394, -1394, -1394, -1394,  5064,  5064, -1394,   481,
     481,   877,   877,   877,   877,   520,   520,   520, -1394,  1183,
    4160,   624,   806,   806,  9964, 10395,   806,   624,   481,   481,
      86,    86,  1131,  1131,  1131, -1394,   598, -1394,   717,   917,
   -1394,   461,  1158,   928, -1394, -1394,   938,   939,   942,   948,
   -1394, -1394,  5064,  1189,  1190,  1203,  1202, -1394, -1394,  1135,
     153,  1212, -1394, -1394, -1394, -1394, -1394, -1394, -1394,  5064,
   -1394, -1394, -1394, -1394, -1394, -1394,  5064, -1394, -1394,  5064,
    5064,  5064, -1394, -1394, -1394, -1394, -1394,  9986,   234, 10373,
    5064, -1394,  5064,  5064,  5064, -1394,  5064,   990,  1240,  1247,
     274, -1394,   729,  1005,  1250,   503, -1394, -1394, -1394, -1394,
    8412,  1027,  1028,  1033,  1036,   421,   604,  1038,  1275,  1281,
     504,   638,    21, -1394, -1394, -1394, -1394,  1305,  1075,  7192,
    7214,  7236,  7276,  7298,  5064,    25, 10373,  3922,  5821,  5975,
   10373,  1251, -1394,   539,  1079,  1083,  1326,  1339, -1394,  1228,
   -1394, -1394, -1394,  1197,  1346, -1394,  1356, -1394, -1394, -1394,
   -1394, -1394, -1394, -1394, -1394, -1394, -1394,  1110,  5064, -1394,
    1365, -1394,   146, -1394,  2480,  1136, -1394,   253,  1512,  1512,
    1248,    28, -1394,   218, -1394, -1394,  1306, -1394, -1394, -1394,
   -1394, -1394, -1394, 10373,  1129, -1394, -1394, -1394, -1394,  1380,
     651,  1394, -1394, -1394, -1394,  1157,  1168, -1394,  1350, -1394,
     693,    83, -1394, 10008,  1180, -1394,   421, -1394,  1173,  3485,
      61,  1281, -1394, -1394, -1394, -1394, -1394, -1394, -1394, -1394,
   -1394, -1394, -1394, -1394, -1394,  1262, -1394,  1262, -1394,  1262,
    1262, -1394, -1394, -1394,  1425, 10888, -1394, -1394,  1362,  1199,
   -1394, -1394,   136, 11101, -1394,    94, -1394,  1346, -1394,  1346,
    5064,  5064,  1365, -1394,  5064, -1394,  1281,  1211, -1394, -1394,
    1110,  1110,  1110,  1110,  1201,  1204,  1240,    69,  1221,    37,
    1240,  1255,   154,  1256,  1485,   109,    63,   103,  1443,  1341,
    1264,  1266, 10748,  1240,   227, 10414, -1394, -1394,  5828, 10608,
    1452,  1495,  1228,  1267, -1394, -1394, -1394, -1394, -1394, -1394,
   -1394, -1394, -1394, -1394, -1394, -1394, -1394, -1394, -1394, -1394,
   -1394, -1394, -1394, -1394, -1394, -1394, -1394,  1451, -1394, 11101,
   11101, -1394,  4548, -1394, -1394, -1394,    99,  1285,   101,  1285,
    6003,  9913, -1394,  6046,   323, -1394, -1394,  1510,  1517,  1518,
    1524,  1523, -1394,   664,   341,  1179, -1394,  1286,  5064, -1394,
     761,   439,  1356,   862,  1528,  1478, -1394,   454,  5064,  1292,
    1295,  1365,   152,  3777, -1394,   896,  3777,   901,  1480, -1394,
    1300,  1301,   702,  1302,  1308,  1309,  1310,  1311,  1312,  1313,
    1314,  1540,  1540,  1540,  1540,  1316,  1317,  1321,  1322,   478,
   -1394,  1818,  1303,  1323,  1320,  1327,  1565,   403, -1394,  1110,
    1143,  9610,  1423,   911,  1332,  1573,  1334,  3630, -1394, -1394,
   -1394, -1394, -1394,  3630,  1479,  1479,  1161, -1394, -1394, -1394,
   -1394, -1394, -1394, -1394,  1479, -1394, -1394,  1166,  1167,    66,
   -1394, -1394, -1394, -1394, -1394,  1170, -1394, -1394, -1394, -1394,
   -1394,  1576,   100,   167,   357,  1401,  9766, -1394, -1394, -1394,
    1537, -1394, -1394, -1394,  1538, -1394, -1394, -1394,  4944, -1394,
    9262, 10208, -1394, -1394,  1436,  1360, -1394,  1366, -1394,  5228,
   -1394, -1394,   594, -1394,   192, -1394,  1364, -1394, -1394, -1394,
    1368,  1369, -1394,  5064, -1394,  1370,  1372, -1394, -1394, -1394,
   -1394, -1394, -1394, -1394, -1394,  1373,  1374,   207, -1394,    62,
    7320,  1356, -1394,  5064, -1394, -1394,  1375, -1394, -1394, -1394,
   -1394, -1394,  1110, -1394,  1611,  7342, -1394, -1394,   977, -1394,
    1487,  1378,   677,  1379, 10373,   698,   185, -1394,  1381,   719,
   -1394, -1394,  5064,  1382,  1383,  1387,  1388, -1394,   985,  5459,
    5459,  5459,  5459,  5459,  5459,  5459,  5459,  1371,   989,   994,
     995,   998,  5459,  5459,  5459,  5459,  1377, -1394, -1394,  1540,
     580, -1394, -1394, -1394,   226, -1394,   228,   180,  1396,  1397,
    1398,  1286,  1400,  1390,  1619,  1578, -1394, -1394, -1394,  1403,
    1018, -1394,   150,   184,   132,   728,  1356,    62,  1218,  1406,
    1409,  1410,    62,  1356,  1411,    62,  3630,  3169,  1412,    62,
    1414,  1416,  1420,   238,    32,  5064,  3288,  1633,   525,   160,
   -1394, -1394,  1262,  1262,  1422,   350, -1394,  1024,  1262,  1427,
     438, -1394,  1034,  1437,  1044,  1446, -1394, -1394, -1394, -1394,
    1262,  1449,  1048,  1453,  1670, -1394,  3634,   185,   167,  1055,
    5064,   185,  1056,  1262,  1110,  1262,  1691,  1643, -1394, -1394,
     753, 11101, -1394,  1459,  1460,  1465,  1484,  1469, -1394, -1394,
   -1394, 10373, -1394,  4530,  4530, -1394,  5064,  1685,  8434,   683,
     757,   492,   517, -1394, -1394, -1394,  5064, -1394,   119,  1476,
   -1394,  1059, -1394, -1394, 10373,  5064, -1394,   202, -1394,  1365,
   -1394,  1475,  1717,   756, -1394,   773,  1561,   683,   185,   757,
    5064, -1394, -1394,   683,   757,   185,  7364, -1394, -1394,  5064,
    5156,   702, -1394,  1471,  5064,  5064,  1499,  1488,  1489,  1491,
    1498,  1500,  1502,  1506,  1513,  5607,  1720, -1394, -1394, -1394,
   -1394,  1516,  1519,  1520,  1521, -1394,   580, -1394, -1394,    36,
    5064, -1394,  2562, -1394,  1665,  1514, -1394, -1394, -1394, -1394,
    1240,  1525,  1752, -1394,  1612,  5064,  1573, -1394, -1394, -1394,
   -1394,  4667,  1527,  1060,  5064,  5064, -1394,  5064, -1394,   565,
    1529,   303, -1394,  1761, -1394,  3335,  5064,  5064,  5064,  1533,
     591,    60,  1535, -1394,   175, -1394,  1762,  3407,  2646,  1539,
    5064,  5064,  2728,  5064, -1394,  1633,  1652,   119,   426, -1394,
   -1394, -1394,  3288,  4761, -1394,  3889,  4023,  1110,  1110, -1394,
    5064,  5064, -1394,  1534,  1780, -1394,  1110, -1394,  5064, -1394,
    1782, -1394, -1394, -1394, -1394,    48, -1394, -1394,  1783,  5064,
    1066,   185,  1072, -1394,  1073, -1394,   200,  1286,  1110, 11028,
   -1394, 11168, -1394, -1394, -1394,   753, -1394, -1394,  5387,  5537,
   10373,  1566,  1569, 10373, -1394, -1394,  1548,  1553,  1554,  1555,
    1556,  1559,   784, 10030,  5064,    62, -1394,  4833,  8456,  1748,
   -1394,  1568, -1394, -1394,  1572, -1394,  1560, -1394,  1570,   789,
     811,  1571,  1076,  1574, 10373,  1580,  1581,  1089,  1301, 10052,
    5064, 10373, -1394,  1777, 10373,  1591, 10373,  1592,  5064,  5459,
    5459,  5064,  5459,  5459,  5459,  5459,  5064,  1567,  1577,  5459,
    5459,  5459,  5459,   603,   193,   194,   817, -1394,  1586,   818,
   -1394,  1588,   542,  1088,  1094, -1394,  1593, 11028, -1394, 10373,
   -1394,  1827,   819, -1394,   835, -1394, -1394,  8513,  8535,   844,
   -1394,  5064, -1394, -1394, -1394, -1394,  7465,  7593,  7615, -1394,
   -1394,  1594,  1603,  5064, -1394, -1394, -1394,  1607,  7637, -1394,
    7694,  7716,  1608,  7738,  1609,  3288,  1610,  5064,  5064,  1613,
     -28, -1394, 10373, -1394, -1394,  1615,   845,  1595,   195,  5064,
    5064,  8557,  1621,  5064,  5064,  8579,  1240,  1240, 10373, 10074,
    5064, -1394,  1854, 10373, -1394,  1780,  1095,   850,  8601, -1394,
    1100, -1394, -1394,  1857,  1286,  1351,  1240,  1813, -1394,  1625,
   -1394, -1394,  4530,  4530, -1394, -1394, -1394, -1394, -1394, -1394,
    5064, -1394,  5064, 10373, -1394,  1646,    -6,  4135, -1394,  5064,
   -1394,   779,   542,  2148, -1394, -1394, -1394, -1394,   185, -1394,
     185,   185,   185, -1394,  1635,  1636,  5064,  9250, -1394,   233,
    5064,  5064, 10373,  1642,  1649,   155,  1650,  1653,  1654,  1655,
     851, -1394,  5607,  1656,  1658,  1663,  1668,  1644,  1673,  1540,
     852,  1540,   856,  5064, -1394, -1394, -1394, -1394,   417,   609,
     685, -1394,   637,   775,   837,   882,   894, -1394, -1394, -1394,
    1088,  3288, -1394,  1869,  1839,  1674, -1394,  1669, -1394, -1394,
   -1394,  1675,  8684,   787,  2232,  2314,  2398,  3630,  5064,  8829,
     787,  3288,  3288,  3630,  3288,  3630,  3630, -1394, -1394, -1394,
   10373, 10373,  1633,  4269,  4269, -1394, -1394,  1676,  5064,  1816,
    8851,  8873, -1394,  5064,  8912,  8934, -1394,  1114,  1117,  5064,
   10104,  1678,  1124,  1125, -1394,  1911, -1394, -1394, -1394,  1679,
   -1394,  1145,  1912,  1680,  1150,  1151, -1394, -1394,   214,   345,
     860, 10329, -1394, -1394, -1394, -1394,  8956, -1394,   425, -1394,
   -1394,   731,  1681, -1394,  7760,  1155,  1163,  1184,  1194, -1394,
   -1394, 10351,  5064,  1886,  5607, 10373, 10373,  5064,  5064, -1394,
    1356,  1682,  1683,  5064,  5064,  5064,  5064,  5064,  1684,  1686,
    5064,  5064,  5064,  5064,  1540,  1540,   222, -1394,   222, -1394,
   -1394,   787,  1923, -1394,  1924,  1926,  1262,  1930,  1931,  1932,
    1262,  1933,  1935,  1936,  1262,   615, -1394,  1699,  1240,  1240,
    1240,  1262,  1240,  1240,  1240,  1262,  1240,  1240,  1240,  1262,
   -1394,  1882,  1700,  1794,  4925, -1394, -1394, -1394, -1394,   787,
   -1394,    -1,  3216, -1394,  1900,   129,    18,  1982,   162,  2066,
   -1394,  8978, -1394, -1394,  1893,  1894, -1394, -1394, -1394, -1394,
    3288, -1394, -1394, -1394,  7782, -1394, -1394,  7866, -1394, -1394,
   -1394, -1394,  6072,  5064,  5064,  1943, -1394, -1394,  1706,  5064,
    1857, -1394,   510,  1209, -1394,  1210, -1394, -1394, -1394, -1394,
   -1394, -1394, -1394,  5064, -1394,  5064,  5828,  5828,  1946, -1394,
    1896,  1710, -1394, -1394, -1394, -1394, -1394, -1394,  5064,  8011,
   -1394,  1729,   155,  1715,   119,  1722,  1356,   155,   155,  1725,
     155,  6147, -1394, -1394,  1726,  1727,   155,   155,   222,   222,
   -1394, -1394, -1394,  5064,  5064,  3288, -1394, -1394, -1394,  1110,
   -1394, -1394, -1394,  1110, -1394, -1394, -1394,  1110, -1394, -1394,
     787,  1215,  1219,  1223,  1110,  1226,  1229,  1230,  1110,  1233,
    1234,  1237,  1110, -1394,  1728, -1394, -1394,  8033, -1394,  3508,
   -1394,  3288,  3288, -1394,  1742, -1394, -1394,  3288, -1394, -1394,
   -1394, -1394,  2810,  3558,  3288,  3288, -1394,  1723,  1723, -1394,
    6098, 10373,  1730, -1394, 10373, -1394, -1394, -1394,  1972, -1394,
    1734, 10373, -1394, -1394,  1741, -1394,   787, 10373, -1394,  5064,
    1740,  5064, -1394,   119,  1746,  1747,  5064,  1751,  1754,  5064,
    5064,  1755,  1758,  5064,  5064,  8055,  8095,  1925,  1991,  2004,
    2007,  3288, -1394, -1394, -1394,  1240, -1394, -1394, -1394,  1240,
   -1394, -1394, -1394,  1240, -1394, -1394, -1394, -1394, -1394, -1394,
   -1394,  1770,  9000, -1394, -1394, -1394,  5064,  5064, -1394,  5064,
    1765, -1394, -1394,  5064,  3630, 10373,  1775,   155,  1778,  1779,
     155,  1789,  1797,   155,   155,  1798,  1799,  8117,  8139,  1781,
    1803, -1394, -1394, -1394, -1394,  1962,  1238,  1244,  1260,    62,
      98,  9101,  9228, 10373,  8161,  1970, -1394,  1804, -1394, -1394,
    1807, -1394, -1394,  1808,  1809, -1394, -1394,  1810,  1811, -1394,
   -1394, -1394, -1394, -1394, -1394,  1801,  1815,  1819, -1394, -1394,
   -1394, -1394,  1814,  1817,  1820,  1824, -1394, -1394,  5064,  3630,
    5064, 11168, -1394, -1394, -1394, -1394,  8183, -1394,  8284, -1394,
    3630,  3630, -1394, -1394
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
      12,     0,     0,     0,     0,     0,     0,     0,    12,     0,
      11,     4,    75,    74,    73,    71,    72,    19,    13,     0,
      18,     0,     0,     0,    78,    78,     1,     5,   301,   300,
       0,     0,     0,    14,     0,     0,     0,     0,    77,    79,
      87,   297,    15,     0,   264,   192,   191,     6,     7,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   189,    20,   139,   193,
      17,   721,   724,     0,     0,    97,     0,     0,   307,    16,
       0,     8,   150,   151,   152,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   145,
     154,   146,   143,   140,   141,   181,     0,     0,     0,     0,
     142,   153,   144,   188,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   723,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    82,     0,     0,     0,     0,     0,
       0,    90,     0,   306,   197,   188,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   222,   148,   149,   147,     0,     0,   223,   174,
     175,   172,   176,   173,   177,   169,   170,   171,   156,   178,
     179,   164,   165,   166,     0,   163,   155,   162,   167,   168,
     160,   161,   157,   158,   159,   196,     0,   265,     0,   726,
     722,     0,     0,   108,    99,    98,     0,     0,     0,     0,
      80,    81,     0,     0,     0,     0,     0,    88,    89,     0,
      12,   303,   195,   219,   198,   199,   200,   201,   202,     0,
     203,   205,   206,   207,   208,   209,     0,   211,   212,     0,
       0,     0,   214,   215,   216,   217,   218,     0,     0,   187,
       0,   194,     0,     0,     0,   266,     0,     0,     0,     0,
       0,   719,   685,     0,     0,     0,    84,    83,    86,    85,
       0,     0,     0,     0,     0,   418,     0,   462,     0,     0,
       0,     0,     0,   278,   460,   276,   456,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   180,     0,     0,     0,
     725,     0,   270,     0,     0,     0,     0,     0,   684,     0,
     720,    76,   109,     0,     0,    96,     0,   100,    92,    93,
      95,    94,    91,   422,     9,    10,   423,   420,     0,   424,
       0,   419,     0,   308,     0,     0,   466,     0,   289,   289,
     289,   461,   304,    12,   282,   305,     0,   298,   204,   210,
     220,   221,   213,   182,     0,   224,   268,   269,   267,     0,
       0,     0,   715,   716,   717,     0,     0,   673,     0,   110,
       0,     0,   421,     0,     0,   309,   418,   310,     0,     0,
       0,     0,   458,   408,   412,   406,   411,   407,   410,   414,
     409,   405,   413,   415,   416,   291,   288,   291,   417,   291,
     291,   277,   280,   279,     0,     0,   225,   727,     0,     0,
     271,   718,     0,     0,   729,     0,   110,     0,   110,     0,
       0,     0,     0,   465,     0,   464,     0,     0,   467,   290,
     478,   478,   478,   478,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   380,
      51,     0,     0,     0,     0,     0,   323,   389,     0,     0,
       0,     0,     0,     0,   691,   710,   693,   694,   688,   689,
     690,   692,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,     0,   678,   675,
     676,   680,     0,   686,   111,   101,     0,   106,     0,   106,
       0,   432,   311,     0,     0,   457,   477,     0,     0,     0,
       0,     0,   373,     0,     0,     0,   118,    63,     0,    53,
       0,     0,     0,     0,     0,     0,   379,   489,     0,     0,
       0,     0,     0,   185,   239,     0,   185,     0,     0,   369,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     525,     0,     0,     0,     0,     0,     0,     0,    50,   478,
       0,     0,     0,     0,     0,     0,   451,     0,   240,   246,
     247,   248,   256,     0,   475,   473,     0,   241,   252,   243,
     249,   250,   251,   242,   474,   254,   257,     0,     0,     0,
     253,   255,   259,   262,   263,     0,   258,   260,   261,   245,
     244,     0,     0,     0,   404,   291,     0,   396,   392,   395,
     363,   388,   299,   728,     0,   683,   674,   679,     0,   681,
       0,     0,   687,   104,     0,     0,   102,     0,   476,   445,
     444,   429,   431,   434,     0,   463,     0,   284,   283,   285,
     286,     0,   322,     0,   375,     0,     0,   122,   126,   121,
     125,   120,   124,   123,   127,     0,     0,     0,    62,     0,
       0,     0,   324,     0,    54,    27,     0,   376,   485,   486,
     487,   488,     0,   483,     0,     0,   372,    35,     0,   425,
       0,   233,     0,     0,   184,     0,     0,   332,     0,     0,
     331,   371,     0,     0,     0,     0,     0,   552,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   544,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   530,   529,     0,
     556,   370,   526,   503,     0,   502,     0,     0,     0,     0,
       0,    63,     0,     0,     0,     0,   357,   358,    36,     0,
       0,   427,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    12,   292,     0,
     342,   343,   291,   291,     0,   479,   492,     0,   291,     0,
     479,   496,     0,     0,     0,     0,   402,   401,   400,   403,
     291,     0,     0,     0,     0,   344,   185,     0,     0,     0,
     185,     0,     0,   291,   478,   291,     0,     0,   361,   730,
       0,     0,   714,   688,   689,   690,     0,     0,   107,   105,
     103,   439,   433,     0,     0,   459,     0,     0,     0,     0,
       0,     0,     0,    70,    68,    69,     0,    58,   292,     0,
     296,     0,   364,    55,    52,     0,   484,     0,   381,     0,
      28,     0,     0,     0,   472,     0,     0,     0,     0,     0,
     186,   232,   238,     0,     0,     0,     0,   507,   506,     0,
       0,     0,   501,     0,     0,     0,   564,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   524,   521,   522,
     523,     0,     0,     0,     0,   543,   556,   554,   555,     0,
       0,   528,     0,   539,     0,   347,   345,    49,    48,    47,
       0,     0,     0,   367,     0,     0,     0,    29,   450,   448,
     449,   185,     0,     0,     0,     0,   628,   185,   624,     0,
       0,     0,   578,     0,   632,     0,     0,     0,     0,     0,
       0,     0,     0,   590,     0,   583,     0,     0,     0,     0,
       0,     0,     0,     0,    56,    12,     0,   128,     0,   634,
     633,   608,     0,     0,   627,     0,     0,   478,   478,    31,
       0,     0,   490,   480,     0,    23,   478,    33,     0,   494,
       0,    25,    34,    26,    30,     0,    32,    24,     0,     0,
       0,     0,     0,   325,     0,   329,   478,    63,   478,     0,
     393,     0,   711,   712,   713,     0,   677,   441,     0,     0,
     440,     0,     0,   287,   302,   374,     0,     0,     0,     0,
       0,     0,     0,    66,     0,     0,   341,     0,     0,     0,
     352,     0,   426,   236,     0,   230,     0,   234,     0,     0,
       0,     0,     0,     0,   183,     0,     0,     0,     0,   548,
       0,   550,   553,     0,   558,   139,   557,   139,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   546,     0,
       0,     0,     0,     0,     0,     0,     0,    64,     0,     0,
     351,     0,     0,   655,     0,   378,     0,     0,   366,   430,
     428,     0,     0,   454,     0,   340,   339,     0,     0,     0,
     589,     0,   582,   580,   579,   631,     0,     0,     0,   575,
     588,     0,     0,     0,   587,   585,   584,     0,     0,   577,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   131,   136,   293,   609,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   491,     0,
       0,   493,     0,   495,   497,     0,     0,     0,     0,   326,
       0,   327,   330,     0,    63,     0,     0,     0,   362,     0,
     442,   443,     0,     0,   117,   116,   114,   112,   115,   113,
       0,    59,     0,   294,   295,     0,     0,     0,   383,     0,
     356,    12,     0,     0,   471,   237,   231,   235,     0,   336,
       0,     0,     0,   333,     0,     0,     0,   181,   566,     0,
       0,     0,   563,     0,     0,   567,     0,     0,     0,     0,
       0,   545,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   527,   540,   538,   349,   639,   639,
     639,   669,     0,   639,   639,   639,     0,   636,   653,   637,
     654,     0,   315,     0,     0,     0,   446,     0,   447,   615,
     613,     0,     0,    40,     0,     0,     0,     0,     0,     0,
      40,     0,     0,     0,     0,     0,     0,    57,   610,   130,
     135,   134,    12,     0,     0,   129,   626,     0,     0,     0,
       0,     0,   614,     0,     0,     0,   612,     0,     0,     0,
       0,   272,     0,     0,    22,     0,   138,   635,   328,     0,
     399,     0,     0,     0,     0,     0,   394,   682,     0,     0,
       0,     0,   386,   384,   365,   382,     0,   229,     0,   226,
     228,     0,     0,   470,     0,     0,     0,     0,     0,   505,
     504,     0,     0,     0,     0,   560,   559,     0,     0,   573,
     569,     0,   568,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   541,     0,   542,
      65,    40,     0,   638,     0,     0,   291,     0,     0,     0,
     291,     0,     0,     0,   291,   671,   672,     0,     0,     0,
       0,   291,     0,     0,     0,   291,     0,     0,     0,   291,
     652,     0,     0,     0,     0,   455,   623,   574,    37,    39,
     630,     0,     0,    46,     0,     0,     0,     0,     0,     0,
     605,     0,   576,   630,   600,   598,   591,   622,   607,   606,
       0,   132,   133,   625,     0,   617,   620,     0,   616,   618,
     320,   319,     0,     0,     0,     0,   318,    21,     0,     0,
       0,   314,   479,     0,   499,     0,   321,   316,   317,   438,
     437,   436,   435,     0,    60,     0,     0,     0,     0,   227,
       0,     0,   469,   468,   338,   337,   335,   334,     0,     0,
     565,   561,   567,     0,   570,     0,   571,   567,   567,     0,
     567,   567,   520,   547,     0,     0,   567,   567,     0,     0,
     535,   536,   537,     0,     0,     0,   661,   664,   667,   478,
     659,   662,   665,   478,   660,   663,   666,   478,   670,   668,
      40,     0,     0,     0,   478,     0,     0,     0,   478,     0,
       0,     0,   478,   346,     0,   368,   453,     0,    38,     0,
     595,     0,     0,    43,     0,   592,    45,     0,   596,   593,
     597,   594,     0,     0,     0,     0,   611,     0,     0,   481,
       0,   273,   274,   137,   397,   398,   498,   313,     0,   312,
       0,    67,   387,   385,     0,   353,    40,   549,   551,     0,
       0,     0,   511,   572,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   645,   648,   651,     0,   643,   646,   649,     0,
     644,   647,   650,     0,   377,   452,   581,   629,    44,    42,
      41,     0,     0,   586,   601,   599,     0,     0,   482,     0,
     479,   500,    61,     0,     0,   562,     0,   567,     0,     0,
     567,     0,     0,   567,   567,     0,     0,     0,     0,     0,
       0,   350,   658,   656,   657,     0,     0,     0,     0,     0,
       0,     0,     0,   275,     0,     0,   509,     0,   512,   515,
       0,   517,   519,     0,     0,   514,   518,     0,     0,   531,
     533,   348,   642,   640,   641,     0,     0,     0,   621,   619,
     359,   355,     0,     0,     0,     0,   532,   534,     0,     0,
       0,     0,   510,   516,   508,   513,     0,   603,     0,   360,
       0,     0,   604,   602
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1394, -1394, -1394,  1596,  -266,     5, -1394,  2029,  2032, -1115,
   -1394, -1301,  -578, -1007, -1394, -1394,  -413, -1394,  -244,  -636,
    -779,  1105,  -733,  -481,  2064,  2048, -1394, -1394, -1394,  1895,
   -1394, -1394, -1394,  1890, -1394, -1394, -1394, -1394,  1522,    70,
     929,  -652, -1394,  -563,  -534, -1020, -1394,  -421, -1394,   -32,
   -1394,  -718,   -73,   297, -1394,   686,  1335,  -482, -1394, -1394,
    -224,  -335, -1394, -1394, -1394,  1692,   557,  -436,  -675,   999,
   -1394, -1394, -1394, -1394, -1394, -1394, -1394, -1394, -1394,  -517,
   -1394, -1394, -1394, -1394, -1394, -1394, -1394, -1394, -1394,  1590,
   -1394, -1394,   843, -1394, -1394, -1394,  -483, -1068,  -559,   583,
     722, -1394,  1431,  -455,  -124,  -182, -1394, -1394,  -382,  1121,
   -1394, -1394,  1421,  -860, -1394, -1394,   781, -1394, -1394,  1713,
      88,  1638,  1016,  1207, -1394,  -331,  -449,  -193, -1394, -1394,
    1081,  -659,  1080,  1477,   491, -1394,  1515, -1394,  -583, -1394,
   -1394, -1393,  -582, -1394,  -605,  1193, -1394,  1171,  -479, -1394,
    -793, -1394,  -626, -1394, -1394,   646,  1315,  -991, -1394,   820,
    -385, -1099, -1394, -1394,   688,   879,  1622, -1394, -1394,  1601,
   -1394, -1394,  1604, -1394, -1394,   472,  -524,  1070,  1833, -1394,
   -1394, -1394, -1394, -1394, -1394
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     7,     8,    86,   389,   515,    10,    19,    20,   516,
    1479,  1480,  1483,  1484,   628,   629,   579,   580,   836,   728,
     729,  1146,  1147,   907,    11,    39,    12,    96,   183,   184,
      13,    97,   190,   191,    14,   179,   325,   377,   695,   265,
     475,   576,   577,   725,   726,   837,  1200,  1201,   864,  1093,
     136,   755,  1485,    88,  1398,  1399,   594,   595,   672,   673,
      89,   363,  1372,   341,   342,   343,   455,   490,   839,   910,
     911,    15,    98,   465,    30,   348,   281,   193,   336,   517,
    1153,  1152,  1441,  1261,  1101,  1771,  1071,  1097,  1157,   587,
     518,  1257,  1258,  1537,  1536,   519,   520,   679,   680,  1380,
    1381,   859,   860,   456,   460,   390,   748,   810,   435,   811,
     701,   702,   703,  1081,   704,   813,  1163,  1164,   344,   345,
     346,   397,   924,   925,   675,   566,   567,  1636,  1043,   744,
     846,   847,   851,   852,  1524,  1525,   620,   621,   622,   789,
     623,  1573,   624,   625,   778,   767,   768,   969,   947,  1279,
    1421,  1422,  1030,  1333,  1340,  1609,  1005,  1031,   865,  1318,
    1446,  1319,  1320,  1321,  1311,  1312,   428,   473,   547,   548,
     549,   550,   551,   368,   369,   552,   553,   887,   321,   322,
      93,   175,   317,   420,    16
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      87,   678,   681,  1238,   391,     9,   862,   779,   780,   781,
     437,   840,   144,     9,   790,  1210,  1214,   841,   763,   764,
     868,   491,   980,   492,   493,   597,   414,   196,   692,   632,
     752,   337,   923,   758,  1082,    44,   867,   871,  1317,  1493,
      44,  1204,   568,   569,   570,  1574,    33,    99,   263,  1144,
     135,   845,  1610,   143,   909,    21,   432,  1145,  1353,   753,
     674,  1181,   759,    44,   337,    44,   592,   855,   195,  -404,
     574,  1618,  -119,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   554,   256,  1756,
     562,    44,   554,   592,   554,   391,   592,    28,    22,    29,
     590,   154,  -418,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   195,
    1575,   258,  1000,   994,    47,    48,  1397,  1009,   805,   434,
    1012,   988,   431,   308,  1019,   585,   337,  -380,  1419,   989,
     990,   573,  1400,   856,   692,   583,   692,   886,   582,   734,
     592,  1035,   266,  1092,   391,  1663,  1664,   267,   633,     1,
     801,   974,   383,   391,   966,   992,   994,   592,   592,   307,
     869,   872,  1004,   877,   195,   309,   777,   777,    44,   176,
    1013,  1004,   177,  1099,  1348,  1317,   384,   385,  1109,   749,
     903,  1354,   857,   858,  1355,  1620,   904,   905,  1478,  1393,
     875,   462,    23,  -404,  1611,  1478,   386,  -380,   634,   903,
    -418,   903,  1061,   227,   436,   904,   905,   904,   905,   874,
     330,   903,    24,  1611,     1,  1570,  1571,   904,   905,  1184,
      91,  -380,  -380,   478,   482,   479,   743,   349,    34,    34,
     403,   751,   404,   405,   350,  1025,   387,   351,   352,   353,
    1026,  -380,   338,  1162,   415,   581,   339,   365,   356,  1169,
     357,   358,   359,  1397,   360,   340,   264,   388,  1235,  1671,
    1194,   948,   949,   950,   951,   952,   953,   954,   388,  1400,
     383,   593,   586,   961,   962,   963,   964,   575,   835,   486,
     835,  -380,  -119,   971,   994,   973,  -404,  -119,   913,   168,
     169,   170,   413,   591,   384,   385,  1478,   172,  1487,  1489,
    1471,   993,   635,   173,    92,   555,  1182,  1087,   866,  1091,
     693,   596,   696,   727,   386,  1704,   835,   102,   103,   104,
    1494,  1495,  1024,  1497,  1617,  1172,   433,   886,   581,   388,
     227,   366,   439,   172,  1608,  1086,  1113,  1089,   227,   173,
     228,  1116,   995,   996,   129,   131,   132,   133,   134,  1175,
     140,   142,  1388,  1389,   387,  1060,  1062,  1611,   991,  1064,
     750,  1175,  -461,  1111,  1420,  -461,  1226,   338,  1285,  1115,
    1036,   339,   388,  1290,  -380,   870,  1037,  1038,   340,    25,
     727,   916,  1046,   838,  1233,   995,   996,    17,   975,   838,
     909,   976,   870,   870,  1055,  1067,   814,   396,    44,   815,
     893,  1299,  1301,  1359,   223,   224,   225,  1066,   575,  1068,
    -354,    18,   894,  1100,   430,   906,  1112,  1572,   560,   561,
     388,     1,   563,  1117,   856,  1382,  1529,  -281,   816,  -281,
    -281,   956,   817,   818,   970,  1530,   972,   819,   820,   821,
      26,   822,  1413,   227,   823,  1478,  1023,   388,   798,   786,
     799,   777,    -3,   355,  1414,   500,   824,   825,   826,   827,
    1442,  1613,   441,   828,   383,    31,  1313,  1314,   -12,   151,
     152,   153,   442,   857,   858,   908,   154,   581,     1,  1626,
      32,   800,  1315,   505,   384,   385,  1443,  1390,   384,   385,
     842,   843,   -12,   -12,   -12,   829,   830,   738,   487,   488,
     848,  1478,    35,   318,  1444,  1274,  1275,  1102,   386,  1300,
    1302,    17,   -12,   995,   996,   154,   730,   557,   319,   559,
     373,   739,   740,   831,   678,    36,   745,   832,   787,  1088,
     320,   754,   441,   180,   754,    42,  1373,    37,   788,   181,
    1440,   741,   706,     2,   396,   398,   399,   514,   387,  1230,
     182,   713,   714,  1090,  1667,   718,  1237,  1531,  1216,  1217,
    1040,   400,   999,   908,   838,    38,  1532,  1222,   908,  1010,
    1041,   908,   838,   838,   720,   908,   722,  1696,  1697,   717,
    1027,   742,   838,  1308,  1309,    41,  1297,  1234,  1588,  1236,
    1688,  1689,    17,   724,  1298,   171,  1690,     3,   719,  1310,
     721,   172,    -2,  1694,  1695,   145,   146,   173,   147,   148,
     149,   150,   151,   152,   153,  1154,     4,   723,    94,   154,
    1283,  1284,  1042,  1286,  1287,  1288,  1289,  1049,     1,    95,
    1293,  1294,  1295,  1296,   101,   227,   374,   891,   833,   375,
     834,   388,   376,   835,  1324,  1203,   174,     5,  1048,   733,
    1725,   898,  1447,   172,  1552,  1553,  1308,  1309,  1041,   173,
    1557,  1558,  1559,  1560,  1436,     6,  1438,  1564,  1565,  1566,
    1567,   914,  1310,  1779,   388,   765,   384,   385,  1443,   766,
     178,  1490,   166,   167,   168,   169,   170,  1496,   754,  1498,
    1499,   180,   270,     2,  1225,   100,  1448,   181,   145,   146,
     936,   147,   148,   149,   150,   151,   152,   153,   182,   105,
     312,   313,   154,   185,   186,   155,   156,   157,   158,   159,
    1519,   166,   167,   168,   169,   170,   106,   187,  1451,  1650,
    1041,   107,  1028,  1033,  1654,  1655,  1034,  1657,  1658,   172,
     188,   108,  1540,  1661,  1662,   173,   718,     3,   421,   109,
     422,   838,   384,   385,  1443,   189,  1405,   908,  1406,  1407,
    1408,  1209,  1213,   838,   699,   720,     4,   722,   700,   367,
    1640,   318,  1452,   195,   110,     1,  1170,   227,   838,   172,
     282,   967,   968,     1,   724,   173,   319,   145,   146,   956,
     147,   148,   149,   150,   151,   152,   153,     5,   320,  1568,
    1569,   154,  1180,   111,   754,   172,   157,   227,   754,   500,
     311,   173,  1032,   392,   112,     6,   393,   500,  1458,   717,
    1313,  1314,   113,   164,   165,   166,   167,   168,   169,   170,
     -12,  1080,  1080,   476,  1083,   477,  1315,   505,   719,   114,
     721,   908,   384,   385,  1443,   505,  1455,   401,  1456,  1457,
     402,  1367,  1368,  1098,   -12,   -12,   -12,   723,   145,   146,
     468,   115,  1459,   469,   754,   151,   152,   153,  1114,   116,
    1384,  1385,   154,   421,   -12,   712,  1616,  1119,  1121,  1616,
    1462,  1616,  1124,  1126,  1737,   192,   927,  1740,  1707,   928,
    1743,  1744,   117,  1710,  1450,  1454,  1713,  1714,  1461,  1465,
    1469,   514,  1501,  1502,   384,   385,  1443,   930,   118,   514,
     931,   160,   314,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,  1159,  1463,  1466,   457,   459,   934,   754,
    1206,   935,  1167,  1168,   119,   754,   997,   646,   315,   998,
    1455,   838,  1456,  1541,  1176,  1177,  1178,  1642,  1643,   384,
     385,  1443,   120,  1687,  1027,   882,  1188,   121,  1190,  1191,
    1193,   657,   658,   659,  1202,   930,   122,  1687,  1105,  1467,
     731,   195,   732,  1211,  1215,  1072,  1073,  1074,  1218,  1219,
    1579,   665,  1106,   222,  1583,  1107,  1223,   257,  1587,   678,
     678,   688,   690,  1250,  1256,  1594,  1251,  1228,   930,  1598,
    1195,  1266,   123,  1602,   163,   164,   165,   166,   167,   168,
     169,   170,  1445,  1449,  1453,   124,   125,  1460,  1464,  1468,
    1106,   126,   127,  1267,  1755,  1757,  1303,  1303,   930,  1304,
    1306,  1326,  1253,   128,   259,   195,   946,   946,   946,   946,
     946,   946,   946,   946,  1327,   261,   272,  1328,  1735,   946,
     946,   946,   946,   930,   227,   260,  1331,  1357,  1277,  1375,
    1427,   956,  1376,  1428,  1437,   956,  1282,   838,  1439,  1533,
     262,   421,  1534,   735,   268,   269,   164,   165,   166,   167,
     168,   169,   170,   838,     1,   273,   274,   838,   838,   838,
     838,   838,   838,  1591,  1592,  1593,   275,  1595,  1596,  1597,
    1668,  1599,  1600,  1601,  1669,   756,   279,   757,  1670,  1332,
     756,   280,   760,  1777,   802,  1675,   803,   276,   500,  1679,
     421,  1339,   807,  1683,  1782,  1783,   154,   316,  1316,  1313,
    1314,   -12,   844,   323,   845,  1350,  1351,   849,   853,   850,
     850,   861,   324,   845,   838,  1315,   505,  1360,  1361,   326,
     327,  1364,  1365,   328,  1256,   -12,   -12,   -12,  1370,   329,
     185,   186,   331,   332,   145,   146,  1554,   147,   148,   149,
     150,   151,   152,   153,   187,   -12,   333,   334,   154,   277,
    1080,  1080,   156,   157,   158,   159,   919,   188,   920,  1001,
    1391,    44,   815,   335,   941,   195,   942,  1396,   956,   361,
     957,  1404,   189,   956,   956,   958,   959,   956,   347,   960,
     514,  1125,  1127,   362,  1411,   715,   716,   371,  1415,  1416,
     364,   816,  1137,   372,   678,   817,   818,   986,   838,   987,
     819,   820,   821,  1044,   822,  1045,  1316,   823,   379,   380,
    1002,   717,   718,  1050,   381,  1051,   838,   382,   395,   824,
     825,   826,   827,  1050,   337,  1053,   828,  1044,   394,  1057,
     719,   720,   721,   722,   756,   756,  1063,  1065,  1095,   756,
    1096,  1166,   195,   195,   195,   756,  1491,  1229,   406,   723,
     724,   756,   756,  1231,  1232,   756,   407,  1269,   829,   830,
     423,  1202,  1202,   419,   424,  1316,  1504,  1202,   756,   425,
    1273,  1507,  1653,   421,  1044,  1322,  1374,  1512,  1316,   756,
    1726,  1378,   426,   427,  1727,  1316,   831,   458,  1728,   263,
     832,   838,  1383,   421,   362,  1510,   421,  1500,  1511,    44,
     388,   443,   444,  1515,  1044,  1516,  1517,   429,   434,   445,
     446,   447,   448,   449,   440,   133,   134,   450,   466,   464,
    1549,   451,   452,   467,  1520,   838,  1521,   838,   838,   421,
     421,  1527,  1528,   838,   756,  1561,  1544,   470,   471,   838,
     838,   838,   756,  1316,  1545,   556,   474,   558,   472,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   489,
     481,   453,   454,   756,   483,  1546,   946,   946,   494,   946,
     946,   946,   946,   756,   521,  1547,   946,   946,   946,   946,
     522,   571,  1607,  1003,   598,   572,  1316,   838,  1520,  1638,
    1637,  1639,   195,   565,   421,   195,  1672,   195,   421,   578,
    1673,   833,   421,   834,  1674,   421,   835,  1676,   421,   421,
    1677,  1678,   421,   421,  1680,  1681,   421,   421,  1682,  1752,
     838,  1630,  1631,   421,  1316,  1753,   589,  1634,   921,   586,
      44,    45,    46,   584,   588,    47,    48,    49,   683,   421,
     599,  1754,   627,  1641,   630,   908,   908,   682,   685,   686,
     694,   600,   601,   707,   443,   444,  1647,    50,    51,    52,
     708,   709,   445,   446,   447,   448,   449,   710,   711,   727,
     450,   736,   737,   746,   451,   452,   747,   761,   762,   619,
     769,  1665,  1666,   777,   793,   838,   770,   771,   772,   773,
     774,   775,   776,   602,   782,   783,   838,   838,   489,   784,
     785,   795,  1108,   794,    44,    45,    46,   796,   797,    47,
      48,    49,   806,   808,   453,   454,   809,   812,   458,   863,
     603,   604,   605,   606,   607,   608,   609,   610,   878,  1429,
    1692,    50,    51,    52,   879,  1316,   611,   612,   613,   614,
     888,   889,   615,   616,   617,   618,   895,   890,   896,   899,
     897,   900,   901,   902,   917,   915,   926,  1705,   929,   965,
     933,   955,   983,   937,   938,   443,   444,   939,   940,   982,
     984,  1717,  1718,   445,   446,   447,   448,   449,   977,   978,
     979,   450,   981,   985,  1006,   451,   452,  1007,  1008,  1011,
    1018,  1316,  1020,  1196,  1021,    44,    45,    46,  1022,     1,
      47,    48,    49,  1039,  1731,  1732,    53,  1733,  1047,    54,
      55,  1734,    56,    57,    58,    59,    60,    61,  1052,    62,
      63,   619,    50,    51,    52,   453,   454,  1054,    64,    65,
    1056,  1058,  1059,    66,  1069,  1070,    67,    68,    69,    70,
    -711,  -712,    71,    72,    73,    74,  -713,    75,    76,  1075,
    1076,  1551,  1084,    77,    78,    79,  1094,  1103,    80,    81,
    1104,  1123,  1128,  1138,  1150,    82,  -185,  1129,  1130,  -185,
    1131,   922,  1197,    83,    84,    85,  1776,  1132,  1778,  1133,
      53,  1134,  1198,    54,    55,  1135,    56,    57,    58,    59,
      60,    61,  1136,    62,    63,  1139,  1151,  1156,  1140,  1141,
    1142,  1158,    64,    65,  1173,  1185,  1155,    66,  1165,  1171,
      67,    68,    69,    70,  1179,  1183,    71,    72,    73,    74,
    1189,    75,    76,   845,  1220,   850,  1227,    77,    78,    79,
    1244,  1242,    80,    81,  1243,  1245,  1246,  1247,  1248,    82,
    -185,  1249,  1260,  -185,   922,   922,  1262,    83,    84,    85,
    1263,  1278,  1265,  1268,  1280,  1281,  1270,  1196,  1291,    44,
      45,    46,  1271,  1272,    47,    48,    49,  1292,  1305,  1307,
    1325,    53,  1323,  1358,    54,    55,  1337,    56,    57,    58,
      59,    60,    61,  1338,    62,    63,    50,    51,    52,  1341,
    1345,  1347,  1349,    64,    65,  1352,  1356,  1371,    66,  1363,
    1379,    67,    68,    69,    70,  1386,  1387,    71,    72,    73,
      74,  1392,    75,    76,  1472,   791,  1409,  1410,    77,    78,
      79,  1417,  1434,    80,    81,  1199,   600,   601,  1418,  1423,
      82,  1473,  1424,  1425,  1426,  1430,  1197,  1431,    83,    84,
      85,  1614,  1432,    44,    45,    46,  1198,  1433,    47,    48,
      49,  1435,  1474,  1161,  1518,  1522,  1476,  1503,  1514,  1519,
    1550,  1526,  1556,  1542,  1555,  1562,  1576,  1577,   602,  1578,
      50,    51,    52,  1580,  1581,  1582,  1584,  1563,  1585,  1586,
    1590,  1603,  1604,  1605,  1624,  1625,  1632,  1482,  1633,  1644,
    1645,  1646,  1649,  1615,  1651,   603,   604,   605,   606,   607,
     608,   609,   610,  1652,  1656,  1659,  1660,  1611,  1208,  1684,
    1699,   611,   612,   613,   614,  1700,  1702,   615,   616,   617,
     618,  1703,  1706,  1614,  1721,    44,    45,    46,  1708,  1709,
      47,    48,    49,  1711,  1722,    53,  1712,  1715,    54,    55,
    1716,    56,    57,    58,    59,    60,    61,  1723,    62,    63,
    1724,  1729,    50,    51,    52,  1041,  1736,    64,    65,  1738,
    1739,  1751,    66,  1749,  1761,    67,    68,    69,    70,  1482,
    1741,    71,    72,    73,    74,  1619,    75,    76,  1742,  1745,
    1746,  1768,    77,    78,    79,  1750,  1762,    80,    81,  1763,
    1764,  1765,  1766,  1767,    82,  1772,   619,  1769,  1773,  1770,
      43,  1774,    83,    84,    85,  1775,    90,  1614,   523,    44,
      45,    46,    27,    40,    47,    48,    49,  1149,   271,    53,
     278,   697,    54,    55,  1539,    56,    57,    58,    59,    60,
      61,   932,    62,    63,  1254,   463,    50,    51,    52,   626,
    1395,    64,    65,  1635,  1523,   873,    66,  1160,  1475,    67,
      68,    69,    70,  1482,   461,    71,    72,    73,    74,  1621,
      75,    76,  1264,   892,   564,  1221,    77,    78,    79,  1701,
    1224,    80,    81,  1110,  1122,   854,   792,  1143,    82,  1623,
    1470,  1401,  1017,  1589,   684,  1239,    83,    84,    85,  1402,
     687,    44,    45,    46,   689,   370,    47,    48,    49,     0,
       0,    53,     0,     0,    54,    55,     0,    56,    57,    58,
      59,    60,    61,     0,    62,    63,     0,     0,    50,    51,
      52,     0,     0,    64,    65,     0,     0,     0,    66,     0,
       0,    67,    68,    69,    70,     0,     0,    71,    72,    73,
      74,     0,    75,    76,     0,     0,     0,     0,    77,    78,
      79,     0,     0,    80,    81,     0,     0,     0,     0,     0,
      82,     0,     0,     0,     0,     0,     0,     0,    83,    84,
      85,     0,     0,  1481,     0,    44,    45,    46,     0,     0,
      47,    48,    49,     0,     0,    53,     0,     0,    54,    55,
       0,    56,    57,    58,    59,    60,    61,     0,    62,    63,
       0,     0,    50,    51,    52,     0,     0,    64,    65,     0,
       0,     0,    66,     0,     0,    67,    68,    69,    70,  1482,
       0,    71,    72,    73,    74,     0,    75,    76,     0,     0,
       0,     0,    77,    78,    79,     0,     0,    80,    81,     0,
       0,     0,     0,     0,    82,     0,     0,     0,     0,     0,
       0,     0,    83,    84,    85,  1486,     0,    44,    45,    46,
       0,     0,    47,    48,    49,     0,     0,    53,     0,     0,
      54,    55,     0,    56,    57,    58,    59,    60,    61,     0,
      62,    63,     0,     0,    50,    51,    52,     0,     0,    64,
      65,     0,     0,     0,    66,     0,     0,    67,    68,    69,
      70,  1482,     0,    71,    72,    73,    74,     0,    75,    76,
       0,     0,     0,     0,    77,    78,    79,     0,     0,    80,
      81,     0,     0,     0,     0,     0,    82,     0,     0,     0,
    1403,     0,     0,     0,    83,    84,    85,     0,     0,  1488,
       0,    44,    45,    46,     0,     0,    47,    48,    49,     0,
       0,    53,     0,     0,    54,    55,     0,    56,    57,    58,
      59,    60,    61,     0,    62,    63,     0,     0,    50,    51,
      52,     0,     0,    64,    65,     0,     0,     0,    66,     0,
       0,    67,    68,    69,    70,  1482,     0,    71,    72,    73,
      74,     0,    75,    76,     0,     0,     0,     0,    77,    78,
      79,     0,     0,    80,    81,     0,     0,     0,     0,     0,
      82,     0,     0,     0,     0,     0,     0,     0,    83,    84,
      85,   438,     0,    44,    45,    46,     0,     0,    47,    48,
      49,     0,     0,    53,     0,     0,    54,    55,     0,    56,
      57,    58,    59,    60,    61,     0,    62,    63,     0,     0,
      50,    51,    52,     0,     0,    64,    65,     0,     0,     0,
      66,     0,     0,    67,    68,    69,    70,     0,     0,    71,
      72,    73,    74,     0,    75,    76,     0,     0,     0,     0,
      77,    78,    79,     0,     0,    80,    81,     0,     0,     0,
       0,     0,    82,     0,     0,     0,     0,     0,     0,     0,
      83,    84,    85,  1148,     0,    44,    45,    46,     0,     0,
      47,    48,    49,     0,     0,     0,     0,    53,     0,     0,
      54,    55,     0,    56,    57,    58,    59,    60,    61,     0,
      62,    63,    50,    51,    52,     0,     0,     0,     0,    64,
      65,     0,     0,     0,    66,     0,     0,    67,    68,    69,
      70,     0,     0,    71,    72,    73,    74,     0,    75,    76,
       0,     0,     0,     0,    77,    78,    79,     0,     0,    80,
      81,     0,     0,     0,     0,     0,    82,     0,     0,     0,
       0,     0,     0,     0,    83,    84,    85,  1187,     0,    44,
      45,    46,     0,     0,    47,    48,    49,     0,     0,    53,
       0,     0,    54,    55,     0,    56,    57,    58,    59,    60,
      61,     0,    62,    63,     0,     0,    50,    51,    52,     0,
       0,    64,    65,     0,     0,     0,    66,     0,     0,    67,
      68,    69,    70,     0,     0,    71,    72,    73,    74,     0,
      75,    76,     0,     0,     0,     0,    77,    78,    79,     0,
       0,    80,    81,     0,     0,     0,     0,     0,    82,     0,
       0,     0,     0,     0,     0,     0,    83,    84,    85,  1192,
       0,    44,    45,    46,     0,     0,    47,    48,    49,     0,
       0,    53,     0,     0,    54,    55,     0,    56,    57,    58,
      59,    60,    61,     0,    62,    63,     0,     0,    50,    51,
      52,     0,     0,    64,    65,     0,     0,     0,    66,     0,
       0,    67,    68,    69,    70,     0,     0,    71,    72,    73,
      74,     0,    75,    76,     0,     0,     0,     0,    77,    78,
      79,     0,     0,    80,    81,     0,     0,     0,     0,     0,
      82,     0,     0,     0,     0,     0,     0,     0,    83,    84,
      85,  1691,     0,    44,    45,    46,     0,     0,    47,    48,
      49,     0,     0,     0,     0,    53,     0,     0,    54,    55,
       0,    56,    57,    58,    59,    60,    61,     0,    62,    63,
      50,    51,    52,     0,     0,     0,     0,    64,    65,     0,
       0,     0,    66,     0,     0,    67,    68,    69,    70,     0,
       0,    71,    72,    73,    74,     0,    75,    76,     0,     0,
       0,     0,    77,    78,    79,     0,     0,    80,    81,     0,
       0,     0,     0,     0,    82,     0,     0,     0,     0,     0,
       0,     0,    83,    84,    85,   130,     0,    44,    45,    46,
       0,     0,    47,    48,    49,     0,     0,    53,     0,     0,
      54,    55,     0,    56,    57,    58,    59,    60,    61,     0,
      62,    63,     0,     0,     0,     0,     0,     0,     0,    64,
      65,     0,     0,     0,    66,     0,     0,    67,    68,    69,
      70,     0,     0,    71,    72,    73,    74,     0,    75,    76,
       0,     0,     0,     0,    77,    78,    79,     0,     0,    80,
      81,     0,     0,     0,     0,     0,    82,     0,     0,     0,
       0,     0,     0,     0,    83,    84,    85,   141,     0,    44,
      45,    46,     0,     0,    47,    48,    49,     0,     0,    53,
       0,     0,    54,    55,     0,    56,    57,    58,    59,    60,
      61,     0,    62,    63,     0,     0,     0,     0,     0,     0,
       0,    64,    65,     0,     0,     0,    66,     0,     0,    67,
      68,    69,    70,     0,     0,    71,    72,    73,    74,     0,
      75,    76,     0,     0,     0,     0,    77,    78,    79,     0,
       0,    80,    81,     0,     0,     0,     0,     0,    82,     0,
       0,     0,     0,     0,     0,     0,    83,    84,    85,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    53,     0,     0,    54,    55,     0,    56,
      57,    58,    59,    60,    61,     0,    62,    63,     0,     0,
       0,     0,     0,     0,     0,    64,    65,     0,     0,     0,
      66,     0,     0,    67,    68,    69,    70,     0,     0,    71,
      72,    73,    74,     0,    75,    76,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    82,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    85,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    53,     0,     0,    54,    55,
       0,    56,    57,    58,    59,    60,    61,     0,    62,    63,
    1014,     0,    44,   815,     0,     0,     0,    64,    65,     0,
       0,     0,    66,     0,     0,    67,    68,    69,    70,     0,
       0,    71,    72,    73,    74,     0,    75,    76,     0,     0,
       0,     0,   816,     0,     0,     0,   817,   818,     0,     0,
       0,   819,   820,   821,    82,   822,     0,   814,   823,    44,
     815,     0,     0,     0,    85,     0,     0,     0,     0,     0,
     824,   825,   826,   827,     0,     0,     0,   828,     0,     0,
       0,     0,     0,  1015,     0,     0,     0,     0,     0,   816,
       0,     0,     0,   817,   818,     0,     0,     0,   819,   820,
     821,     0,   822,     0,     0,   823,     0,     0,     0,   829,
     830,     0,     0,     0,     0,     0,     0,   824,   825,   826,
     827,     0,     0,     0,   828,     0,     0,     0,     0,   814,
       0,    44,   815,     0,     0,     0,     0,   831,     0,     0,
       0,   832,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   829,   830,     0,     0,
       0,   816,     0,     0,     0,   817,   818,     0,     0,     0,
     819,   820,   821,     0,   822,     0,   814,   823,    44,   815,
       0,     0,     0,     0,   831,     0,     0,     0,   832,   824,
     825,   826,   827,     0,     0,     0,   828,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   816,     0,
       0,     0,   817,   818,     0,     0,     0,   819,   820,   821,
       0,   822,     0,     0,   823,     0,     0,  1174,   829,   830,
       0,     0,     0,     0,  1016,     0,   824,   825,   826,   827,
       0,     0,     0,   828,     0,     0,     0,     0,   814,     0,
      44,   815,   833,     0,   834,     0,   831,   835,     0,     0,
     832,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   829,   830,     0,     0,     0,
     816,  1612,     0,     0,   817,   818,     0,     0,     0,   819,
     820,   821,     0,   822,     0,     0,   823,  1029,     0,   833,
       0,   834,     0,   831,   835,     0,     0,   832,   824,   825,
     826,   827,     0,     0,     0,   828,     0,     0,     0,     0,
       0,  1186,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,   829,   830,   814,
     154,    44,   815,   155,   156,   157,   158,   159,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1029,
       0,   833,     0,   834,     0,   831,   835,     0,     0,   832,
       0,   816,     0,     0,     0,   817,   818,     0,     0,     0,
     819,   820,   821,     0,   822,     0,     0,   823,     0,   814,
    1686,    44,   815,     0,     0,     0,     0,     0,     0,   824,
     825,   826,   827,     0,     0,     0,   828,     0,   833,     0,
     834,     0,     0,   835,     0,     0,     0,     0,     0,     0,
       0,   816,     0,     0,     0,   817,   818,     0,     0,     0,
     819,   820,   821,     0,   822,     0,     0,   823,   829,   830,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   824,
     825,   826,   827,     0,     0,     0,   828,     0,     0,     0,
       0,   814,  1693,    44,   815,     0,   831,    44,    45,    46,
     832,     0,    47,    48,    49,     0,     0,     0,     0,     0,
     833,     0,   834,     0,     0,   835,     0,     0,   829,   830,
       0,     0,     0,   816,    50,    51,    52,   817,   818,     0,
       0,     0,   819,   820,   821,     0,   822,     0,     0,   823,
       0,     0,     0,     0,     0,     0,   831,     0,     0,     0,
     832,   824,   825,   826,   827,     0,     0,     0,   828,     0,
     715,   716,     0,     0,     0,     0,     0,     0,     0,   160,
     484,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,     0,   717,   718,     0,     0,
     829,   830,     0,     0,     0,     0,   485,     0,     0,     0,
       0,     0,     0,     0,     0,   719,   720,   721,   722,     0,
       0,   833,     0,   834,     0,     0,   835,     0,   831,     0,
       0,     0,   832,     0,   723,   724,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      44,    45,    46,     0,     0,    47,    48,    49,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   833,     0,   834,     0,     0,   835,    50,    51,    52,
       0,     0,     0,    53,     0,     0,    54,    55,     0,    56,
      57,    58,    59,    60,    61,     0,    62,    63,     0,     0,
       0,     0,     0,     0,     0,    64,    65,     0,     0,     0,
      66,     0,     0,    67,    68,    69,    70,     0,     0,    71,
      72,    73,    74,     0,    75,    76,     0,     0,     0,     0,
      77,    78,    79,     0,     0,    80,    81,     0,     0,   717,
     718,     0,    82,   833,     0,   834,     0,     0,   835,     0,
      83,    84,    85,     0,     0,     0,     0,     0,   719,   720,
     721,   722,    44,    45,    46,     0,     0,    47,    48,    49,
       0,     0,     0,     0,     0,     0,     0,   723,   724,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    50,
      51,    52,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   145,   146,     0,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,     0,    53,     0,     0,    54,
      55,     0,    56,    57,    58,    59,    60,    61,     0,    62,
      63,     0,     0,     0,     0,     0,     0,     0,    64,    65,
       0,     0,     0,    66,     0,     0,    67,    68,    69,    70,
    1207,     0,    71,    72,    73,    74,     0,    75,    76,     0,
       0,     0,     0,    77,    78,    79,     0,     0,    80,    81,
       0,     0,     0,     0,     0,    82,     0,     0,     0,     0,
       0,     0,     0,    83,    84,    85,    44,    45,    46,     0,
       0,    47,    48,    49,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    50,    51,    52,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    53,     0,
       0,    54,    55,     0,    56,    57,    58,    59,    60,    61,
       0,    62,    63,     0,     0,     0,     0,     0,     0,     0,
      64,    65,     0,     0,     0,    66,     0,     0,    67,    68,
      69,    70,     0,     0,    71,    72,    73,    74,     0,    75,
      76,     0,     0,     0,     0,    77,    78,    79,     0,     0,
      80,    81,     0,     0,  1212,     0,     0,    82,     0,     0,
       0,     0,   833,     0,  1208,    83,    84,    85,    44,    45,
      46,     0,     0,    47,    48,    49,   160,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,     0,     0,
       0,     0,     0,     0,     0,    50,    51,    52,     0,     0,
       0,   145,   146,   416,   147,   148,   149,   150,   151,   152,
     153,     0,  1255,     0,     0,   154,     0,     0,  1394,     0,
     157,   158,   159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    53,     0,     0,    54,    55,     0,    56,    57,
      58,    59,    60,    61,     0,    62,    63,     0,     0,     0,
       0,     0,     0,     0,    64,    65,     0,     0,     0,    66,
       0,     0,    67,    68,    69,    70,     0,     0,    71,    72,
      73,    74,     0,    75,    76,     0,     0,     0,     0,    77,
      78,    79,     0,     0,    80,    81,     0,     0,     0,     0,
       0,    82,     0,     0,     0,     0,   833,     0,  1208,    83,
      84,    85,    44,    45,    46,     0,     0,    47,    48,    49,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    50,
      51,    52,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    53,     0,     0,    54,    55,     0,
      56,    57,    58,    59,    60,    61,     0,    62,    63,     0,
       0,     0,     0,     0,     0,     0,    64,    65,     0,     0,
       0,    66,     0,     0,    67,    68,    69,    70,     0,  1197,
      71,    72,    73,    74,     0,    75,    76,     0,     0,  1198,
       0,    77,    78,    79,     0,     0,    80,    81,     0,    44,
      45,    46,     0,    82,    47,    48,    49,     0,     0,     0,
       0,    83,    84,    85,     0,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,    50,    51,    52,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    44,
      45,    46,     0,     0,    47,    48,    49,     0,    53,     0,
       0,    54,    55,     0,    56,    57,    58,    59,    60,    61,
       0,    62,    63,     0,     0,     0,    50,    51,    52,     0,
      64,    65,     0,     0,     0,    66,     0,     0,    67,    68,
      69,    70,     0,     0,    71,    72,    73,    74,     0,    75,
      76,     0,     0,     0,     0,    77,    78,    79,     0,     0,
      80,    81,     0,     0,     0,     0,     0,    82,     0,     0,
       0,     0,     0,     0,     0,    83,    84,    85,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    44,    45,    46,     0,     0,    47,    48,
      49,     0,     0,     0,     0,    53,     0,     0,    54,    55,
       0,    56,    57,    58,    59,    60,    61,     0,    62,    63,
      50,    51,    52,     0,     0,     0,     0,    64,    65,     0,
       0,     0,    66,     0,     0,    67,    68,    69,    70,     0,
       0,    71,    72,    73,    74,     0,    75,    76,     0,     0,
       0,     0,    77,    78,    79,     0,     0,    80,    81,     0,
       0,     0,     0,     0,    82,     0,     0,     0,   194,     0,
       0,     0,    83,    84,    85,    53,     0,     0,    54,    55,
       0,    56,    57,    58,    59,    60,    61,     0,    62,    63,
       0,     0,     0,     0,     0,     0,     0,    64,    65,     0,
       0,     0,    66,     0,     0,    67,    68,    69,    70,     0,
       0,    71,    72,    73,    74,     0,    75,    76,     0,     0,
       0,     0,    77,    78,    79,     0,     0,    80,    81,     0,
      44,    45,    46,     0,    82,    47,    48,    49,   255,     0,
       0,     0,    83,    84,    85,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    50,    51,    52,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    53,
       0,     0,    54,    55,     0,    56,    57,    58,    59,    60,
      61,     0,    62,    63,     0,     0,     0,     0,     0,     0,
       0,    64,    65,     0,     0,     0,    66,     0,  1077,    67,
      68,    69,    70,     0,     0,    71,    72,    73,    74,     0,
      75,    76,     0,     0,     0,     0,    77,    78,    79,     0,
       0,  1078,  1079,     0,    44,    45,    46,     0,    82,    47,
      48,    49,   524,   691,     0,     0,    83,    84,    85,   525,
       0,   526,     0,   527,     0,     0,     0,     0,     0,     0,
       0,    50,    51,    52,     0,     0,     0,     0,     0,     0,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    44,    45,    46,     0,
       0,    47,    48,    49,     0,     0,    53,     0,     0,    54,
      55,     0,    56,    57,    58,    59,    60,    61,     0,    62,
      63,     0,     0,    50,    51,    52,     0,     0,    64,    65,
       0,     0,     0,    66,     0,     0,    67,    68,    69,    70,
    1255,     0,    71,    72,    73,    74,     0,    75,    76,     0,
       0,     0,     0,    77,    78,    79,     0,     0,    80,    81,
       0,     0,     0,     0,     0,    82,     0,     0,     0,     0,
       0,  1161,     0,    83,    84,    85,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    44,    45,
      46,     0,     0,    47,    48,    49,     0,     0,     0,     0,
      53,     0,     0,    54,    55,     0,    56,    57,    58,    59,
      60,    61,     0,    62,    63,    50,    51,    52,     0,     0,
       0,     0,    64,    65,     0,     0,     0,    66,     0,     0,
      67,    68,    69,    70,     0,     0,    71,    72,    73,    74,
       0,    75,    76,     0,     0,     0,     0,    77,    78,    79,
       0,     0,    80,    81,     0,     0,     0,     0,     0,    82,
       0,     0,     0,  1205,     0,     0,     0,    83,    84,    85,
       0,     0,    53,     0,     0,    54,    55,     0,    56,    57,
      58,    59,    60,    61,     0,    62,    63,     0,     0,     0,
       0,     0,     0,     0,    64,    65,     0,     0,     0,    66,
       0,     0,    67,    68,    69,    70,     0,     0,    71,    72,
      73,    74,     0,    75,    76,     0,     0,     0,     0,    77,
      78,    79,     0,     0,    80,    81,     0,    44,    45,    46,
       0,    82,    47,    48,    49,     0,     0,     0,     0,    83,
      84,    85,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    50,    51,    52,     0,     0,     0,
       0,     0,     0,     0,    53,     0,     0,    54,    55,     0,
      56,    57,    58,    59,    60,    61,     0,    62,    63,     0,
       0,     0,     0,     0,     0,     0,    64,    65,     0,     0,
       0,    66,     0,     0,    67,    68,    69,    70,     0,     0,
      71,    72,    73,    74,     0,    75,    76,     0,     0,     0,
       0,    77,    78,    79,     0,     0,    80,    81,     0,    44,
      45,    46,     0,    82,    47,    48,    49,  1606,   524,   880,
       0,    83,    84,    85,     0,   525,     0,   526,     0,   527,
       0,     0,     0,     0,     0,     0,    50,    51,    52,     0,
       0,     0,     0,     0,     0,     0,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    44,    45,    46,     0,     0,    47,    48,    49,     0,
       0,     0,     0,    53,     0,     0,    54,    55,     0,    56,
      57,    58,    59,    60,    61,     0,    62,    63,    50,    51,
      52,     0,     0,     0,     0,    64,    65,     0,     0,     0,
      66,     0,     0,    67,    68,    69,    70,     0,     0,    71,
      72,    73,    74,     0,    75,    76,     0,     0,     0,     0,
      77,    78,    79,     0,     0,    80,    81,     0,     0,     0,
       0,     0,    82,     0,     0,     0,     0,     0,     0,     0,
      83,    84,    85,    44,    45,    46,     0,     0,    47,    48,
      49,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    53,     0,     0,    54,    55,
       0,    56,    57,    58,    59,    60,    61,     0,    62,    63,
       0,     0,     0,     0,     0,     0,     0,    64,    65,     0,
       0,     0,    66,     0,     0,    67,    68,    69,    70,     0,
       0,    71,    72,    73,    74,     0,    75,    76,     0,     0,
       0,     0,    77,    78,    79,     0,     0,    80,    81,     0,
      44,    45,    46,     0,  1120,    47,    48,    49,     0,     0,
       0,     0,    83,    84,    85,     0,     0,    53,     0,     0,
      54,    55,     0,    56,    57,    58,    59,    60,    61,     0,
      62,    63,     0,     0,     0,     0,     0,     0,     0,    64,
      65,     0,     0,     0,    66,     0,     0,    67,    68,    69,
      70,     0,     0,    71,    72,    73,    74,     0,    75,    76,
       0,     0,     0,     0,    77,    78,    79,     0,     0,    80,
      81,     0,    44,    45,    46,     0,     0,    47,    48,    49,
       0,     0,     0,     0,    83,    84,    85,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    53,
       0,     0,    54,    55,     0,    56,    57,    58,    59,    60,
      61,     0,    62,    63,     0,     0,     0,     0,     0,   943,
       0,    64,    65,     0,     0,     0,    66,     0,     0,    67,
      68,    69,    70,     0,     0,    71,    72,    73,    74,     0,
      75,    76,     0,     0,     0,     0,   137,   138,   139,   944,
      44,    45,    46,     0,     0,    47,    48,    49,    82,   945,
       0,     0,     0,     0,     0,     0,     0,     0,    85,     0,
       0,     0,     0,     0,     0,     0,    53,     0,     0,    54,
      55,     0,    56,    57,    58,    59,    60,    61,     0,    62,
      63,     0,     0,     0,     0,     0,     0,     0,    64,    65,
       0,     0,     0,    66,     0,  1240,    67,    68,    69,    70,
       0,     0,    71,    72,    73,    74,     0,    75,    76,     0,
      44,    45,    46,     0,     0,    47,    48,    49,     0,     0,
       0,     0,     0,     0,     0,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    85,     0,     0,    53,     0,
       0,    54,    55,     0,    56,    57,    58,    59,    60,    61,
       0,    62,    63,     0,     0,     0,     0,     0,     0,     0,
      64,    65,     0,     0,     0,    66,     0,     0,    67,    68,
      69,    70,     0,     0,    71,    72,    73,    74,     0,    75,
      76,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    85,     0,     0,
       0,     0,     0,     0,     0,     0,    53,     0,     0,    54,
      55,     0,    56,    57,    58,    59,    60,    61,     0,    62,
      63,     0,     0,     0,     0,     0,     0,     0,    64,    65,
       0,     0,     0,    66,     0,  1241,    67,    68,    69,    70,
       0,     0,    71,    72,    73,    74,     0,    75,    76,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    85,    53,     0,     0,    54,
      55,     0,    56,    57,    58,    59,    60,    61,     0,    62,
      63,     0,     0,     0,     0,     0,     0,     0,    64,    65,
       0,     0,     0,    66,     0,     0,    67,    68,    69,    70,
       0,     0,    71,    72,    73,    74,     0,    75,    76,   495,
       0,   -12,   145,   146,   496,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,    82,   154,     0,     0,   155,
     156,   157,   158,   159,     1,    85,     0,     0,     0,     0,
       0,     0,     0,   -12,   -12,   497,   676,   -12,   -12,   -12,
     498,     0,     0,   -12,     0,     0,   499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   500,   501,
       0,     0,     0,   502,     0,     0,   503,     0,   -12,   -12,
     -12,   -12,     0,     0,     0,     0,   504,   -12,     0,   -12,
     -12,   -12,   -12,   -12,   -12,   -12,   505,   -12,     0,     0,
       0,     0,   506,   507,   -12,   -12,   -12,   -12,     0,     0,
     -12,   -12,   -12,   -12,   -12,     0,     0,   508,     0,     0,
       0,   -12,   -12,     0,   509,   -12,   -12,   -12,   -12,   -12,
     -12,   -12,   -12,   -12,   510,     0,     0,   -12,     0,     0,
       0,   -12,   -12,   -12,   -12,     0,     0,     0,     0,     0,
       0,     0,     0,   511,     0,     0,     0,     0,   512,   513,
     514,     0,     0,     0,     0,     0,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,   -12,   -12,   155,   156,   157,   158,   159,     0,     0,
       0,     0,   -12,     0,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   145,   146,     0,
     147,   148,   149,   150,   151,   152,   153,     0,     0,   677,
       0,   154,   417,     0,   155,   156,   157,   158,   159,     0,
       0,     0,     0,   145,   146,     0,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,     0,     0,     0,     0,   145,
     146,     0,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,     0,   154,     0,     0,   155,   156,   157,   158,
     159,     0,     0,     0,     0,   145,   146,     0,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
    1419,     0,   155,   156,   157,   158,   159,     0,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   418,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   145,
     146,     0,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,     0,   154,   698,     0,   155,   156,   157,   158,
     159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     160,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   160,   705,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   160,  1629,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   160,  1698,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   160,   226,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,   145,   146,  1420,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
       0,     0,   160,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,     0,     0,     0,     0,   145,   146,
     283,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
     145,   146,     0,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,     0,   284,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,     0,     0,   285,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,   145,   146,   286,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,     0,     0,   287,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,     0,     0,
       0,   288,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,     0,   290,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,     0,   291,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,   145,   146,   292,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,   145,   146,     0,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,   145,
     146,     0,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,     0,   154,     0,     0,   155,   156,   157,   158,
     159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     160,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,     0,   145,   146,   293,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
     145,   146,     0,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,     0,     0,   160,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,     0,     0,   294,     0,     0,     0,
     160,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,     0,     0,     0,   295,     0,
       0,     0,   160,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,     0,     0,     0,     0,   145,   146,
     297,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,     0,     0,   298,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,     0,     0,   302,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,     0,     0,
       0,   303,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,     0,   304,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,   145,   146,   305,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,   145,   146,     0,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,   145,   146,     0,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,   145,   146,   306,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,   145,
     146,     0,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,     0,   154,     0,     0,   155,   156,   157,   158,
     159,   145,   146,     0,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,   154,     0,     0,   155,   156,
     157,   158,   159,   145,   146,     0,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,   145,   146,     0,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   160,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,     0,     0,
       0,     0,     0,     0,   408,     0,     0,     0,   160,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,     0,     0,   409,     0,     0,     0,
     160,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,     0,   145,   146,   410,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,     0,     0,
     160,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,     0,     0,     0,   411,     0,
       0,     0,   160,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,     0,     0,     0,     0,     0,     0,
     412,     0,     0,     0,   160,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,     0,     0,     0,     0,
       0,     0,   912,     0,     0,     0,   160,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,     0,     0,
       0,     0,     0,     0,   918,     0,     0,     0,   160,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,   145,   146,  1118,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,   145,   146,  1334,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,   145,   146,     0,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,   145,
     146,     0,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,     0,   154,     0,     0,   155,   156,   157,   158,
     159,   145,   146,     0,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,   154,     0,     0,   155,   156,
     157,   158,   159,   145,   146,     0,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,     0,  1335,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,     0,     0,  1336,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,   145,   146,  1342,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   160,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,     0,     0,  1343,     0,     0,     0,
     160,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,     0,     0,     0,  1344,     0,
       0,     0,   160,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,     0,     0,     0,     0,     0,     0,
    1346,     0,     0,     0,   160,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,     0,     0,     0,     0,
       0,     0,  1543,     0,     0,     0,   160,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,     0,     0,
       0,     0,   145,   146,  1627,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,     0,     0,
     160,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,     0,   145,   146,  1628,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
     145,   146,     0,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,     0,  1648,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,     0,  1685,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,   145,   146,  1719,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,     0,     0,  1720,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,     0,     0,  1747,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,     0,     0,
       0,  1748,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,     0,  1760,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,   145,   146,  1780,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,   145,   146,     0,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,   145,   146,     0,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   160,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,   145,   146,  1781,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
     145,   146,     0,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,     0,     0,   160,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,     0,     0,
       0,     0,     0,   378,     0,     0,     0,     0,   160,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,     0,  1085,     0,     0,     0,     0,
     160,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,   145,   146,  1259,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,  1329,     0,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,     0,  1330,     0,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,     0,  1362,     0,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,     0,     0,
    1366,     0,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
     145,   146,  1377,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,     0,     0,   160,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,   145,   146,  1477,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,   145,   146,     0,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,   145,   146,     0,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,   145,
     146,     0,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,     0,   154,     0,     0,   155,   156,   157,   158,
     159,   145,   146,     0,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,   154,     0,     0,   155,   156,
     157,   158,   159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,     0,     0,
    1492,     0,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,  1505,     0,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,   145,   146,  1506,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,     0,     0,   160,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,     0,     0,
       0,     0,     0,  1508,     0,     0,     0,     0,   160,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,     0,  1509,     0,     0,     0,     0,
     160,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,     0,     0,  1538,     0,     0,
       0,     0,   160,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,     0,     0,     0,     0,     0,  1622,
       0,     0,     0,     0,   160,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,     0,     0,     0,   145,
     146,  1730,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,     0,   154,     0,     0,   155,   156,   157,   158,
     159,   145,   146,     0,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,   154,     0,     0,   155,   156,
     157,   158,   159,   145,   146,     0,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
     145,   146,  1758,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   160,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,     0,     0,     0,     0,     0,  1759,
       0,     0,     0,     0,   160,   221,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   524,   881,     0,  1412,
       0,     0,     0,   525,     0,   526,   160,   527,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,     0,     0,
       0,   289,     0,     0,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,   296,     0,
       0,     0,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
     299,     0,     0,     0,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,   495,   300,   -12,     0,     0,   496,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,   301,     0,     1,     0,     0,     0,
       0,     0,     0,     0,     0,   -12,   -12,   497,     0,   -12,
     -12,   -12,   498,     0,     0,   -12,     0,     0,   499,     0,
       0,     0,  -391,     0,     0,     0,     0,     0,     0,     0,
     500,   501,     0,     0,     0,   502,     0,     0,   503,     0,
     -12,   -12,   -12,   -12,     0,     0,     0,     0,   504,   -12,
       0,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   505,   -12,
       0,     0,     0,     0,   506,   507,   -12,   -12,   -12,   -12,
       0,     0,   -12,   -12,   -12,   -12,   -12,     0,     0,   508,
       0,     0,     0,   -12,   -12,     0,   509,   -12,   -12,   -12,
     -12,   -12,   -12,   -12,   -12,   -12,   510,     0,     0,   -12,
       0,     0,     0,   -12,   -12,   -12,   -12,     0,     0,     0,
       0,     0,     0,     0,     0,   511,     0,     0,     0,     0,
     512,   513,   514,     0,     0,     0,     0,   495,     0,   -12,
       0,     0,   496,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   -12,   -12,     0,     0,     0,     0,     0,
       0,     0,     1,     0,   -12,     0,     0,     0,     0,     0,
       0,   -12,   -12,   497,     0,   -12,   -12,   -12,   498,     0,
       0,   -12,     0,     0,   499,     0,     0,     0,  -391,     0,
       0,     0,     0,     0,     0,     0,   500,   501,     0,     0,
       0,   502,     0,     0,   503,   804,   -12,   -12,   -12,   -12,
       0,     0,     0,     0,   504,   -12,     0,   -12,   -12,   -12,
     -12,   -12,   -12,   -12,   505,   -12,     0,     0,     0,     0,
     506,   507,   -12,   -12,   -12,   -12,     0,     0,   -12,   -12,
     -12,   -12,   -12,     0,     0,   508,     0,     0,     0,   -12,
     -12,     0,   509,   -12,   -12,   -12,   -12,   -12,   -12,   -12,
     -12,   -12,   510,     0,     0,   -12,     0,     0,     0,   -12,
     -12,   -12,   -12,     0,     0,     0,     0,     0,     0,     0,
       0,   511,     0,     0,     0,     0,   512,   513,   514,     0,
       0,     0,     0,     0,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,   -12,
     -12,   155,   156,   157,   158,   159,     0,     0,   145,   146,
     -12,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
       0,     0,     0,     0,     0,   145,   146,     0,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,   876,   155,   156,   157,   158,   159,   145,   146,     0,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,   145,
     146,     0,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,     0,   154,     0,     0,   155,   156,   157,   158,
     159,   145,   146,     0,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,   154,     0,     0,   155,   156,
     157,   158,   159,   145,   146,     0,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,   145,   146,     0,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,     0,     0,     0,
       0,     0,     0,   699,     0,   145,   146,   700,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   160,   221,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   160,   310,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     160,   354,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   160,   480,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   160,  1252,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   160,  1276,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   160,  1369,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   160,  1513,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     145,   146,     0,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,   636,     0,     0,
     154,     0,     0,     0,     0,   157,   158,   159,     0,     0,
       0,     0,   524,     0,     0,     0,     0,     0,     0,   525,
     882,   526,     0,   527,     0,     0,     0,     0,     0,   637,
     638,     0,     0,   639,   640,   641,     0,     0,     0,   642,
     883,   884,   885,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,     0,
       0,     0,     0,     0,   643,   644,   645,   646,     0,     0,
       0,     0,     0,   647,     0,   648,   649,   650,   651,   652,
     653,   654,     0,   655,     0,     0,     0,     0,     0,     0,
     656,   657,   658,   659,     0,     0,   660,   661,   662,   663,
     664,     0,     0,     0,     0,     0,     0,   443,   444,     0,
       0,   665,   666,   667,   668,   445,   446,   447,   448,   449,
       0,     0,     0,   450,     0,     0,     0,   451,   452,   669,
     670,     0,     0,   160,  1535,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   160,  1548,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   453,   454,     0,
       0,     0,     0,     0,     0,     0,     0,   160,   671,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   495,
       0,   -12,     0,     0,   496,     0,     0,     0,     0,     0,
       0,     0,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     1,     0,     0,     0,     0,     0,
       0,     0,     0,   -12,   -12,   497,     0,   -12,   -12,   -12,
     498,     0,     0,   -12,     0,     0,   499,     0,     0,     0,
    -390,     0,     0,  -390,     0,     0,     0,     0,   500,   501,
       0,     0,     0,   502,     0,     0,   503,     0,   -12,   -12,
     -12,   -12,     0,     0,     0,     0,   504,   -12,     0,   -12,
     -12,   -12,   -12,   -12,   -12,   -12,   505,   -12,     0,     0,
       0,     0,   506,   507,   -12,   -12,   -12,   -12,     0,     0,
     -12,   -12,   -12,   -12,   -12,     0,     0,   508,     0,     0,
       0,   -12,   -12,     0,   509,   -12,   -12,   -12,   -12,   -12,
     -12,   -12,   -12,   -12,   510,     0,     0,   -12,     0,     0,
       0,   -12,   -12,   -12,   -12,     0,     0,     0,     0,   495,
       0,   -12,     0,   511,   496,     0,     0,  -390,   512,   513,
     514,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     1,     0,     0,     0,     0,     0,
       0,   -12,   -12,   -12,   -12,   497,   631,   -12,   -12,   -12,
     498,     0,   -12,   -12,     0,     0,   499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   500,   501,
       0,     0,     0,   502,     0,     0,   503,     0,   -12,   -12,
     -12,   -12,     0,     0,     0,     0,   504,   -12,     0,   -12,
     -12,   -12,   -12,   -12,   -12,   -12,   505,   -12,     0,     0,
       0,     0,   506,   507,   -12,   -12,   -12,   -12,     0,     0,
     -12,   -12,   -12,   -12,   -12,     0,     0,   508,     0,     0,
       0,   -12,   -12,     0,   509,   -12,   -12,   -12,   -12,   -12,
     -12,   -12,   -12,   -12,   510,     0,     0,   -12,     0,     0,
       0,   -12,   -12,   -12,   -12,     0,     0,     0,     0,   495,
       0,   -12,     0,   511,   496,     0,     0,  -391,   512,   513,
     514,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     1,     0,     0,     0,     0,     0,
       0,   -12,   -12,   -12,   -12,   497,     0,   -12,   -12,   -12,
     498,     0,   -12,   -12,     0,     0,   499,     0,     0,     0,
       0,     0,     0,  -391,     0,     0,     0,     0,   500,   501,
       0,     0,     0,   502,     0,     0,   503,     0,   -12,   -12,
     -12,   -12,     0,     0,     0,     0,   504,   -12,     0,   -12,
     -12,   -12,   -12,   -12,   -12,   -12,   505,   -12,     0,     0,
       0,     0,   506,   507,   -12,   -12,   -12,   -12,     0,     0,
     -12,   -12,   -12,   -12,   -12,     0,     0,   508,     0,     0,
       0,   -12,   -12,     0,   509,   -12,   -12,   -12,   -12,   -12,
     -12,   -12,   -12,   -12,   510,     0,     0,   -12,     0,     0,
       0,   -12,   -12,   -12,   -12,     0,     0,     0,     0,   495,
       0,   -12,     0,   511,   496,     0,     0,     0,   512,   513,
     514,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     1,     0,     0,     0,     0,     0,
       0,   -12,   -12,   -12,   -12,   497,     0,   -12,   -12,   -12,
     498,     0,   -12,   -12,     0,     0,   499,     0,     0,     0,
    -391,     0,     0,     0,     0,     0,     0,     0,   500,   501,
       0,     0,     0,   502,     0,     0,   503,     0,   -12,   -12,
     -12,   -12,     0,     0,     0,     0,   504,   -12,     0,   -12,
     -12,   -12,   -12,   -12,   -12,   -12,   505,   -12,     0,     0,
       0,     0,   506,   507,   -12,   -12,   -12,   -12,     0,     0,
     -12,   -12,   -12,   -12,   -12,     0,     0,   508,     0,     0,
       0,   -12,   -12,     0,   509,   -12,   -12,   -12,   -12,   -12,
     -12,   -12,   -12,   -12,   510,     0,     0,   -12,     0,     0,
       0,   -12,   -12,   -12,   -12,     0,     0,     0,     0,   495,
       0,   -12,     0,   511,   496,     0,     0,     0,   512,   513,
     514,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     1,     0,     0,     0,     0,     0,
       0,   -12,   -12,   -12,   -12,   497,   676,   -12,   -12,   -12,
     498,     0,   -12,   -12,     0,     0,   499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   500,   501,
       0,     0,     0,   502,     0,     0,   503,     0,   -12,   -12,
     -12,   -12,     0,     0,     0,     0,   504,   -12,     0,   -12,
     -12,   -12,   -12,   -12,   -12,   -12,   505,   -12,     0,     0,
       0,     0,   506,   507,   -12,   -12,   -12,   -12,     0,     0,
     -12,   -12,   -12,   -12,   -12,     0,     0,   508,     0,     0,
       0,   -12,   -12,     0,   509,   -12,   -12,   -12,   -12,   -12,
     -12,   -12,   -12,   -12,   510,     0,     0,   -12,     0,     0,
       0,   -12,   -12,   -12,   -12,     0,     0,     0,     0,     0,
       0,     0,     0,   511,     0,     0,     0,     0,   512,   513,
     514,     0,     0,     0,     0,   524,     0,     0,     0,     0,
       0,     0,   525,     0,   526,     0,   527,     0,     0,     0,
       0,   -12,   -12,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   -12,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546
};

static const yytype_int16 yycheck[] =
{
      32,   518,   519,  1071,   335,     0,   665,   612,   613,   614,
     392,   637,    85,     8,   619,  1035,  1036,   643,   601,   601,
     672,   457,   801,   459,   460,   507,     1,   100,   552,   512,
     593,     3,   750,   596,   894,     3,   672,   673,  1153,  1340,
       3,  1032,   491,   492,   493,  1438,    27,    27,     3,    13,
      82,     3,    53,    85,   729,     3,   387,    21,    86,   593,
     515,     1,   596,     3,     3,     3,     3,     1,   100,     3,
       1,    53,     3,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,     3,   171,     1,
     482,     3,     3,     3,     3,   436,     3,    76,   238,    78,
       1,    25,     3,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
    1441,   173,   817,    11,     8,     9,  1261,   822,   631,     3,
     825,     1,   376,   226,   829,     1,     3,     3,     3,     9,
      10,   496,  1261,    97,   688,   500,   690,   691,   499,   582,
       3,    11,   191,   906,   505,  1568,  1569,   196,   513,    26,
     629,     1,    73,   514,   789,     1,    11,     3,     3,   221,
     672,   673,   818,   676,   226,   227,     3,     3,     3,   239,
     826,   827,   242,     1,  1195,  1320,    97,    98,   926,   591,
       3,   239,   146,   147,   242,    53,     9,    10,  1333,   225,
     675,     3,     3,   157,   225,  1340,   117,    73,     1,     3,
       3,     3,   868,   239,    88,     9,    10,     9,    10,   675,
     272,     3,     3,   225,    26,    23,    24,     9,    10,    74,
       3,    97,    98,   170,   436,   172,   587,   289,   239,   239,
     239,   592,   241,   242,   296,   233,   157,   299,   300,   301,
     238,   117,   244,   991,   249,   499,   248,     3,   310,   997,
     312,   313,   314,  1398,   316,   280,   241,   250,  1067,  1590,
    1023,   770,   771,   772,   773,   774,   775,   776,   250,  1398,
      73,   238,   148,   782,   783,   784,   785,   238,   248,   248,
     248,   157,   243,   794,    11,   796,   250,   248,   731,   233,
     234,   235,   354,   505,    97,    98,  1441,   244,  1335,  1336,
    1321,   813,   514,   250,    87,   241,  1011,   900,   238,   902,
     241,   238,   241,   243,   117,  1646,   248,    50,    51,    52,
    1341,  1342,   833,  1344,   225,    52,   388,   881,   582,   250,
     239,    87,   394,   244,  1479,   899,   929,   901,   239,   250,
     249,   934,   240,   241,    77,    78,    79,    80,    81,  1005,
      83,    84,  1242,  1243,   157,   867,   868,   225,   238,   871,
     238,  1017,   239,   927,   239,   242,  1055,   244,  1131,   933,
     240,   248,   250,  1136,   250,   238,   842,   843,   403,     3,
     243,   742,   848,   637,  1066,   240,   241,     3,   238,   643,
    1095,   241,   238,   238,   860,   874,     1,   339,     3,     4,
     238,   238,   238,   238,   137,   138,   139,   873,   238,   875,
     238,    27,   250,   241,   374,   238,   928,   225,   480,   481,
     250,    26,   484,   935,    97,  1234,   242,   239,    33,   241,
     242,   239,    37,    38,   238,   251,   238,    42,    43,    44,
       0,    46,   239,   239,    49,  1590,   238,   250,    75,     1,
      77,     3,     0,   249,   251,    60,    61,    62,    63,    64,
      73,  1482,   239,    68,    73,    26,    71,    72,    73,    18,
      19,    20,   249,   146,   147,   729,    25,   731,    26,  1500,
     240,   108,    87,    88,    97,    98,    99,  1250,    97,    98,
     644,   645,    97,    98,    99,   100,   101,    73,   440,   441,
     654,  1646,   238,    72,   117,  1118,  1118,   919,   117,  1144,
    1145,     3,   117,   240,   241,    25,   578,   477,    87,   479,
      47,    97,    98,   128,  1071,     3,   588,   132,    80,    67,
      99,   593,   239,   197,   596,    27,  1225,   241,    90,   203,
    1303,   117,   249,    91,   486,    71,    72,   152,   157,  1061,
     214,   240,   241,    66,  1575,    93,  1069,   242,  1037,  1038,
     240,    87,   816,   817,   818,   241,   251,  1046,   822,   823,
     250,   825,   826,   827,   112,   829,   114,  1627,  1628,    92,
     834,   157,   836,    71,    72,     3,    13,  1066,     3,  1068,
    1611,  1612,     3,   131,    21,   238,  1617,   145,   111,    87,
     113,   244,     0,  1624,  1625,    11,    12,   250,    14,    15,
      16,    17,    18,    19,    20,   980,   164,   130,   239,    25,
    1129,  1130,   845,  1132,  1133,  1134,  1135,   850,    26,   165,
    1139,  1140,  1141,  1142,     8,   239,   163,   699,   243,   166,
     245,   250,   169,   248,  1157,   249,    99,   195,   240,   240,
    1671,   713,    73,   244,  1417,  1418,    71,    72,   250,   250,
    1423,  1424,  1425,  1426,  1299,   213,  1301,  1430,  1431,  1432,
    1433,   733,    87,  1771,   250,     3,    97,    98,    99,     7,
       5,  1337,   231,   232,   233,   234,   235,  1343,   750,  1345,
    1346,   197,   198,    91,  1055,   238,   117,   203,    11,    12,
     762,    14,    15,    16,    17,    18,    19,    20,   214,   238,
      23,    24,    25,   180,   181,    28,    29,    30,    31,    32,
     240,   231,   232,   233,   234,   235,   238,   194,    73,  1552,
     250,   238,   835,   238,  1557,  1558,   241,  1560,  1561,   244,
     207,   238,  1398,  1566,  1567,   250,    93,   145,   239,   238,
     241,  1005,    97,    98,    99,   222,  1268,  1011,  1270,  1271,
    1272,  1035,  1036,  1017,   200,   112,   164,   114,   204,    70,
    1533,    72,   117,   835,   238,    26,   241,   239,  1032,   244,
     242,   231,   232,    26,   131,   250,    87,    11,    12,   239,
      14,    15,    16,    17,    18,    19,    20,   195,    99,  1434,
    1435,    25,   241,   238,   866,   244,    30,   239,   870,    60,
     242,   250,   837,   239,   238,   213,   242,    60,    73,    92,
      71,    72,   238,   229,   230,   231,   232,   233,   234,   235,
      73,   893,   894,   170,   896,   172,    87,    88,   111,   238,
     113,  1095,    97,    98,    99,    88,   239,   239,   241,   242,
     242,  1216,  1217,   915,    97,    98,    99,   130,    11,    12,
     239,   238,   117,   242,   926,    18,    19,    20,   930,   238,
    1235,  1236,    25,   239,   117,   241,  1484,   939,   940,  1487,
      73,  1489,   944,   945,  1707,   243,   239,  1710,  1651,   242,
    1713,  1714,   238,  1656,  1309,  1310,  1659,  1660,  1313,  1314,
    1315,   152,  1353,  1354,    97,    98,    99,   239,   238,   152,
     242,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   985,   117,    73,   399,   400,   239,   991,
    1033,   242,   994,   995,   238,   997,   238,    73,   251,   241,
     239,  1195,   241,   242,  1006,  1007,  1008,  1536,  1537,    97,
      98,    99,   238,  1609,  1208,   232,  1018,   238,  1020,  1021,
    1022,    97,    98,    99,  1026,   239,   238,  1623,   242,   117,
     239,  1033,   241,  1035,  1036,   252,   253,   254,  1040,  1041,
    1446,   117,   239,   242,  1450,   242,  1048,     3,  1454,  1536,
    1537,   549,   550,   239,  1097,  1461,   242,  1059,   239,  1465,
    1025,   242,   238,  1469,   228,   229,   230,   231,   232,   233,
     234,   235,  1308,  1309,  1310,   238,   238,  1313,  1314,  1315,
     239,   238,   238,   242,  1729,  1730,   239,   239,   239,   242,
     242,   242,  1094,   238,     3,  1097,   769,   770,   771,   772,
     773,   774,   775,   776,   239,   241,   240,   242,  1704,   782,
     783,   784,   785,   239,   239,     3,   242,   242,  1120,   239,
     239,   239,   242,   242,   242,   239,  1128,  1321,   242,   239,
     239,   239,   242,   241,     3,     3,   229,   230,   231,   232,
     233,   234,   235,  1337,    26,   240,   240,  1341,  1342,  1343,
    1344,  1345,  1346,  1458,  1459,  1460,   240,  1462,  1463,  1464,
    1579,  1466,  1467,  1468,  1583,   239,   238,   241,  1587,  1171,
     239,   238,   241,  1769,     1,  1594,     3,   240,    60,  1598,
     239,  1183,   241,  1602,  1780,  1781,    25,   240,  1153,    71,
      72,    73,     1,     5,     3,  1197,  1198,     1,     1,     3,
       3,     1,   244,     3,  1398,    87,    88,  1209,  1210,   241,
     241,  1213,  1214,   241,  1257,    97,    98,    99,  1220,   241,
     180,   181,     3,     3,    11,    12,  1420,    14,    15,    16,
      17,    18,    19,    20,   194,   117,     3,     5,    25,   199,
    1242,  1243,    29,    30,    31,    32,   239,   207,   241,     1,
    1252,     3,     4,    88,   239,  1257,   241,  1259,   239,   239,
     241,  1263,   222,   239,   239,   241,   241,   239,    26,   241,
     152,   944,   945,     3,  1276,    66,    67,   242,  1280,  1281,
       3,    33,   955,     3,  1771,    37,    38,   239,  1482,   241,
      42,    43,    44,   239,    46,   241,  1261,    49,   241,   241,
      52,    92,    93,   239,   241,   241,  1500,   241,     3,    61,
      62,    63,    64,   239,     3,   241,    68,   239,   250,   241,
     111,   112,   113,   114,   239,   239,   241,   241,   239,   239,
     241,   241,  1334,  1335,  1336,   239,  1338,   241,     3,   130,
     131,   239,   239,   241,   241,   239,   241,   241,   100,   101,
     241,  1353,  1354,    72,   241,  1320,  1358,  1359,   239,     3,
     241,  1363,  1556,   239,   239,   241,   241,  1369,  1333,   239,
    1675,   241,     3,   115,  1679,  1340,   128,    99,  1683,     3,
     132,  1575,     1,   239,     3,   241,   239,  1352,   241,     3,
     250,   113,   114,   239,   239,   241,   241,   170,     3,   121,
     122,   123,   124,   125,   238,  1078,  1079,   129,   249,    73,
    1412,   133,   134,     3,   239,  1609,   241,  1611,  1612,   239,
     239,   241,   241,  1617,   239,  1427,   241,     3,   241,  1623,
    1624,  1625,   239,  1398,   241,   476,    56,   478,   240,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   157,
     240,   173,   174,   239,   251,   241,  1129,  1130,     3,  1132,
    1133,  1134,  1135,   239,    72,   241,  1139,  1140,  1141,  1142,
     241,   240,  1474,   225,     1,   241,  1441,  1671,   239,   239,
     241,   241,  1484,   242,   239,  1487,   241,  1489,   239,   238,
     241,   243,   239,   245,   241,   239,   248,   241,   239,   239,
     241,   241,   239,   239,   241,   241,   239,   239,   241,   241,
    1704,  1513,  1514,   239,  1479,   241,     1,  1519,     1,   148,
       3,     4,     5,   238,   238,     8,     9,    10,     3,   239,
      57,   241,   238,  1535,   238,  1729,  1730,    55,   241,    58,
     225,    68,    69,     3,   113,   114,  1548,    30,    31,    32,
       3,     3,   121,   122,   123,   124,   125,     3,     5,   243,
     129,     3,    54,   241,   133,   134,   241,    57,   238,   238,
     238,  1573,  1574,     3,   241,  1769,   238,   238,   238,   238,
     238,   238,   238,   110,   238,   238,  1780,  1781,   157,   238,
     238,   241,     1,   240,     3,     4,     5,   240,     3,     8,
       9,    10,   149,   241,   173,   174,     3,   243,    99,     3,
     137,   138,   139,   140,   141,   142,   143,   144,    51,  1292,
    1622,    30,    31,    32,    56,  1590,   153,   154,   155,   156,
     164,   241,   159,   160,   161,   162,   242,   241,   240,   239,
     241,   239,   239,   239,     3,   240,   238,  1649,   239,   242,
     239,   250,     3,   241,   241,   113,   114,   240,   240,   239,
      52,  1663,  1664,   121,   122,   123,   124,   125,   242,   242,
     242,   129,   242,   240,   238,   133,   134,   238,   238,   238,
     238,  1646,   238,     1,   238,     3,     4,     5,   238,    26,
       8,     9,    10,   241,  1696,  1697,   179,  1699,   241,   182,
     183,  1703,   185,   186,   187,   188,   189,   190,   241,   192,
     193,   238,    30,    31,    32,   173,   174,   241,   201,   202,
     241,   238,    22,   206,     3,    52,   209,   210,   211,   212,
     241,   241,   215,   216,   217,   218,   241,   220,   221,   225,
     241,  1414,    27,   226,   227,   228,   240,   242,   231,   232,
       3,   250,   223,     3,    59,   238,   239,   239,   239,   242,
     239,   244,    80,   246,   247,   248,  1768,   239,  1770,   239,
     179,   239,    90,   182,   183,   239,   185,   186,   187,   188,
     189,   190,   239,   192,   193,   239,   242,     5,   239,   239,
     239,   149,   201,   202,     3,     3,   241,   206,   241,   240,
     209,   210,   211,   212,   241,   240,   215,   216,   217,   218,
     241,   220,   221,     3,   250,     3,     3,   226,   227,   228,
     242,   225,   231,   232,   225,   242,   242,   242,   242,   238,
     239,   242,    54,   242,   244,   244,   238,   246,   247,   248,
     238,    34,   242,   242,   223,   223,   242,     1,   251,     3,
       4,     5,   242,   242,     8,     9,    10,   250,   242,   241,
       3,   179,   239,   238,   182,   183,   242,   185,   186,   187,
     188,   189,   190,   240,   192,   193,    30,    31,    32,   242,
     242,   242,   242,   201,   202,   242,   241,     3,   206,   238,
       3,   209,   210,   211,   212,    52,   241,   215,   216,   217,
     218,   225,   220,   221,     5,    57,   241,   241,   226,   227,
     228,   239,   238,   231,   232,   233,    68,    69,   239,   239,
     238,    52,   239,   239,   239,   239,    80,   239,   246,   247,
     248,     1,   239,     3,     4,     5,    90,   239,     8,     9,
      10,   238,   238,   244,     3,     3,   241,   241,   240,   240,
      34,   241,   239,   242,   242,   241,     3,     3,   110,     3,
      30,    31,    32,     3,     3,     3,     3,   251,     3,     3,
     241,    59,   242,   149,    51,    51,     3,    47,   242,     3,
      54,   241,   223,    53,   239,   137,   138,   139,   140,   141,
     142,   143,   144,   241,   239,   239,   239,   225,   245,   241,
     240,   153,   154,   155,   156,     3,   242,   159,   160,   161,
     162,   240,   242,     1,    59,     3,     4,     5,   242,   242,
       8,     9,    10,   242,     3,   179,   242,   242,   182,   183,
     242,   185,   186,   187,   188,   189,   190,     3,   192,   193,
       3,   241,    30,    31,    32,   250,   241,   201,   202,   241,
     241,    59,   206,   242,    54,   209,   210,   211,   212,    47,
     241,   215,   216,   217,   218,    53,   220,   221,   241,   241,
     241,   240,   226,   227,   228,   242,   242,   231,   232,   242,
     242,   242,   242,   242,   238,   241,   238,   242,   241,   240,
      31,   241,   246,   247,   248,   241,    34,     1,   472,     3,
       4,     5,     8,    25,     8,     9,    10,   972,   183,   179,
     190,   559,   182,   183,  1398,   185,   186,   187,   188,   189,
     190,   756,   192,   193,  1095,   403,    30,    31,    32,   509,
    1257,   201,   202,  1520,  1382,   674,   206,   986,  1327,   209,
     210,   211,   212,    47,   401,   215,   216,   217,   218,    53,
     220,   221,  1106,   702,   486,  1044,   226,   227,   228,  1638,
    1050,   231,   232,   926,   941,   658,   621,   966,   238,  1493,
    1320,  1262,   827,  1455,   522,  1075,   246,   247,   248,     1,
     549,     3,     4,     5,   550,   322,     8,     9,    10,    -1,
      -1,   179,    -1,    -1,   182,   183,    -1,   185,   186,   187,
     188,   189,   190,    -1,   192,   193,    -1,    -1,    30,    31,
      32,    -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,
      -1,   209,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,    -1,   220,   221,    -1,    -1,    -1,    -1,   226,   227,
     228,    -1,    -1,   231,   232,    -1,    -1,    -1,    -1,    -1,
     238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,   247,
     248,    -1,    -1,     1,    -1,     3,     4,     5,    -1,    -1,
       8,     9,    10,    -1,    -1,   179,    -1,    -1,   182,   183,
      -1,   185,   186,   187,   188,   189,   190,    -1,   192,   193,
      -1,    -1,    30,    31,    32,    -1,    -1,   201,   202,    -1,
      -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,    47,
      -1,   215,   216,   217,   218,    -1,   220,   221,    -1,    -1,
      -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,
      -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   246,   247,   248,     1,    -1,     3,     4,     5,
      -1,    -1,     8,     9,    10,    -1,    -1,   179,    -1,    -1,
     182,   183,    -1,   185,   186,   187,   188,   189,   190,    -1,
     192,   193,    -1,    -1,    30,    31,    32,    -1,    -1,   201,
     202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,
     212,    47,    -1,   215,   216,   217,   218,    -1,   220,   221,
      -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,
     232,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,
     242,    -1,    -1,    -1,   246,   247,   248,    -1,    -1,     1,
      -1,     3,     4,     5,    -1,    -1,     8,     9,    10,    -1,
      -1,   179,    -1,    -1,   182,   183,    -1,   185,   186,   187,
     188,   189,   190,    -1,   192,   193,    -1,    -1,    30,    31,
      32,    -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,
      -1,   209,   210,   211,   212,    47,    -1,   215,   216,   217,
     218,    -1,   220,   221,    -1,    -1,    -1,    -1,   226,   227,
     228,    -1,    -1,   231,   232,    -1,    -1,    -1,    -1,    -1,
     238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,   247,
     248,     1,    -1,     3,     4,     5,    -1,    -1,     8,     9,
      10,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,
     186,   187,   188,   189,   190,    -1,   192,   193,    -1,    -1,
      30,    31,    32,    -1,    -1,   201,   202,    -1,    -1,    -1,
     206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,
     226,   227,   228,    -1,    -1,   231,   232,    -1,    -1,    -1,
      -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     246,   247,   248,     1,    -1,     3,     4,     5,    -1,    -1,
       8,     9,    10,    -1,    -1,    -1,    -1,   179,    -1,    -1,
     182,   183,    -1,   185,   186,   187,   188,   189,   190,    -1,
     192,   193,    30,    31,    32,    -1,    -1,    -1,    -1,   201,
     202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,    -1,   220,   221,
      -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,
     232,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   246,   247,   248,     1,    -1,     3,
       4,     5,    -1,    -1,     8,     9,    10,    -1,    -1,   179,
      -1,    -1,   182,   183,    -1,   185,   186,   187,   188,   189,
     190,    -1,   192,   193,    -1,    -1,    30,    31,    32,    -1,
      -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,    -1,
     220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,
      -1,   231,   232,    -1,    -1,    -1,    -1,    -1,   238,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   246,   247,   248,     1,
      -1,     3,     4,     5,    -1,    -1,     8,     9,    10,    -1,
      -1,   179,    -1,    -1,   182,   183,    -1,   185,   186,   187,
     188,   189,   190,    -1,   192,   193,    -1,    -1,    30,    31,
      32,    -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,
      -1,   209,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,    -1,   220,   221,    -1,    -1,    -1,    -1,   226,   227,
     228,    -1,    -1,   231,   232,    -1,    -1,    -1,    -1,    -1,
     238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,   247,
     248,     1,    -1,     3,     4,     5,    -1,    -1,     8,     9,
      10,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,
      -1,   185,   186,   187,   188,   189,   190,    -1,   192,   193,
      30,    31,    32,    -1,    -1,    -1,    -1,   201,   202,    -1,
      -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,    -1,   220,   221,    -1,    -1,
      -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,
      -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   246,   247,   248,     1,    -1,     3,     4,     5,
      -1,    -1,     8,     9,    10,    -1,    -1,   179,    -1,    -1,
     182,   183,    -1,   185,   186,   187,   188,   189,   190,    -1,
     192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,
     202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,    -1,   220,   221,
      -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,
     232,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   246,   247,   248,     1,    -1,     3,
       4,     5,    -1,    -1,     8,     9,    10,    -1,    -1,   179,
      -1,    -1,   182,   183,    -1,   185,   186,   187,   188,   189,
     190,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,    -1,
     220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,
      -1,   231,   232,    -1,    -1,    -1,    -1,    -1,   238,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   246,   247,   248,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,
     186,   187,   188,   189,   190,    -1,   192,   193,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,
     206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,
      -1,   185,   186,   187,   188,   189,   190,    -1,   192,   193,
       1,    -1,     3,     4,    -1,    -1,    -1,   201,   202,    -1,
      -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,    -1,   220,   221,    -1,    -1,
      -1,    -1,    33,    -1,    -1,    -1,    37,    38,    -1,    -1,
      -1,    42,    43,    44,   238,    46,    -1,     1,    49,     3,
       4,    -1,    -1,    -1,   248,    -1,    -1,    -1,    -1,    -1,
      61,    62,    63,    64,    -1,    -1,    -1,    68,    -1,    -1,
      -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,    -1,    33,
      -1,    -1,    -1,    37,    38,    -1,    -1,    -1,    42,    43,
      44,    -1,    46,    -1,    -1,    49,    -1,    -1,    -1,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    61,    62,    63,
      64,    -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,     1,
      -1,     3,     4,    -1,    -1,    -1,    -1,   128,    -1,    -1,
      -1,   132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,    -1,    -1,
      -1,    33,    -1,    -1,    -1,    37,    38,    -1,    -1,    -1,
      42,    43,    44,    -1,    46,    -1,     1,    49,     3,     4,
      -1,    -1,    -1,    -1,   128,    -1,    -1,    -1,   132,    61,
      62,    63,    64,    -1,    -1,    -1,    68,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    -1,
      -1,    -1,    37,    38,    -1,    -1,    -1,    42,    43,    44,
      -1,    46,    -1,    -1,    49,    -1,    -1,    52,   100,   101,
      -1,    -1,    -1,    -1,   225,    -1,    61,    62,    63,    64,
      -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,     1,    -1,
       3,     4,   243,    -1,   245,    -1,   128,   248,    -1,    -1,
     132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,   101,    -1,    -1,    -1,
      33,   225,    -1,    -1,    37,    38,    -1,    -1,    -1,    42,
      43,    44,    -1,    46,    -1,    -1,    49,   241,    -1,   243,
      -1,   245,    -1,   128,   248,    -1,    -1,   132,    61,    62,
      63,    64,    -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,
      -1,    74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,   100,   101,     1,
      25,     3,     4,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,
      -1,   243,    -1,   245,    -1,   128,   248,    -1,    -1,   132,
      -1,    33,    -1,    -1,    -1,    37,    38,    -1,    -1,    -1,
      42,    43,    44,    -1,    46,    -1,    -1,    49,    -1,     1,
      52,     3,     4,    -1,    -1,    -1,    -1,    -1,    -1,    61,
      62,    63,    64,    -1,    -1,    -1,    68,    -1,   243,    -1,
     245,    -1,    -1,   248,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    -1,    -1,    -1,    37,    38,    -1,    -1,    -1,
      42,    43,    44,    -1,    46,    -1,    -1,    49,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,
      62,    63,    64,    -1,    -1,    -1,    68,    -1,    -1,    -1,
      -1,     1,    74,     3,     4,    -1,   128,     3,     4,     5,
     132,    -1,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
     243,    -1,   245,    -1,    -1,   248,    -1,    -1,   100,   101,
      -1,    -1,    -1,    33,    30,    31,    32,    37,    38,    -1,
      -1,    -1,    42,    43,    44,    -1,    46,    -1,    -1,    49,
      -1,    -1,    -1,    -1,    -1,    -1,   128,    -1,    -1,    -1,
     132,    61,    62,    63,    64,    -1,    -1,    -1,    68,    -1,
      66,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    92,    93,    -1,    -1,
     100,   101,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,    -1,
      -1,   243,    -1,   245,    -1,    -1,   248,    -1,   128,    -1,
      -1,    -1,   132,    -1,   130,   131,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,    -1,    -1,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   243,    -1,   245,    -1,    -1,   248,    30,    31,    32,
      -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,
     186,   187,   188,   189,   190,    -1,   192,   193,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,
     206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,
     226,   227,   228,    -1,    -1,   231,   232,    -1,    -1,    92,
      93,    -1,   238,   243,    -1,   245,    -1,    -1,   248,    -1,
     246,   247,   248,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,     3,     4,     5,    -1,    -1,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   130,   131,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,   179,    -1,    -1,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,
     101,    -1,   215,   216,   217,   218,    -1,   220,   221,    -1,
      -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,
      -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   246,   247,   248,     3,     4,     5,    -1,
      -1,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,
      -1,   182,   183,    -1,   185,   186,   187,   188,   189,   190,
      -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,
     211,   212,    -1,    -1,   215,   216,   217,   218,    -1,   220,
     221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,
     231,   232,    -1,    -1,   101,    -1,    -1,   238,    -1,    -1,
      -1,    -1,   243,    -1,   245,   246,   247,   248,     3,     4,
       5,    -1,    -1,     8,     9,    10,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,    -1,    -1,
      -1,    11,    12,   251,    14,    15,    16,    17,    18,    19,
      20,    -1,    47,    -1,    -1,    25,    -1,    -1,    53,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,   186,
     187,   188,   189,   190,    -1,   192,   193,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,   206,
      -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,   216,
     217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,   226,
     227,   228,    -1,    -1,   231,   232,    -1,    -1,    -1,    -1,
      -1,   238,    -1,    -1,    -1,    -1,   243,    -1,   245,   246,
     247,   248,     3,     4,     5,    -1,    -1,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,
     185,   186,   187,   188,   189,   190,    -1,   192,   193,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,
      -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,    80,
     215,   216,   217,   218,    -1,   220,   221,    -1,    -1,    90,
      -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,     3,
       4,     5,    -1,   238,     8,     9,    10,    -1,    -1,    -1,
      -1,   246,   247,   248,    -1,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,    -1,    -1,     8,     9,    10,    -1,   179,    -1,
      -1,   182,   183,    -1,   185,   186,   187,   188,   189,   190,
      -1,   192,   193,    -1,    -1,    -1,    30,    31,    32,    -1,
     201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,
     211,   212,    -1,    -1,   215,   216,   217,   218,    -1,   220,
     221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,
     231,   232,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   246,   247,   248,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,    -1,    -1,     8,     9,
      10,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,
      -1,   185,   186,   187,   188,   189,   190,    -1,   192,   193,
      30,    31,    32,    -1,    -1,    -1,    -1,   201,   202,    -1,
      -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,    -1,   220,   221,    -1,    -1,
      -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,
      -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,   242,    -1,
      -1,    -1,   246,   247,   248,   179,    -1,    -1,   182,   183,
      -1,   185,   186,   187,   188,   189,   190,    -1,   192,   193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,
      -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,    -1,   220,   221,    -1,    -1,
      -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,
       3,     4,     5,    -1,   238,     8,     9,    10,   242,    -1,
      -1,    -1,   246,   247,   248,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,
      -1,    -1,   182,   183,    -1,   185,   186,   187,   188,   189,
     190,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   201,   202,    -1,    -1,    -1,   206,    -1,   208,   209,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,    -1,
     220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,
      -1,   231,   232,    -1,     3,     4,     5,    -1,   238,     8,
       9,    10,   224,   225,    -1,    -1,   246,   247,   248,   231,
      -1,   233,    -1,   235,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,    -1,
      -1,     8,     9,    10,    -1,    -1,   179,    -1,    -1,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    30,    31,    32,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,
      47,    -1,   215,   216,   217,   218,    -1,   220,   221,    -1,
      -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,
      -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,
      -1,   244,    -1,   246,   247,   248,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,    -1,    -1,     8,     9,    10,    -1,    -1,    -1,    -1,
     179,    -1,    -1,   182,   183,    -1,   185,   186,   187,   188,
     189,   190,    -1,   192,   193,    30,    31,    32,    -1,    -1,
      -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,
     209,   210,   211,   212,    -1,    -1,   215,   216,   217,   218,
      -1,   220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,
      -1,    -1,   231,   232,    -1,    -1,    -1,    -1,    -1,   238,
      -1,    -1,    -1,   242,    -1,    -1,    -1,   246,   247,   248,
      -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,   186,
     187,   188,   189,   190,    -1,   192,   193,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,   206,
      -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,   216,
     217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,   226,
     227,   228,    -1,    -1,   231,   232,    -1,     3,     4,     5,
      -1,   238,     8,     9,    10,    -1,    -1,    -1,    -1,   246,
     247,   248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,
     185,   186,   187,   188,   189,   190,    -1,   192,   193,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,
      -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,
     215,   216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,
      -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,     3,
       4,     5,    -1,   238,     8,     9,    10,   242,   224,   225,
      -1,   246,   247,   248,    -1,   231,    -1,   233,    -1,   235,
      -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,    -1,    -1,     8,     9,    10,    -1,
      -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,
     186,   187,   188,   189,   190,    -1,   192,   193,    30,    31,
      32,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,
     206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,
     226,   227,   228,    -1,    -1,   231,   232,    -1,    -1,    -1,
      -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     246,   247,   248,     3,     4,     5,    -1,    -1,     8,     9,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,
      -1,   185,   186,   187,   188,   189,   190,    -1,   192,   193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,
      -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,    -1,   220,   221,    -1,    -1,
      -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,
       3,     4,     5,    -1,   238,     8,     9,    10,    -1,    -1,
      -1,    -1,   246,   247,   248,    -1,    -1,   179,    -1,    -1,
     182,   183,    -1,   185,   186,   187,   188,   189,   190,    -1,
     192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,
     202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,    -1,   220,   221,
      -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,
     232,    -1,     3,     4,     5,    -1,    -1,     8,     9,    10,
      -1,    -1,    -1,    -1,   246,   247,   248,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,
      -1,    -1,   182,   183,    -1,   185,   186,   187,   188,   189,
     190,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    50,
      -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,    -1,
     220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,    80,
       3,     4,     5,    -1,    -1,     8,     9,    10,   238,    90,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   248,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,   208,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,    -1,   220,   221,    -1,
       3,     4,     5,    -1,    -1,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   248,    -1,    -1,   179,    -1,
      -1,   182,   183,    -1,   185,   186,   187,   188,   189,   190,
      -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,
     211,   212,    -1,    -1,   215,   216,   217,   218,    -1,   220,
     221,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   248,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,   208,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,    -1,   220,   221,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   248,   179,    -1,    -1,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,    -1,   220,   221,     1,
      -1,     3,    11,    12,     6,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,   238,    25,    -1,    -1,    28,
      29,    30,    31,    32,    26,   248,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    35,    36,    37,    38,    39,    40,    41,
      42,    -1,    -1,    45,    -1,    -1,    48,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,
      -1,    -1,    -1,    65,    -1,    -1,    68,    -1,    70,    71,
      72,    73,    -1,    -1,    -1,    -1,    78,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,    -1,    -1,
     102,   103,   104,   105,   106,    -1,    -1,   109,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,    -1,    -1,   129,    -1,    -1,
      -1,   133,   134,   135,   136,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   145,    -1,    -1,    -1,    -1,   150,   151,
     152,    -1,    -1,    -1,    -1,    -1,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,   173,   174,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,   184,    -1,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,   241,
      -1,    25,   251,    -1,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
       3,    -1,    28,    29,    30,    31,    32,    -1,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,   251,    -1,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   224,   251,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   224,   251,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,   251,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   224,   248,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    11,    12,   239,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    11,    12,
     242,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    11,    12,   242,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    11,    12,   242,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    11,    12,   242,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    11,    12,
     242,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    11,    12,   242,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    11,    12,   242,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    11,    12,   242,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,
     242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    11,    12,   242,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    11,    12,   242,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    11,    12,   242,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,
     242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    11,    12,   242,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    11,    12,   242,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    11,    12,   242,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    11,    12,   242,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    11,    12,   242,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    11,    12,   241,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,   241,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
     241,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      11,    12,   241,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    11,    12,   241,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
     241,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,   241,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    11,    12,   241,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,   241,
      -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    11,
      12,   241,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      11,    12,   241,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,   241,
      -1,    -1,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   224,   225,    -1,   239,
      -1,    -1,    -1,   231,    -1,   233,   224,   235,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,   239,    -1,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,   239,    -1,
      -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
     239,    -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,     1,   239,     3,    -1,    -1,     6,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,   239,    -1,    26,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    35,    36,    37,    -1,    39,
      40,    41,    42,    -1,    -1,    45,    -1,    -1,    48,    -1,
      -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    61,    -1,    -1,    -1,    65,    -1,    -1,    68,    -1,
      70,    71,    72,    73,    -1,    -1,    -1,    -1,    78,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
      -1,    -1,   102,   103,   104,   105,   106,    -1,    -1,   109,
      -1,    -1,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,    -1,    -1,   129,
      -1,    -1,    -1,   133,   134,   135,   136,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   145,    -1,    -1,    -1,    -1,
     150,   151,   152,    -1,    -1,    -1,    -1,     1,    -1,     3,
      -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   173,   174,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    26,    -1,   184,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    36,    37,    -1,    39,    40,    41,    42,    -1,
      -1,    45,    -1,    -1,    48,    -1,    -1,    -1,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,
      -1,    65,    -1,    -1,    68,   225,    70,    71,    72,    73,
      -1,    -1,    -1,    -1,    78,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,    -1,    -1,   102,   103,
     104,   105,   106,    -1,    -1,   109,    -1,    -1,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,    -1,    -1,   129,    -1,    -1,    -1,   133,
     134,   135,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   145,    -1,    -1,    -1,    -1,   150,   151,   152,    -1,
      -1,    -1,    -1,    -1,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,   173,
     174,    28,    29,    30,    31,    32,    -1,    -1,    11,    12,
     184,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,   225,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,   200,    -1,    11,    12,   204,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,     3,    -1,    -1,
      25,    -1,    -1,    -1,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,   224,    -1,    -1,    -1,    -1,    -1,    -1,   231,
     232,   233,    -1,   235,    -1,    -1,    -1,    -1,    -1,    35,
      36,    -1,    -1,    39,    40,    41,    -1,    -1,    -1,    45,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
      -1,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    -1,
      -1,    -1,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      96,    97,    98,    99,    -1,    -1,   102,   103,   104,   105,
     106,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,   122,   123,   124,   125,
      -1,    -1,    -1,   129,    -1,    -1,    -1,   133,   134,   135,
     136,    -1,    -1,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   173,   174,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,   184,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,     1,
      -1,     3,    -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    26,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    35,    36,    37,    -1,    39,    40,    41,
      42,    -1,    -1,    45,    -1,    -1,    48,    -1,    -1,    -1,
      52,    -1,    -1,    55,    -1,    -1,    -1,    -1,    60,    61,
      -1,    -1,    -1,    65,    -1,    -1,    68,    -1,    70,    71,
      72,    73,    -1,    -1,    -1,    -1,    78,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,    -1,    -1,
     102,   103,   104,   105,   106,    -1,    -1,   109,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,    -1,    -1,   129,    -1,    -1,
      -1,   133,   134,   135,   136,    -1,    -1,    -1,    -1,     1,
      -1,     3,    -1,   145,     6,    -1,    -1,   149,   150,   151,
     152,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    26,    -1,    -1,    -1,    -1,    -1,
      -1,   173,   174,    35,    36,    37,    38,    39,    40,    41,
      42,    -1,   184,    45,    -1,    -1,    48,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,
      -1,    -1,    -1,    65,    -1,    -1,    68,    -1,    70,    71,
      72,    73,    -1,    -1,    -1,    -1,    78,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,    -1,    -1,
     102,   103,   104,   105,   106,    -1,    -1,   109,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,    -1,    -1,   129,    -1,    -1,
      -1,   133,   134,   135,   136,    -1,    -1,    -1,    -1,     1,
      -1,     3,    -1,   145,     6,    -1,    -1,   149,   150,   151,
     152,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    26,    -1,    -1,    -1,    -1,    -1,
      -1,   173,   174,    35,    36,    37,    -1,    39,    40,    41,
      42,    -1,   184,    45,    -1,    -1,    48,    -1,    -1,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    60,    61,
      -1,    -1,    -1,    65,    -1,    -1,    68,    -1,    70,    71,
      72,    73,    -1,    -1,    -1,    -1,    78,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,    -1,    -1,
     102,   103,   104,   105,   106,    -1,    -1,   109,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,    -1,    -1,   129,    -1,    -1,
      -1,   133,   134,   135,   136,    -1,    -1,    -1,    -1,     1,
      -1,     3,    -1,   145,     6,    -1,    -1,    -1,   150,   151,
     152,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    26,    -1,    -1,    -1,    -1,    -1,
      -1,   173,   174,    35,    36,    37,    -1,    39,    40,    41,
      42,    -1,   184,    45,    -1,    -1,    48,    -1,    -1,    -1,
      52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,
      -1,    -1,    -1,    65,    -1,    -1,    68,    -1,    70,    71,
      72,    73,    -1,    -1,    -1,    -1,    78,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,    -1,    -1,
     102,   103,   104,   105,   106,    -1,    -1,   109,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,    -1,    -1,   129,    -1,    -1,
      -1,   133,   134,   135,   136,    -1,    -1,    -1,    -1,     1,
      -1,     3,    -1,   145,     6,    -1,    -1,    -1,   150,   151,
     152,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    26,    -1,    -1,    -1,    -1,    -1,
      -1,   173,   174,    35,    36,    37,    38,    39,    40,    41,
      42,    -1,   184,    45,    -1,    -1,    48,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,
      -1,    -1,    -1,    65,    -1,    -1,    68,    -1,    70,    71,
      72,    73,    -1,    -1,    -1,    -1,    78,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,    -1,    -1,
     102,   103,   104,   105,   106,    -1,    -1,   109,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,    -1,    -1,   129,    -1,    -1,
      -1,   133,   134,   135,   136,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   145,    -1,    -1,    -1,    -1,   150,   151,
     152,    -1,    -1,    -1,    -1,   224,    -1,    -1,    -1,    -1,
      -1,    -1,   231,    -1,   233,    -1,   235,    -1,    -1,    -1,
      -1,   173,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   184,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    26,    91,   145,   164,   195,   213,   272,   273,   276,
     277,   295,   297,   301,   305,   342,   455,     3,    27,   278,
     279,     3,   238,     3,     3,     3,     0,   295,    76,    78,
     345,    26,   240,    27,   239,   238,     3,   241,   241,   296,
     296,     3,    27,   278,     3,     4,     5,     8,     9,    10,
      30,    31,    32,   179,   182,   183,   185,   186,   187,   188,
     189,   190,   192,   193,   201,   202,   206,   209,   210,   211,
     212,   215,   216,   217,   218,   220,   221,   226,   227,   228,
     231,   232,   238,   246,   247,   248,   274,   320,   324,   331,
     279,     3,    87,   451,   239,   165,   298,   302,   343,    27,
     238,     8,   324,   324,   324,   238,   238,   238,   238,   238,
     238,   238,   238,   238,   238,   238,   238,   238,   238,   238,
     238,   238,   238,   238,   238,   238,   238,   238,   238,   324,
       1,   324,   324,   324,   324,   320,   321,   226,   227,   228,
     324,     1,   324,   320,   323,    11,    12,    14,    15,    16,
      17,    18,    19,    20,    25,    28,    29,    30,    31,    32,
     224,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   238,   244,   250,    99,   452,   239,   242,     5,   306,
     197,   203,   214,   299,   300,   180,   181,   194,   207,   222,
     303,   304,   243,   348,   242,   320,   323,   320,   320,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   225,   242,   324,   324,   324,   248,   239,   249,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,   320,   320,   242,   323,     3,   320,     3,
       3,   241,   239,     3,   241,   310,   191,   196,     3,     3,
     198,   300,   240,   240,   240,   240,   240,   199,   304,   238,
     238,   347,   242,   242,   242,   242,   242,   242,   242,   239,
     242,   242,   242,   242,   242,   242,   239,   242,   242,   239,
     239,   239,   242,   242,   242,   242,   242,   320,   323,   320,
     225,   242,    23,    24,   225,   251,   240,   453,    72,    87,
      99,   449,   450,     5,   244,   307,   241,   241,   241,   241,
     320,     3,     3,     3,     5,    88,   349,     3,   244,   248,
     276,   334,   335,   336,   389,   390,   391,    26,   346,   320,
     320,   320,   320,   320,   225,   249,   320,   320,   320,   320,
     320,   239,     3,   332,     3,     3,    87,    70,   444,   445,
     449,   242,     3,    47,   163,   166,   169,   308,   241,   241,
     241,   241,   241,    73,    97,    98,   117,   157,   250,   275,
     376,   396,   239,   242,   250,     3,   391,   392,    71,    72,
      87,   239,   242,   239,   241,   242,     3,   241,   242,   242,
     242,   242,   242,   320,     1,   249,   251,   251,   251,    72,
     454,   239,   241,   241,   241,     3,     3,   115,   437,   170,
     310,   331,   396,   320,     3,   379,    88,   379,     1,   320,
     238,   239,   249,   113,   114,   121,   122,   123,   124,   125,
     129,   133,   134,   173,   174,   337,   374,   337,    99,   337,
     375,   390,     3,   336,    73,   344,   249,     3,   239,   242,
       3,   241,   240,   438,    56,   311,   170,   172,   170,   172,
     225,   240,   376,   251,   225,   251,   248,   391,   391,   157,
     338,   338,   338,   338,     3,     1,     6,    37,    42,    48,
      60,    61,    65,    68,    78,    88,    94,    95,   109,   116,
     126,   145,   150,   151,   152,   276,   280,   350,   361,   366,
     367,    72,   241,   274,   224,   231,   233,   235,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   439,   440,   441,
     442,   443,   446,   447,     3,   241,   311,   310,   311,   310,
     320,   320,   379,   320,   392,   242,   396,   397,   397,   397,
     397,   240,   241,   332,     1,   238,   312,   313,   238,   287,
     288,   331,   396,   332,   238,     1,   148,   360,   238,     1,
       1,   376,     3,   238,   327,   328,   238,   328,     1,    57,
      68,    69,   110,   137,   138,   139,   140,   141,   142,   143,
     144,   153,   154,   155,   156,   159,   160,   161,   162,   238,
     407,   408,   409,   411,   413,   414,   360,   238,   285,   286,
     238,    38,   367,   332,     1,   376,     3,    35,    36,    39,
      40,    41,    45,    70,    71,    72,    73,    79,    81,    82,
      83,    84,    85,    86,    87,    89,    96,    97,    98,    99,
     102,   103,   104,   105,   106,   117,   118,   119,   120,   135,
     136,   184,   329,   330,   374,   395,    38,   241,   350,   368,
     369,   350,    55,     3,   437,   241,    58,   440,   446,   443,
     446,   225,   447,   241,   225,   309,   241,   309,   251,   200,
     204,   381,   382,   383,   385,   251,   249,     3,     3,     3,
       3,     5,   241,   240,   241,    66,    67,    92,    93,   111,
     112,   113,   114,   130,   131,   314,   315,   243,   290,   291,
     320,   239,   241,   240,   287,   241,     3,    54,    73,    97,
      98,   117,   157,   396,   400,   320,   241,   241,   377,   379,
     238,   396,   314,   315,   320,   322,   239,   241,   314,   315,
     241,    57,   238,   409,   413,     3,     7,   416,   417,   238,
     238,   238,   238,   238,   238,   238,   238,     3,   415,   415,
     415,   415,   238,   238,   238,   238,     1,    80,    90,   410,
     415,    57,   407,   241,   240,   241,   240,     3,    75,    77,
     108,   397,     1,     3,   225,   367,   149,   241,   241,     3,
     378,   380,   243,   386,     1,     4,    33,    37,    38,    42,
      43,    44,    46,    49,    61,    62,    63,    64,    68,   100,
     101,   128,   132,   243,   245,   248,   289,   316,   331,   339,
     423,   423,   375,   375,     1,     3,   401,   402,   375,     1,
       3,   403,   404,     1,   404,     1,    97,   146,   147,   372,
     373,     1,   402,     3,   319,   429,   238,   290,   312,   328,
     238,   290,   328,   373,   338,   374,   225,   367,    51,    56,
     225,   225,   232,   252,   253,   254,   447,   448,   164,   241,
     241,   320,   383,   238,   250,   242,   240,   241,   320,   239,
     239,   239,   239,     3,     9,    10,   238,   294,   331,   339,
     340,   341,   242,   287,   320,   240,   396,     3,   242,   239,
     241,     1,   244,   322,   393,   394,   238,   239,   242,   239,
     239,   242,   327,   239,   239,   242,   320,   241,   241,   240,
     240,   239,   241,    50,    80,    90,   324,   419,   419,   419,
     419,   419,   419,   419,   419,   250,   239,   241,   241,   241,
     241,   419,   419,   419,   419,   242,   415,   231,   232,   418,
     238,   294,   238,   294,     1,   238,   241,   242,   242,   242,
     291,   242,   239,     3,    52,   240,   239,   241,     1,     9,
      10,   238,     1,   328,    11,   240,   241,   238,   241,   331,
     339,     1,    52,   225,   423,   427,   238,   238,   238,   339,
     331,   238,   339,   423,     1,    74,   225,   427,   238,   339,
     238,   238,   238,   238,   294,   233,   238,   331,   323,   241,
     423,   428,   276,   238,   241,    11,   240,   338,   338,   241,
     240,   250,   398,   399,   239,   241,   338,   241,   240,   398,
     239,   241,   241,   241,   241,   338,   241,   241,   238,    22,
     328,   290,   328,   241,   328,   241,   338,   397,   338,     3,
      52,   357,   252,   253,   254,   225,   241,   208,   231,   232,
     320,   384,   384,   320,    27,   241,   315,   314,    67,   315,
      66,   314,   293,   320,   240,   239,   241,   358,   320,     1,
     241,   355,   379,   242,     3,   242,   239,   242,     1,   322,
     394,   315,   328,   314,   320,   315,   314,   328,   242,   320,
     238,   320,   416,   250,   320,   324,   320,   324,   223,   239,
     239,   239,   239,   239,   239,   239,   239,   324,     3,   239,
     239,   239,   239,   418,    13,    21,   292,   293,     1,   292,
      59,   242,   352,   351,   332,   241,     5,   359,   149,   320,
     380,   244,   322,   387,   388,   241,   241,   320,   320,   322,
     241,   240,    52,     3,    52,   423,   320,   320,   320,   241,
     241,     1,   339,   240,    74,     3,    74,     1,   320,   241,
     320,   320,     1,   320,   293,   276,     1,    80,    90,   233,
     317,   318,   320,   249,   428,   242,   323,   101,   245,   289,
     316,   320,   101,   289,   316,   320,   397,   397,   320,   320,
     250,   401,   397,   320,   403,   396,   402,     3,   320,   241,
     328,   241,   241,   312,   397,   291,   397,   367,   368,   448,
     208,   208,   225,   225,   242,   242,   242,   242,   242,   242,
     239,   242,   225,   320,   340,    47,   323,   362,   363,   241,
      54,   354,   238,   238,   393,   242,   242,   242,   242,   241,
     242,   242,   242,   241,   409,   413,   225,   320,    34,   420,
     223,   223,   320,   419,   419,   293,   419,   419,   419,   419,
     293,   251,   250,   419,   419,   419,   419,    13,    21,   238,
     415,   238,   415,   239,   242,   242,   242,   241,    71,    72,
      87,   435,   436,    71,    72,    87,   276,   280,   430,   432,
     433,   434,   241,   239,   367,     3,   242,   239,   242,   241,
     241,   242,   320,   424,   242,   242,   242,   242,   240,   320,
     425,   242,   242,   242,   242,   242,   242,   242,   428,   242,
     320,   320,   242,    86,   239,   242,   241,   242,   238,   238,
     320,   320,   241,   238,   320,   320,   241,   332,   332,   225,
     320,     3,   333,   402,   241,   239,   242,   241,   241,     3,
     370,   371,   291,     1,   332,   332,    52,   241,   384,   384,
     293,   320,   225,   225,    53,   363,   320,   280,   325,   326,
     432,   436,     1,   242,   320,   328,   328,   328,   328,   241,
     241,   320,   239,   239,   251,   320,   320,   239,   239,     3,
     239,   421,   422,   239,   239,   239,   239,   239,   242,   324,
     239,   239,   239,   239,   238,   238,   415,   242,   415,   242,
     293,   353,    73,    99,   117,   275,   431,    73,   117,   275,
     431,    73,   117,   275,   431,   239,   241,   242,    73,   117,
     275,   431,    73,   117,   275,   431,    73,   117,   275,   431,
     430,   428,     5,    52,   238,   387,   241,   241,   280,   281,
     282,     1,    47,   283,   284,   323,     1,   284,     1,   284,
     423,   320,   241,   282,   428,   428,   423,   428,   423,   423,
     276,   318,   318,   241,   320,   241,   241,   320,   241,   241,
     241,   241,   320,   225,   240,   239,   241,   241,     3,   240,
     239,   241,     3,   371,   405,   406,   241,   241,   241,   242,
     251,   242,   251,   239,   242,   225,   365,   364,   241,   326,
     423,   242,   242,   242,   241,   241,   241,   241,   225,   320,
      34,   324,   293,   293,   331,   242,   239,   293,   293,   293,
     293,   320,   241,   251,   293,   293,   293,   293,   415,   415,
      23,    24,   225,   412,   412,   282,     3,     3,     3,   338,
       3,     3,     3,   338,     3,     3,     3,   338,     3,   435,
     241,   332,   332,   332,   338,   332,   332,   332,   338,   332,
     332,   332,   338,    59,   242,   149,   242,   320,   280,   426,
      53,   225,   225,   428,     1,    53,   283,   225,    53,    53,
      53,    53,   241,   426,    51,    51,   428,   242,   242,   251,
     320,   320,     3,   242,   320,   370,   398,   241,   239,   241,
     293,   320,   369,   369,     3,    54,   241,   320,   242,   223,
     421,   239,   241,   331,   421,   421,   239,   421,   421,   239,
     239,   421,   421,   412,   412,   320,   320,   428,   397,   397,
     397,   282,   241,   241,   241,   397,   241,   241,   241,   397,
     241,   241,   241,   397,   241,   242,    52,   423,   428,   428,
     428,     1,   320,    74,   428,   428,   316,   316,   251,   240,
       3,   405,   242,   240,   282,   320,   242,   293,   242,   242,
     293,   242,   242,   293,   293,   242,   242,   320,   320,   242,
     242,    59,     3,     3,     3,   428,   332,   332,   332,   241,
     241,   320,   320,   320,   320,   423,   241,   421,   241,   241,
     421,   241,   241,   421,   421,   241,   241,   242,   242,   242,
     242,    59,   241,   241,   241,   339,     1,   339,   241,   241,
     242,    54,   242,   242,   242,   242,   242,   242,   240,   242,
     240,   356,   241,   241,   241,   241,   320,   423,   320,   368,
     242,   242,   423,   423
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   271,   272,   272,   273,   273,   274,   274,   274,   275,
     275,   276,   276,   277,   277,   277,   277,   278,   278,   279,
     279,   280,   280,   280,   280,   280,   280,   280,   280,   280,
     280,   280,   280,   280,   280,   280,   280,   281,   281,   282,
     282,   283,   283,   283,   283,   284,   284,   285,   285,   285,
     286,   286,   287,   288,   288,   288,   289,   289,   290,   290,
     290,   290,   291,   291,   292,   292,   293,   293,   294,   294,
     294,   295,   295,   295,   295,   295,   295,   296,   296,   298,
     297,   299,   299,   300,   300,   300,   300,   302,   301,   303,
     303,   304,   304,   304,   304,   304,   305,   306,   306,   307,
     307,   308,   308,   308,   308,   308,   309,   309,   310,   310,
     311,   311,   312,   312,   312,   312,   312,   312,   313,   313,
     314,   314,   314,   314,   315,   315,   315,   315,   316,   316,
     316,   317,   317,   317,   318,   318,   318,   319,   319,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   321,   321,   322,   322,   322,   322,   323,   323,   324,
     324,   324,   324,   324,   324,   324,   324,   324,   324,   324,
     324,   324,   324,   324,   324,   324,   324,   324,   324,   324,
     324,   324,   324,   324,   324,   324,   324,   324,   324,   324,
     324,   324,   324,   324,   324,   324,   325,   325,   326,   326,
     327,   327,   327,   327,   327,   327,   327,   327,   328,   328,
     329,   329,   329,   329,   329,   329,   329,   329,   329,   329,
     329,   329,   330,   330,   330,   330,   330,   330,   330,   330,
     330,   330,   330,   330,   331,   331,   331,   331,   331,   331,
     332,   332,   333,   333,   333,   333,   334,   334,   335,   335,
     335,   335,   335,   336,   336,   336,   336,   336,   337,   337,
     338,   338,   339,   339,   340,   341,   341,   343,   344,   342,
     345,   345,   346,   346,   347,   347,   347,   348,   348,   349,
     349,   349,   350,   350,   350,   350,   350,   350,   350,   350,
     350,   350,   350,   350,   350,   350,   350,   350,   350,   350,
     350,   350,   350,   350,   350,   350,   350,   350,   350,   350,
     350,   350,   350,   350,   350,   351,   350,   352,   350,   353,
     350,   350,   354,   350,   355,   350,   350,   350,   350,   356,
     350,   357,   350,   350,   358,   350,   350,   359,   350,   350,
     350,   350,   350,   350,   350,   350,   350,   350,   350,   360,
     360,   361,   362,   362,   364,   363,   365,   363,   366,   366,
     367,   367,   368,   368,   368,   369,   369,   370,   371,   371,
     372,   372,   372,   373,   373,   374,   374,   374,   374,   374,
     374,   374,   374,   374,   374,   374,   374,   375,   376,   376,
     376,   376,   376,   376,   376,   377,   377,   378,   378,   379,
     380,   381,   381,   382,   382,   383,   383,   383,   383,   383,
     384,   384,   384,   384,   385,   385,   386,   386,   386,   386,
     386,   386,   387,   387,   388,   388,   389,   389,   389,   389,
     390,   390,   391,   391,   391,   391,   392,   392,   393,   393,
     393,   394,   394,   395,   395,   395,   396,   397,   397,   398,
     398,   399,   399,   400,   400,   400,   400,   400,   400,   400,
     401,   401,   402,   402,   403,   403,   404,   404,   405,   406,
     406,   407,   407,   407,   407,   407,   407,   407,   407,   407,
     407,   407,   407,   407,   407,   407,   407,   407,   407,   407,
     407,   407,   407,   407,   407,   408,   408,   409,   409,   410,
     410,   411,   411,   411,   411,   412,   412,   412,   413,   413,
     413,   414,   414,   414,   415,   415,   415,   415,   416,   416,
     416,   416,   417,   417,   418,   418,   418,   419,   419,   419,
     419,   419,   419,   419,   419,   420,   420,   421,   421,   422,
     422,   422,   422,   422,   423,   423,   423,   423,   423,   423,
     424,   423,   423,   423,   423,   425,   423,   423,   423,   423,
     423,   423,   423,   423,   423,   423,   423,   423,   423,   423,
     423,   423,   423,   423,   423,   423,   423,   423,   423,   423,
     423,   423,   423,   423,   423,   423,   423,   423,   423,   423,
     423,   423,   423,   423,   423,   423,   423,   423,   423,   426,
     426,   427,   427,   428,   428,   429,   430,   430,   431,   431,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   433,   433,   434,   434,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   436,   436,
     436,   436,   436,   438,   437,   439,   439,   440,   441,   441,
     442,   442,   443,   444,   445,   445,   446,   446,   447,   447,
     447,   447,   447,   447,   447,   447,   447,   447,   447,   447,
     447,   447,   447,   447,   447,   447,   447,   447,   447,   447,
     447,   448,   448,   448,   448,   449,   449,   449,   449,   450,
     450,   451,   451,   452,   452,   453,   453,   454,   454,   455,
     455
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     1,     2,     1,     1,     2,     1,
       1,     1,     0,     2,     3,     3,     4,     3,     1,     1,
       3,     7,     6,     4,     4,     4,     4,     3,     4,     4,
       4,     4,     4,     4,     4,     3,     3,     1,     2,     1,
       0,     3,     3,     2,     3,     2,     1,     3,     3,     3,
       1,     0,     3,     1,     2,     3,     2,     4,     2,     4,
       6,     8,     1,     0,     1,     3,     1,     5,     1,     1,
       1,     1,     1,     1,     1,     1,     8,     1,     0,     0,
       6,     2,     1,     3,     3,     3,     3,     0,     6,     2,
       1,     4,     4,     4,     4,     4,     8,     0,     2,     0,
       2,     4,     5,     6,     5,     6,     0,     2,     1,     3,
       0,     2,     5,     5,     5,     5,     5,     5,     1,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     4,
       4,     1,     3,     3,     2,     2,     1,     6,     4,     1,
       2,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       2,     2,     2,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       5,     1,     5,     3,     1,     0,     2,     3,     1,     1,
       1,     1,     1,     1,     4,     4,     3,     3,     4,     4,
       4,     4,     4,     4,     6,     4,     4,     4,     4,     4,
       6,     4,     4,     6,     4,     4,     4,     4,     4,     4,
       6,     6,     3,     3,     6,     7,     1,     2,     1,     1,
       4,     5,     3,     2,     4,     5,     4,     5,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     4,     6,     6,     6,
       1,     3,     1,     3,     3,     5,     1,     3,     1,     3,
       3,     2,     2,     6,     6,     6,     6,     8,     1,     0,
       1,     0,     1,     3,     3,     3,     1,     0,     0,    11,
       1,     1,     8,     0,     3,     3,     0,     0,     4,     3,
       3,     5,     8,     8,     7,     6,     7,     7,     7,     7,
       7,     7,     3,     1,     3,     4,     5,     5,     6,     4,
       5,     3,     3,     6,     8,     8,     6,     8,     8,     5,
       5,     5,     3,     3,     3,     0,     8,     0,    11,     0,
      10,     5,     0,     9,     0,    12,     6,     3,     3,     0,
      14,     0,     5,     2,     0,     7,     5,     0,     8,     2,
       3,     3,     3,     2,     5,     3,     3,     9,     5,     1,
       0,     4,     2,     1,     0,     4,     0,     4,     2,     1,
       1,     0,     1,     3,     5,     1,     1,     3,     3,     1,
       1,     1,     1,     1,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       1,     2,     1,     1,     1,     1,     3,     1,     3,     4,
       3,     1,     0,     2,     1,     6,     6,     6,     6,     2,
       1,     1,     2,     2,     1,     1,     4,     4,     2,     2,
       2,     0,     5,     4,     1,     3,     1,     5,     3,     7,
       1,     0,     1,     6,     4,     4,     1,     3,     5,     5,
       4,     3,     1,     1,     1,     1,     5,     1,     0,     0,
       1,     5,     6,     1,     2,     1,     1,     1,     1,     0,
       2,     3,     1,     3,     2,     3,     1,     3,     2,     1,
       3,     3,     2,     2,     6,     6,     3,     3,    12,    10,
      12,     8,    10,    12,    10,    10,    12,    10,    10,    10,
       7,     3,     3,     3,     3,     1,     2,     5,     3,     1,
       1,    10,    11,    10,    11,     1,     1,     1,     5,     3,
       5,     6,     6,     3,     1,     4,     3,     6,     3,     7,
       3,     7,     1,     3,     1,     1,     0,     2,     2,     4,
       4,     5,     7,     3,     1,     3,     1,     0,     1,     1,
       2,     2,     3,     1,     5,     3,     5,     3,     2,     3,
       0,     7,     3,     2,     3,     0,     7,     3,     3,     3,
       2,     5,     6,     6,     6,     6,     6,     6,     5,     7,
       5,     7,    13,    11,    13,     5,     5,     5,     2,     3,
       4,     6,     4,     4,     4,     4,     5,     5,     5,     9,
       5,     9,     5,     5,     2,     5,     4,     2,     2,     2,
       0,     2,     1,     1,     1,     4,     1,     1,     1,     0,
       6,     6,     6,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     2,     1,     1,     0,     5,     5,     5,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       3,     2,     2,     0,     4,     1,     1,     4,     1,     2,
       1,     2,     6,     5,     1,     0,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     4,     1,
       2,     1,     3,     1,     0,     2,     0,     2,     4,    10,
      13
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:
#line 402 "parse.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[0].number); based_size = 0;}
#line 4965 "parse.cc" /* yacc.c:1646  */
    break;

  case 7:
#line 404 "parse.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[0].number); based_size = 0;}
#line 4971 "parse.cc" /* yacc.c:1646  */
    break;

  case 8:
#line 406 "parse.y" /* yacc.c:1646  */
    { (yyval.number) = pform_verinum_with_size((yyvsp[-1].number),(yyvsp[0].number), (yylsp[0]).text, (yylsp[0]).first_line);
	       based_size = 0; }
#line 4978 "parse.cc" /* yacc.c:1646  */
    break;

  case 12:
#line 422 "parse.y" /* yacc.c:1646  */
    { (yyval.named_pexprs) = 0; }
#line 4984 "parse.cc" /* yacc.c:1646  */
    break;

  case 13:
#line 426 "parse.y" /* yacc.c:1646  */
    { (yyval.named_pexprs) = 0; }
#line 4990 "parse.cc" /* yacc.c:1646  */
    break;

  case 14:
#line 427 "parse.y" /* yacc.c:1646  */
    { (yyval.named_pexprs) = (yyvsp[-1].named_pexprs); }
#line 4996 "parse.cc" /* yacc.c:1646  */
    break;

  case 15:
#line 428 "parse.y" /* yacc.c:1646  */
    { (yyval.named_pexprs) = (yyvsp[-2].named_pexprs); }
#line 5002 "parse.cc" /* yacc.c:1646  */
    break;

  case 16:
#line 430 "parse.y" /* yacc.c:1646  */
    { if ((yyvsp[-3].named_pexprs)) {
	    svector<named_pexpr_t*>*tmp;
	    tmp = new svector<named_pexpr_t*>(*(yyvsp[-3].named_pexprs), *(yyvsp[-1].named_pexprs));
	    delete (yyvsp[-3].named_pexprs);
	    delete (yyvsp[-1].named_pexprs);
	    (yyval.named_pexprs) = tmp;
	} else (yyval.named_pexprs) = (yyvsp[-1].named_pexprs);
      }
#line 5015 "parse.cc" /* yacc.c:1646  */
    break;

  case 17:
#line 442 "parse.y" /* yacc.c:1646  */
    { svector<named_pexpr_t*>*tmp =
			new svector<named_pexpr_t*>(*(yyvsp[-2].named_pexprs),(yyvsp[0].named_pexpr));
		  delete (yyvsp[-2].named_pexprs);
		  (yyval.named_pexprs) = tmp;
		}
#line 5025 "parse.cc" /* yacc.c:1646  */
    break;

  case 18:
#line 448 "parse.y" /* yacc.c:1646  */
    { svector<named_pexpr_t*>*tmp = new svector<named_pexpr_t*>(1);
		  (*tmp)[0] = (yyvsp[0].named_pexpr);
		  (yyval.named_pexprs) = tmp;
		}
#line 5034 "parse.cc" /* yacc.c:1646  */
    break;

  case 19:
#line 457 "parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[0].text));
		  tmp->parm = 0;
		  delete[](yyvsp[0].text);
		  (yyval.named_pexpr) = tmp;
		}
#line 5045 "parse.cc" /* yacc.c:1646  */
    break;

  case 20:
#line 464 "parse.y" /* yacc.c:1646  */
    { PExpr*tmp = (yyvsp[0].expr);
		  named_pexpr_t*tmp2 = new named_pexpr_t;
		  tmp2->name = lex_strings.make((yyvsp[-2].text));
		  tmp2->parm = tmp;
		  delete[](yyvsp[-2].text);
		  (yyval.named_pexpr) = tmp2;
		}
#line 5057 "parse.cc" /* yacc.c:1646  */
    break;

  case 21:
#line 484 "parse.y" /* yacc.c:1646  */
    { ivl_variable_type_t dtype = (yyvsp[-4].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_set_net_range((yyvsp[-1].perm_strings), (yyvsp[-2].exprs), (yyvsp[-3].flag), dtype);
		  if ((yyvsp[-6].named_pexprs)) delete (yyvsp[-6].named_pexprs);
		}
#line 5068 "parse.cc" /* yacc.c:1646  */
    break;

  case 22:
#line 497 "parse.y" /* yacc.c:1646  */
    { ivl_variable_type_t dtype = (yyvsp[-3].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_set_net_range((yyvsp[-1].perm_strings), 0, (yyvsp[-2].flag), dtype);
		  if ((yyvsp[-5].named_pexprs)) delete (yyvsp[-5].named_pexprs);
		}
#line 5079 "parse.cc" /* yacc.c:1646  */
    break;

  case 23:
#line 509 "parse.y" /* yacc.c:1646  */
    { pform_set_reg_integer((yyvsp[-1].perm_strings));
		  if ((yyvsp[-3].named_pexprs)) delete (yyvsp[-3].named_pexprs);
		}
#line 5087 "parse.cc" /* yacc.c:1646  */
    break;

  case 24:
#line 514 "parse.y" /* yacc.c:1646  */
    { pform_set_reg_time((yyvsp[-1].perm_strings));
		}
#line 5094 "parse.cc" /* yacc.c:1646  */
    break;

  case 25:
#line 523 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings); }
#line 5100 "parse.cc" /* yacc.c:1646  */
    break;

  case 26:
#line 525 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings); }
#line 5106 "parse.cc" /* yacc.c:1646  */
    break;

  case 27:
#line 528 "parse.y" /* yacc.c:1646  */
    { pform_make_events((yyvsp[-1].perm_strings), (yylsp[-2]).text, (yylsp[-2]).first_line);
		}
#line 5113 "parse.cc" /* yacc.c:1646  */
    break;

  case 30:
#line 538 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in reg variable list.");
		  yyerrok;
		  if ((yyvsp[-3].named_pexprs)) delete (yyvsp[-3].named_pexprs);
		}
#line 5122 "parse.cc" /* yacc.c:1646  */
    break;

  case 31:
#line 543 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in integer variable list.");
		  yyerrok;
		  if ((yyvsp[-3].named_pexprs)) delete (yyvsp[-3].named_pexprs);
		}
#line 5131 "parse.cc" /* yacc.c:1646  */
    break;

  case 32:
#line 548 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in time variable list.");
		  yyerrok;
		}
#line 5139 "parse.cc" /* yacc.c:1646  */
    break;

  case 33:
#line 552 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in real variable list.");
		  yyerrok;
		}
#line 5147 "parse.cc" /* yacc.c:1646  */
    break;

  case 34:
#line 556 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in realtime variable list.");
		  yyerrok;
		}
#line 5155 "parse.cc" /* yacc.c:1646  */
    break;

  case 35:
#line 560 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in parameter list.");
		  yyerrok;
		}
#line 5163 "parse.cc" /* yacc.c:1646  */
    break;

  case 36:
#line 564 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error localparam list.");
		  yyerrok;
		}
#line 5171 "parse.cc" /* yacc.c:1646  */
    break;

  case 41:
#line 581 "parse.y" /* yacc.c:1646  */
    { PCase::Item*tmp = new PCase::Item;
		  tmp->expr = *(yyvsp[-2].exprs);
		  tmp->stat = (yyvsp[0].statement);
		  delete (yyvsp[-2].exprs);
		  (yyval.citem) = tmp;
		}
#line 5182 "parse.cc" /* yacc.c:1646  */
    break;

  case 42:
#line 588 "parse.y" /* yacc.c:1646  */
    { PCase::Item*tmp = new PCase::Item;
		  tmp->stat = (yyvsp[0].statement);
		  (yyval.citem) = tmp;
		}
#line 5191 "parse.cc" /* yacc.c:1646  */
    break;

  case 43:
#line 593 "parse.y" /* yacc.c:1646  */
    { PCase::Item*tmp = new PCase::Item;
		  tmp->stat = (yyvsp[0].statement);
		  (yyval.citem) = tmp;
		}
#line 5200 "parse.cc" /* yacc.c:1646  */
    break;

  case 44:
#line 598 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: Incomprehensible case expression.");
		  yyerrok;
		}
#line 5208 "parse.cc" /* yacc.c:1646  */
    break;

  case 45:
#line 605 "parse.y" /* yacc.c:1646  */
    { svector<PCase::Item*>*tmp;
		  tmp = new svector<PCase::Item*>(*(yyvsp[-1].citems), (yyvsp[0].citem));
		  delete (yyvsp[-1].citems);
		  (yyval.citems) = tmp;
		}
#line 5218 "parse.cc" /* yacc.c:1646  */
    break;

  case 46:
#line 611 "parse.y" /* yacc.c:1646  */
    { svector<PCase::Item*>*tmp = new svector<PCase::Item*>(1);
		  (*tmp)[0] = (yyvsp[0].citem);
		  (yyval.citems) = tmp;
		}
#line 5227 "parse.cc" /* yacc.c:1646  */
    break;

  case 52:
#line 630 "parse.y" /* yacc.c:1646  */
    { pform_set_defparam(*(yyvsp[-2].pform_name), (yyvsp[0].expr));
		  delete (yyvsp[-2].pform_name);
		}
#line 5235 "parse.cc" /* yacc.c:1646  */
    break;

  case 54:
#line 638 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: defparam may not include a range.");
		  delete (yyvsp[-1].exprs);
		}
#line 5243 "parse.cc" /* yacc.c:1646  */
    break;

  case 56:
#line 646 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[0].expr);
		  (yyval.exprs) = tmp;
		}
#line 5252 "parse.cc" /* yacc.c:1646  */
    break;

  case 57:
#line 651 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[-1].expr);
		  (yyval.exprs) = tmp;
		}
#line 5261 "parse.cc" /* yacc.c:1646  */
    break;

  case 58:
#line 659 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[0].expr);
		  (yyval.exprs) = tmp;
		}
#line 5270 "parse.cc" /* yacc.c:1646  */
    break;

  case 59:
#line 664 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[-1].expr);
		  (yyval.exprs) = tmp;
		}
#line 5279 "parse.cc" /* yacc.c:1646  */
    break;

  case 60:
#line 669 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(2);
		  (*tmp)[0] = (yyvsp[-3].expr);
		  (*tmp)[1] = (yyvsp[-1].expr);
		  (yyval.exprs) = tmp;
		}
#line 5289 "parse.cc" /* yacc.c:1646  */
    break;

  case 61:
#line 675 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(3);
		  (*tmp)[0] = (yyvsp[-5].expr);
		  (*tmp)[1] = (yyvsp[-3].expr);
		  (*tmp)[2] = (yyvsp[-1].expr);
		  (yyval.exprs) = tmp;
		}
#line 5300 "parse.cc" /* yacc.c:1646  */
    break;

  case 62:
#line 684 "parse.y" /* yacc.c:1646  */
    { (yyval.exprs) = (yyvsp[0].exprs); }
#line 5306 "parse.cc" /* yacc.c:1646  */
    break;

  case 63:
#line 685 "parse.y" /* yacc.c:1646  */
    { (yyval.exprs) = 0; }
#line 5312 "parse.cc" /* yacc.c:1646  */
    break;

  case 64:
#line 690 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
	        (*tmp)[0] = (yyvsp[0].expr);
		(yyval.exprs) = tmp;
	      }
#line 5321 "parse.cc" /* yacc.c:1646  */
    break;

  case 65:
#line 695 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[-2].exprs), (yyvsp[0].expr));
		delete (yyvsp[-2].exprs);
		(yyval.exprs) = tmp;
	      }
#line 5330 "parse.cc" /* yacc.c:1646  */
    break;

  case 66:
#line 703 "parse.y" /* yacc.c:1646  */
    { PExpr*tmp = (yyvsp[0].expr);
		  (yyval.expr) = tmp;
		}
#line 5338 "parse.cc" /* yacc.c:1646  */
    break;

  case 67:
#line 707 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = pform_select_mtm_expr((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 5344 "parse.cc" /* yacc.c:1646  */
    break;

  case 68:
#line 713 "parse.y" /* yacc.c:1646  */
    { verinum*tmp = (yyvsp[0].number);
		  if (tmp == 0) {
			yyerror((yylsp[0]), "internal error: delay.");
			(yyval.expr) = 0;
		  } else {
			(yyval.expr) = new PENumber(tmp);
			FILE_NAME((yyval.expr), (yylsp[0]));
		  }
		  based_size = 0;
		}
#line 5359 "parse.cc" /* yacc.c:1646  */
    break;

  case 69:
#line 724 "parse.y" /* yacc.c:1646  */
    { verireal*tmp = (yyvsp[0].realtime);
		  if (tmp == 0) {
			yyerror((yylsp[0]), "internal error: delay.");
			(yyval.expr) = 0;
		  } else {
			(yyval.expr) = new PEFNumber(tmp);
			FILE_NAME((yyval.expr), (yylsp[0]));
		  }
		}
#line 5373 "parse.cc" /* yacc.c:1646  */
    break;

  case 70:
#line 734 "parse.y" /* yacc.c:1646  */
    { PEIdent*tmp = new PEIdent(lex_strings.make((yyvsp[0].text)));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 5383 "parse.cc" /* yacc.c:1646  */
    break;

  case 76:
#line 748 "parse.y" /* yacc.c:1646  */
    { perm_string tmp3 = lex_strings.make((yyvsp[-5].text));
	pform_set_type_attrib(tmp3, (yyvsp[-3].text), (yyvsp[-1].text));
	delete[] (yyvsp[-5].text);
	delete[] (yyvsp[-3].text);
      }
#line 5393 "parse.cc" /* yacc.c:1646  */
    break;

  case 79:
#line 763 "parse.y" /* yacc.c:1646  */
    { pform_start_discipline((yyvsp[-1].text)); }
#line 5399 "parse.cc" /* yacc.c:1646  */
    break;

  case 80:
#line 765 "parse.y" /* yacc.c:1646  */
    { pform_end_discipline((yylsp[-5])); delete[] (yyvsp[-4].text); }
#line 5405 "parse.cc" /* yacc.c:1646  */
    break;

  case 83:
#line 775 "parse.y" /* yacc.c:1646  */
    { pform_discipline_domain((yylsp[-2]), IVL_DIS_DISCRETE); }
#line 5411 "parse.cc" /* yacc.c:1646  */
    break;

  case 84:
#line 777 "parse.y" /* yacc.c:1646  */
    { pform_discipline_domain((yylsp[-2]), IVL_DIS_CONTINUOUS); }
#line 5417 "parse.cc" /* yacc.c:1646  */
    break;

  case 85:
#line 779 "parse.y" /* yacc.c:1646  */
    { pform_discipline_potential((yylsp[-2]), (yyvsp[-1].text)); delete[] (yyvsp[-1].text); }
#line 5423 "parse.cc" /* yacc.c:1646  */
    break;

  case 86:
#line 781 "parse.y" /* yacc.c:1646  */
    { pform_discipline_flow((yylsp[-2]), (yyvsp[-1].text)); delete[] (yyvsp[-1].text); }
#line 5429 "parse.cc" /* yacc.c:1646  */
    break;

  case 87:
#line 786 "parse.y" /* yacc.c:1646  */
    { pform_start_nature((yyvsp[-1].text)); }
#line 5435 "parse.cc" /* yacc.c:1646  */
    break;

  case 88:
#line 789 "parse.y" /* yacc.c:1646  */
    { pform_end_nature((yylsp[-5])); delete[] (yyvsp[-4].text); }
#line 5441 "parse.cc" /* yacc.c:1646  */
    break;

  case 91:
#line 799 "parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[-1].text); }
#line 5447 "parse.cc" /* yacc.c:1646  */
    break;

  case 93:
#line 802 "parse.y" /* yacc.c:1646  */
    { pform_nature_access((yylsp[-3]), (yyvsp[-1].text)); delete[] (yyvsp[-1].text); }
#line 5453 "parse.cc" /* yacc.c:1646  */
    break;

  case 94:
#line 804 "parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[-1].text); }
#line 5459 "parse.cc" /* yacc.c:1646  */
    break;

  case 95:
#line 806 "parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[-1].text); }
#line 5465 "parse.cc" /* yacc.c:1646  */
    break;

  case 96:
#line 814 "parse.y" /* yacc.c:1646  */
    { cerr << (yylsp[-7]) << ": sorry: config declarations are not supported and "
                "will be skipped." << endl;
	delete[] (yyvsp[-6].text);
      }
#line 5474 "parse.cc" /* yacc.c:1646  */
    break;

  case 102:
#line 834 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].pform_name); }
#line 5480 "parse.cc" /* yacc.c:1646  */
    break;

  case 103:
#line 836 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-4].pform_name); }
#line 5486 "parse.cc" /* yacc.c:1646  */
    break;

  case 108:
#line 848 "parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[0].text); }
#line 5492 "parse.cc" /* yacc.c:1646  */
    break;

  case 109:
#line 850 "parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[-2].text); delete[] (yyvsp[0].text); }
#line 5498 "parse.cc" /* yacc.c:1646  */
    break;

  case 111:
#line 856 "parse.y" /* yacc.c:1646  */
    { delete[] (yyvsp[0].text); }
#line 5504 "parse.cc" /* yacc.c:1646  */
    break;

  case 112:
#line 861 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = (yyvsp[-3].drive).str0;
		  (yyval.drive).str1 = (yyvsp[-1].drive).str1;
		}
#line 5512 "parse.cc" /* yacc.c:1646  */
    break;

  case 113:
#line 865 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = (yyvsp[-1].drive).str0;
		  (yyval.drive).str1 = (yyvsp[-3].drive).str1;
		}
#line 5520 "parse.cc" /* yacc.c:1646  */
    break;

  case 114:
#line 869 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = (yyvsp[-3].drive).str0;
		  (yyval.drive).str1 = PGate::HIGHZ;
		}
#line 5528 "parse.cc" /* yacc.c:1646  */
    break;

  case 115:
#line 873 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = PGate::HIGHZ;
		  (yyval.drive).str1 = (yyvsp[-3].drive).str1;
		}
#line 5536 "parse.cc" /* yacc.c:1646  */
    break;

  case 116:
#line 877 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = (yyvsp[-1].drive).str0;
		  (yyval.drive).str1 = PGate::HIGHZ;
		}
#line 5544 "parse.cc" /* yacc.c:1646  */
    break;

  case 117:
#line 881 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = PGate::HIGHZ;
		  (yyval.drive).str1 = (yyvsp[-1].drive).str1;
		}
#line 5552 "parse.cc" /* yacc.c:1646  */
    break;

  case 118:
#line 887 "parse.y" /* yacc.c:1646  */
    { (yyval.drive) = (yyvsp[0].drive); }
#line 5558 "parse.cc" /* yacc.c:1646  */
    break;

  case 119:
#line 888 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = PGate::STRONG; (yyval.drive).str1 = PGate::STRONG; }
#line 5564 "parse.cc" /* yacc.c:1646  */
    break;

  case 120:
#line 892 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = PGate::SUPPLY; }
#line 5570 "parse.cc" /* yacc.c:1646  */
    break;

  case 121:
#line 893 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = PGate::STRONG; }
#line 5576 "parse.cc" /* yacc.c:1646  */
    break;

  case 122:
#line 894 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = PGate::PULL; }
#line 5582 "parse.cc" /* yacc.c:1646  */
    break;

  case 123:
#line 895 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str0 = PGate::WEAK; }
#line 5588 "parse.cc" /* yacc.c:1646  */
    break;

  case 124:
#line 899 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str1 = PGate::SUPPLY; }
#line 5594 "parse.cc" /* yacc.c:1646  */
    break;

  case 125:
#line 900 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str1 = PGate::STRONG; }
#line 5600 "parse.cc" /* yacc.c:1646  */
    break;

  case 126:
#line 901 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str1 = PGate::PULL; }
#line 5606 "parse.cc" /* yacc.c:1646  */
    break;

  case 127:
#line 902 "parse.y" /* yacc.c:1646  */
    { (yyval.drive).str1 = PGate::WEAK; }
#line 5612 "parse.cc" /* yacc.c:1646  */
    break;

  case 128:
#line 907 "parse.y" /* yacc.c:1646  */
    { PEIdent*tmpi = new PEIdent(*(yyvsp[0].pform_name));
		  PEEvent*tmpe = new PEEvent(PEEvent::ANYEDGE, tmpi);
		  PEventStatement*tmps = new PEventStatement(tmpe);
		  FILE_NAME(tmps, (yylsp[-1]));
		  (yyval.event_statement) = tmps;
		  delete (yyvsp[0].pform_name);
		}
#line 5624 "parse.cc" /* yacc.c:1646  */
    break;

  case 129:
#line 915 "parse.y" /* yacc.c:1646  */
    { PEventStatement*tmp = new PEventStatement(*(yyvsp[-1].event_expr));
		  FILE_NAME(tmp, (yylsp[-3]));
		  delete (yyvsp[-1].event_expr);
		  (yyval.event_statement) = tmp;
		}
#line 5634 "parse.cc" /* yacc.c:1646  */
    break;

  case 130:
#line 921 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "error: Malformed event control expression.");
		  (yyval.event_statement) = 0;
		}
#line 5642 "parse.cc" /* yacc.c:1646  */
    break;

  case 131:
#line 928 "parse.y" /* yacc.c:1646  */
    { (yyval.event_expr) = (yyvsp[0].event_expr); }
#line 5648 "parse.cc" /* yacc.c:1646  */
    break;

  case 132:
#line 930 "parse.y" /* yacc.c:1646  */
    { svector<PEEvent*>*tmp = new svector<PEEvent*>(*(yyvsp[-2].event_expr), *(yyvsp[0].event_expr));
		  delete (yyvsp[-2].event_expr);
		  delete (yyvsp[0].event_expr);
		  (yyval.event_expr) = tmp;
		}
#line 5658 "parse.cc" /* yacc.c:1646  */
    break;

  case 133:
#line 936 "parse.y" /* yacc.c:1646  */
    { svector<PEEvent*>*tmp = new svector<PEEvent*>(*(yyvsp[-2].event_expr), *(yyvsp[0].event_expr));
		  delete (yyvsp[-2].event_expr);
		  delete (yyvsp[0].event_expr);
		  (yyval.event_expr) = tmp;
		}
#line 5668 "parse.cc" /* yacc.c:1646  */
    break;

  case 134:
#line 945 "parse.y" /* yacc.c:1646  */
    { PEEvent*tmp = new PEEvent(PEEvent::POSEDGE, (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  svector<PEEvent*>*tl = new svector<PEEvent*>(1);
		  (*tl)[0] = tmp;
		  (yyval.event_expr) = tl;
		}
#line 5679 "parse.cc" /* yacc.c:1646  */
    break;

  case 135:
#line 952 "parse.y" /* yacc.c:1646  */
    { PEEvent*tmp = new PEEvent(PEEvent::NEGEDGE, (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  svector<PEEvent*>*tl = new svector<PEEvent*>(1);
		  (*tl)[0] = tmp;
		  (yyval.event_expr) = tl;
		}
#line 5690 "parse.cc" /* yacc.c:1646  */
    break;

  case 136:
#line 959 "parse.y" /* yacc.c:1646  */
    { PEEvent*tmp = new PEEvent(PEEvent::ANYEDGE, (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  svector<PEEvent*>*tl = new svector<PEEvent*>(1);
		  (*tl)[0] = tmp;
		  (yyval.event_expr) = tl;
		}
#line 5701 "parse.cc" /* yacc.c:1646  */
    break;

  case 137:
#line 973 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = pform_make_branch_probe_expression((yylsp[-5]), (yyvsp[-5].text), (yyvsp[-3].text), (yyvsp[-1].text)); }
#line 5707 "parse.cc" /* yacc.c:1646  */
    break;

  case 138:
#line 975 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = pform_make_branch_probe_expression((yylsp[-3]), (yyvsp[-3].text), (yyvsp[-1].text)); }
#line 5713 "parse.cc" /* yacc.c:1646  */
    break;

  case 139:
#line 980 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 5719 "parse.cc" /* yacc.c:1646  */
    break;

  case 140:
#line 982 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 5725 "parse.cc" /* yacc.c:1646  */
    break;

  case 141:
#line 984 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('-', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5734 "parse.cc" /* yacc.c:1646  */
    break;

  case 142:
#line 989 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('~', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5743 "parse.cc" /* yacc.c:1646  */
    break;

  case 143:
#line 994 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('&', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5752 "parse.cc" /* yacc.c:1646  */
    break;

  case 144:
#line 999 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('!', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5761 "parse.cc" /* yacc.c:1646  */
    break;

  case 145:
#line 1004 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('|', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5770 "parse.cc" /* yacc.c:1646  */
    break;

  case 146:
#line 1009 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('^', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5779 "parse.cc" /* yacc.c:1646  */
    break;

  case 147:
#line 1014 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: '~' '&'  is not a valid expression. "
			  "Please use operator '~&' instead.");
		  (yyval.expr) = 0;
		}
#line 5788 "parse.cc" /* yacc.c:1646  */
    break;

  case 148:
#line 1019 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: '~' '|'  is not a valid expression. "
			  "Please use operator '~|' instead.");
		  (yyval.expr) = 0;
		}
#line 5797 "parse.cc" /* yacc.c:1646  */
    break;

  case 149:
#line 1024 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: '~' '^'  is not a valid expression. "
			  "Please use operator '~^' instead.");
		  (yyval.expr) = 0;
		}
#line 5806 "parse.cc" /* yacc.c:1646  */
    break;

  case 150:
#line 1029 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('A', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5815 "parse.cc" /* yacc.c:1646  */
    break;

  case 151:
#line 1034 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('N', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5824 "parse.cc" /* yacc.c:1646  */
    break;

  case 152:
#line 1039 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('X', (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 5833 "parse.cc" /* yacc.c:1646  */
    break;

  case 153:
#line 1044 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: Operand of unary ! "
			  "is not a primary expression.");
		  (yyval.expr) = 0;
		}
#line 5842 "parse.cc" /* yacc.c:1646  */
    break;

  case 154:
#line 1049 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: Operand of reduction ^ "
			  "is not a primary expression.");
		  (yyval.expr) = 0;
		}
#line 5851 "parse.cc" /* yacc.c:1646  */
    break;

  case 155:
#line 1054 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('^', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5860 "parse.cc" /* yacc.c:1646  */
    break;

  case 156:
#line 1059 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBPower('p', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5869 "parse.cc" /* yacc.c:1646  */
    break;

  case 157:
#line 1064 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('*', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5878 "parse.cc" /* yacc.c:1646  */
    break;

  case 158:
#line 1069 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('/', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5887 "parse.cc" /* yacc.c:1646  */
    break;

  case 159:
#line 1074 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('%', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5896 "parse.cc" /* yacc.c:1646  */
    break;

  case 160:
#line 1079 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('+', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5905 "parse.cc" /* yacc.c:1646  */
    break;

  case 161:
#line 1084 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('-', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5914 "parse.cc" /* yacc.c:1646  */
    break;

  case 162:
#line 1089 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('&', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5923 "parse.cc" /* yacc.c:1646  */
    break;

  case 163:
#line 1094 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('|', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5932 "parse.cc" /* yacc.c:1646  */
    break;

  case 164:
#line 1099 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('A', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5941 "parse.cc" /* yacc.c:1646  */
    break;

  case 165:
#line 1104 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('O', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5950 "parse.cc" /* yacc.c:1646  */
    break;

  case 166:
#line 1109 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('X', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5959 "parse.cc" /* yacc.c:1646  */
    break;

  case 167:
#line 1114 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('<', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5968 "parse.cc" /* yacc.c:1646  */
    break;

  case 168:
#line 1119 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('>', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5977 "parse.cc" /* yacc.c:1646  */
    break;

  case 169:
#line 1124 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBShift('l', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5986 "parse.cc" /* yacc.c:1646  */
    break;

  case 170:
#line 1129 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBShift('r', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 5995 "parse.cc" /* yacc.c:1646  */
    break;

  case 171:
#line 1134 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBShift('R', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6004 "parse.cc" /* yacc.c:1646  */
    break;

  case 172:
#line 1139 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('e', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6013 "parse.cc" /* yacc.c:1646  */
    break;

  case 173:
#line 1144 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('E', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6022 "parse.cc" /* yacc.c:1646  */
    break;

  case 174:
#line 1149 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('L', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6031 "parse.cc" /* yacc.c:1646  */
    break;

  case 175:
#line 1154 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('G', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6040 "parse.cc" /* yacc.c:1646  */
    break;

  case 176:
#line 1159 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('n', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6049 "parse.cc" /* yacc.c:1646  */
    break;

  case 177:
#line 1164 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBComp('N', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6058 "parse.cc" /* yacc.c:1646  */
    break;

  case 178:
#line 1169 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBLogic('o', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6067 "parse.cc" /* yacc.c:1646  */
    break;

  case 179:
#line 1174 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBLogic('a', (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.expr) = tmp;
		}
#line 6076 "parse.cc" /* yacc.c:1646  */
    break;

  case 180:
#line 1179 "parse.y" /* yacc.c:1646  */
    { PETernary*tmp = new PETernary((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr));
		  FILE_NAME(tmp, (yylsp[-3]));
		  (yyval.expr) = tmp;
		}
#line 6085 "parse.cc" /* yacc.c:1646  */
    break;

  case 181:
#line 1187 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 6091 "parse.cc" /* yacc.c:1646  */
    break;

  case 182:
#line 1189 "parse.y" /* yacc.c:1646  */
    { switch (min_typ_max_flag) {
		      case MIN:
			(yyval.expr) = (yyvsp[-4].expr);
			delete (yyvsp[-2].expr);
			delete (yyvsp[0].expr);
			break;
		      case TYP:
			delete (yyvsp[-4].expr);
			(yyval.expr) = (yyvsp[-2].expr);
			delete (yyvsp[0].expr);
			break;
		      case MAX:
			delete (yyvsp[-4].expr);
			delete (yyvsp[-2].expr);
			(yyval.expr) = (yyvsp[0].expr);
			break;
		  }
		  if (min_typ_max_warn > 0) {
		        cerr << (yyval.expr)->get_fileline() << ": warning: choosing ";
		        switch (min_typ_max_flag) {
		            case MIN:
		              cerr << "min";
		              break;
		            case TYP:
		              cerr << "typ";
		              break;
		            case MAX:
		              cerr << "max";
		              break;
		        }
		        cerr << " expression." << endl;
		        min_typ_max_warn -= 1;
		  }
		}
#line 6130 "parse.cc" /* yacc.c:1646  */
    break;

  case 183:
#line 1236 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[-2].exprs), (yyvsp[0].expr));
		  delete (yyvsp[-2].exprs);
		  (yyval.exprs) = tmp;
		}
#line 6139 "parse.cc" /* yacc.c:1646  */
    break;

  case 184:
#line 1241 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[0].expr);
		  (yyval.exprs) = tmp;
		}
#line 6148 "parse.cc" /* yacc.c:1646  */
    break;

  case 185:
#line 1246 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = 0;
		  (yyval.exprs) = tmp;
		}
#line 6157 "parse.cc" /* yacc.c:1646  */
    break;

  case 186:
#line 1252 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[-1].exprs), 0);
		  delete (yyvsp[-1].exprs);
		  (yyval.exprs) = tmp;
		}
#line 6166 "parse.cc" /* yacc.c:1646  */
    break;

  case 187:
#line 1260 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[-2].exprs), (yyvsp[0].expr));
		  delete (yyvsp[-2].exprs);
		  (yyval.exprs) = tmp;
		}
#line 6175 "parse.cc" /* yacc.c:1646  */
    break;

  case 188:
#line 1265 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[0].expr);
		  (yyval.exprs) = tmp;
		}
#line 6184 "parse.cc" /* yacc.c:1646  */
    break;

  case 189:
#line 1273 "parse.y" /* yacc.c:1646  */
    { assert((yyvsp[0].number));
		  PENumber*tmp = new PENumber((yyvsp[0].number));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 6194 "parse.cc" /* yacc.c:1646  */
    break;

  case 190:
#line 1279 "parse.y" /* yacc.c:1646  */
    { PEFNumber*tmp = new PEFNumber((yyvsp[0].realtime));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 6203 "parse.cc" /* yacc.c:1646  */
    break;

  case 191:
#line 1284 "parse.y" /* yacc.c:1646  */
    { PEString*tmp = new PEString((yyvsp[0].text));
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		}
#line 6212 "parse.cc" /* yacc.c:1646  */
    break;

  case 192:
#line 1289 "parse.y" /* yacc.c:1646  */
    { perm_string tn = lex_strings.make((yyvsp[0].text));
		  PECallFunction*tmp = new PECallFunction(tn);
		  FILE_NAME(tmp, (yylsp[0]));
		  (yyval.expr) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 6223 "parse.cc" /* yacc.c:1646  */
    break;

  case 193:
#line 1300 "parse.y" /* yacc.c:1646  */
    { PEIdent*tmp = new PEIdent(*(yyvsp[0].pform_name));
	  FILE_NAME(tmp, (yylsp[0]));
	  (yyval.expr) = tmp;
	  delete (yyvsp[0].pform_name);
	}
#line 6233 "parse.cc" /* yacc.c:1646  */
    break;

  case 194:
#line 1311 "parse.y" /* yacc.c:1646  */
    { PECallFunction*tmp = new PECallFunction(*(yyvsp[-3].pform_name), *(yyvsp[-1].exprs));
	FILE_NAME(tmp, (yylsp[-3]));
	delete (yyvsp[-3].pform_name);
	(yyval.expr) = tmp;
      }
#line 6243 "parse.cc" /* yacc.c:1646  */
    break;

  case 195:
#line 1317 "parse.y" /* yacc.c:1646  */
    { perm_string tn = lex_strings.make((yyvsp[-3].text));
	PECallFunction*tmp = new PECallFunction(tn, *(yyvsp[-1].exprs));
	FILE_NAME(tmp, (yylsp[-3]));
	delete[](yyvsp[-3].text);
	(yyval.expr) = tmp;
      }
#line 6254 "parse.cc" /* yacc.c:1646  */
    break;

  case 196:
#line 1324 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: function calls must have at least one "
			  "input argument.");
		  yyerrok;
      }
#line 6263 "parse.cc" /* yacc.c:1646  */
    break;

  case 197:
#line 1329 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: system function calls must have at least one "
			  "input argument.");
		  yyerrok;
      }
#line 6272 "parse.cc" /* yacc.c:1646  */
    break;

  case 198:
#line 1338 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$acos");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6282 "parse.cc" /* yacc.c:1646  */
    break;

  case 199:
#line 1345 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$acosh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6292 "parse.cc" /* yacc.c:1646  */
    break;

  case 200:
#line 1352 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$asin");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6302 "parse.cc" /* yacc.c:1646  */
    break;

  case 201:
#line 1359 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$asinh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6312 "parse.cc" /* yacc.c:1646  */
    break;

  case 202:
#line 1366 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$atan");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6322 "parse.cc" /* yacc.c:1646  */
    break;

  case 203:
#line 1373 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$atanh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6332 "parse.cc" /* yacc.c:1646  */
    break;

  case 204:
#line 1380 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$atan2");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-3].expr), (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-5]));
	(yyval.expr) = tmp;
      }
#line 6342 "parse.cc" /* yacc.c:1646  */
    break;

  case 205:
#line 1387 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$ceil");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6352 "parse.cc" /* yacc.c:1646  */
    break;

  case 206:
#line 1394 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$cos");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6362 "parse.cc" /* yacc.c:1646  */
    break;

  case 207:
#line 1401 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$cosh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6372 "parse.cc" /* yacc.c:1646  */
    break;

  case 208:
#line 1408 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$exp");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6382 "parse.cc" /* yacc.c:1646  */
    break;

  case 209:
#line 1415 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$floor");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6392 "parse.cc" /* yacc.c:1646  */
    break;

  case 210:
#line 1422 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$hypot");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-3].expr), (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-5]));
	(yyval.expr) = tmp;
      }
#line 6402 "parse.cc" /* yacc.c:1646  */
    break;

  case 211:
#line 1429 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$ln");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6412 "parse.cc" /* yacc.c:1646  */
    break;

  case 212:
#line 1436 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$log10");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6422 "parse.cc" /* yacc.c:1646  */
    break;

  case 213:
#line 1443 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$pow");
        PECallFunction*tmp = make_call_function(tn, (yyvsp[-3].expr), (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-5]));
	(yyval.expr) = tmp;
      }
#line 6432 "parse.cc" /* yacc.c:1646  */
    break;

  case 214:
#line 1450 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$sin");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6442 "parse.cc" /* yacc.c:1646  */
    break;

  case 215:
#line 1457 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$sinh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6452 "parse.cc" /* yacc.c:1646  */
    break;

  case 216:
#line 1464 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$sqrt");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6462 "parse.cc" /* yacc.c:1646  */
    break;

  case 217:
#line 1471 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$tan");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6472 "parse.cc" /* yacc.c:1646  */
    break;

  case 218:
#line 1478 "parse.y" /* yacc.c:1646  */
    { perm_string tn = perm_string::literal("$tanh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6482 "parse.cc" /* yacc.c:1646  */
    break;

  case 219:
#line 1489 "parse.y" /* yacc.c:1646  */
    { PEUnary*tmp = new PEUnary('m', (yyvsp[-1].expr));
        FILE_NAME(tmp,(yylsp[-3]));
	(yyval.expr) = tmp;
      }
#line 6491 "parse.cc" /* yacc.c:1646  */
    break;

  case 220:
#line 1495 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('M', (yyvsp[-3].expr), (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-5]));
	(yyval.expr) = tmp;
      }
#line 6500 "parse.cc" /* yacc.c:1646  */
    break;

  case 221:
#line 1501 "parse.y" /* yacc.c:1646  */
    { PEBinary*tmp = new PEBinary('m', (yyvsp[-3].expr), (yyvsp[-1].expr));
	FILE_NAME(tmp,(yylsp[-5]));
	(yyval.expr) = tmp;
      }
#line 6509 "parse.cc" /* yacc.c:1646  */
    break;

  case 222:
#line 1509 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 6515 "parse.cc" /* yacc.c:1646  */
    break;

  case 223:
#line 1514 "parse.y" /* yacc.c:1646  */
    { PEConcat*tmp = new PEConcat(*(yyvsp[-1].exprs));
		  FILE_NAME(tmp, (yylsp[-2]));
		  delete (yyvsp[-1].exprs);
		  (yyval.expr) = tmp;
		}
#line 6525 "parse.cc" /* yacc.c:1646  */
    break;

  case 224:
#line 1520 "parse.y" /* yacc.c:1646  */
    { PExpr*rep = (yyvsp[-4].expr);
		  PEConcat*tmp = new PEConcat(*(yyvsp[-2].exprs), rep);
		  FILE_NAME(tmp, (yylsp[-5]));
		  delete (yyvsp[-2].exprs);
		  (yyval.expr) = tmp;
		}
#line 6536 "parse.cc" /* yacc.c:1646  */
    break;

  case 225:
#line 1527 "parse.y" /* yacc.c:1646  */
    { PExpr*rep = (yyvsp[-5].expr);
		  PEConcat*tmp = new PEConcat(*(yyvsp[-3].exprs), rep);
		  FILE_NAME(tmp, (yylsp[-6]));
		  delete (yyvsp[-3].exprs);
		  (yyval.expr) = tmp;
		  yyerror((yylsp[-2]), "error: Syntax error between internal '}' "
			  "and closing '}' of repeat concatenation.");
		  yyerrok;
		}
#line 6550 "parse.cc" /* yacc.c:1646  */
    break;

  case 226:
#line 1543 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 6556 "parse.cc" /* yacc.c:1646  */
    break;

  case 227:
#line 1545 "parse.y" /* yacc.c:1646  */
    { if ((yyvsp[-1].wires) && (yyvsp[0].wires)) {
		        svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[-1].wires), *(yyvsp[0].wires));
			delete (yyvsp[-1].wires);
			delete (yyvsp[0].wires);
			(yyval.wires) = tmp;
		  } else if ((yyvsp[-1].wires)) {
			(yyval.wires) = (yyvsp[-1].wires);
		  } else {
			(yyval.wires) = (yyvsp[0].wires);
		  }
		}
#line 6572 "parse.cc" /* yacc.c:1646  */
    break;

  case 228:
#line 1560 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 6578 "parse.cc" /* yacc.c:1646  */
    break;

  case 229:
#line 1562 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = 0; }
#line 6584 "parse.cc" /* yacc.c:1646  */
    break;

  case 230:
#line 1569 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[-3].text);
		  tmp->parms = (yyvsp[-1].exprs);
		  tmp->file  = (yylsp[-3]).text;
		  tmp->lineno = (yylsp[-3]).first_line;
		  delete[](yyvsp[-3].text);
		  (yyval.gate) = tmp;
		}
#line 6597 "parse.cc" /* yacc.c:1646  */
    break;

  case 231:
#line 1579 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  svector<PExpr*>*rng = (yyvsp[-3].exprs);
		  tmp->name = (yyvsp[-4].text);
		  tmp->parms = (yyvsp[-1].exprs);
		  tmp->range[0] = (*rng)[0];
		  tmp->range[1] = (*rng)[1];
		  tmp->file  = (yylsp[-4]).text;
		  tmp->lineno = (yylsp[-4]).first_line;
		  delete[](yyvsp[-4].text);
		  delete rng;
		  (yyval.gate) = tmp;
		}
#line 6614 "parse.cc" /* yacc.c:1646  */
    break;

  case 232:
#line 1592 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  tmp->name = "";
		  tmp->parms = (yyvsp[-1].exprs);
		  tmp->file  = (yylsp[-2]).text;
		  tmp->lineno = (yylsp[-2]).first_line;
		  (yyval.gate) = tmp;
		}
#line 6626 "parse.cc" /* yacc.c:1646  */
    break;

  case 233:
#line 1603 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  svector<PExpr*>*rng = (yyvsp[0].exprs);
		  tmp->name = (yyvsp[-1].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = 0;
		  tmp->range[0] = (*rng)[0];
		  tmp->range[1] = (*rng)[1];
		  tmp->file  = (yylsp[-1]).text;
		  tmp->lineno = (yylsp[-1]).first_line;
		  delete[](yyvsp[-1].text);
		  delete rng;
		  (yyval.gate) = tmp;
		}
#line 6644 "parse.cc" /* yacc.c:1646  */
    break;

  case 234:
#line 1620 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[-3].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = (yyvsp[-1].named_pexprs);
		  tmp->file  = (yylsp[-3]).text;
		  tmp->lineno = (yylsp[-3]).first_line;
		  delete[](yyvsp[-3].text);
		  (yyval.gate) = tmp;
		}
#line 6658 "parse.cc" /* yacc.c:1646  */
    break;

  case 235:
#line 1631 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  svector<PExpr*>*rng = (yyvsp[-3].exprs);
		  tmp->name = (yyvsp[-4].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = (yyvsp[-1].named_pexprs);
		  tmp->range[0] = (*rng)[0];
		  tmp->range[1] = (*rng)[1];
		  tmp->file  = (yylsp[-4]).text;
		  tmp->lineno = (yylsp[-4]).first_line;
		  delete[](yyvsp[-4].text);
		  delete rng;
		  (yyval.gate) = tmp;
		}
#line 6676 "parse.cc" /* yacc.c:1646  */
    break;

  case 236:
#line 1646 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[-3].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = 0;
		  tmp->file  = (yylsp[-3]).text;
		  tmp->lineno = (yylsp[-3]).first_line;
		  yyerror((yylsp[-2]), "error: Syntax error in instance port "
			  "expression(s).");
		  delete[](yyvsp[-3].text);
		  (yyval.gate) = tmp;
		}
#line 6692 "parse.cc" /* yacc.c:1646  */
    break;

  case 237:
#line 1659 "parse.y" /* yacc.c:1646  */
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[-4].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = 0;
		  tmp->file  = (yylsp[-4]).text;
		  tmp->lineno = (yylsp[-4]).first_line;
		  yyerror((yylsp[-2]), "error: Syntax error in instance port "
			  "expression(s).");
		  delete[](yyvsp[-4].text);
		  (yyval.gate) = tmp;
		}
#line 6708 "parse.cc" /* yacc.c:1646  */
    break;

  case 238:
#line 1674 "parse.y" /* yacc.c:1646  */
    { svector<lgate>*tmp1 = (yyvsp[-2].gates);
		  lgate*tmp2 = (yyvsp[0].gate);
		  svector<lgate>*out = new svector<lgate> (*tmp1, *tmp2);
		  delete tmp1;
		  delete tmp2;
		  (yyval.gates) = out;
		}
#line 6720 "parse.cc" /* yacc.c:1646  */
    break;

  case 239:
#line 1682 "parse.y" /* yacc.c:1646  */
    { svector<lgate>*tmp = new svector<lgate>(1);
		  (*tmp)[0] = *(yyvsp[0].gate);
		  delete (yyvsp[0].gate);
		  (yyval.gates) = tmp;
		}
#line 6730 "parse.cc" /* yacc.c:1646  */
    break;

  case 240:
#line 1690 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::AND; }
#line 6736 "parse.cc" /* yacc.c:1646  */
    break;

  case 241:
#line 1691 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NAND; }
#line 6742 "parse.cc" /* yacc.c:1646  */
    break;

  case 242:
#line 1692 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::OR; }
#line 6748 "parse.cc" /* yacc.c:1646  */
    break;

  case 243:
#line 1693 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NOR; }
#line 6754 "parse.cc" /* yacc.c:1646  */
    break;

  case 244:
#line 1694 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::XOR; }
#line 6760 "parse.cc" /* yacc.c:1646  */
    break;

  case 245:
#line 1695 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::XNOR; }
#line 6766 "parse.cc" /* yacc.c:1646  */
    break;

  case 246:
#line 1696 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::BUF; }
#line 6772 "parse.cc" /* yacc.c:1646  */
    break;

  case 247:
#line 1697 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::BUFIF0; }
#line 6778 "parse.cc" /* yacc.c:1646  */
    break;

  case 248:
#line 1698 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::BUFIF1; }
#line 6784 "parse.cc" /* yacc.c:1646  */
    break;

  case 249:
#line 1699 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NOT; }
#line 6790 "parse.cc" /* yacc.c:1646  */
    break;

  case 250:
#line 1700 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NOTIF0; }
#line 6796 "parse.cc" /* yacc.c:1646  */
    break;

  case 251:
#line 1701 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NOTIF1; }
#line 6802 "parse.cc" /* yacc.c:1646  */
    break;

  case 252:
#line 1705 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::NMOS; }
#line 6808 "parse.cc" /* yacc.c:1646  */
    break;

  case 253:
#line 1706 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RNMOS; }
#line 6814 "parse.cc" /* yacc.c:1646  */
    break;

  case 254:
#line 1707 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::PMOS; }
#line 6820 "parse.cc" /* yacc.c:1646  */
    break;

  case 255:
#line 1708 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RPMOS; }
#line 6826 "parse.cc" /* yacc.c:1646  */
    break;

  case 256:
#line 1709 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::CMOS; }
#line 6832 "parse.cc" /* yacc.c:1646  */
    break;

  case 257:
#line 1710 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RCMOS; }
#line 6838 "parse.cc" /* yacc.c:1646  */
    break;

  case 258:
#line 1711 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::TRAN; }
#line 6844 "parse.cc" /* yacc.c:1646  */
    break;

  case 259:
#line 1712 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RTRAN; }
#line 6850 "parse.cc" /* yacc.c:1646  */
    break;

  case 260:
#line 1713 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::TRANIF0; }
#line 6856 "parse.cc" /* yacc.c:1646  */
    break;

  case 261:
#line 1714 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::TRANIF1; }
#line 6862 "parse.cc" /* yacc.c:1646  */
    break;

  case 262:
#line 1715 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RTRANIF0; }
#line 6868 "parse.cc" /* yacc.c:1646  */
    break;

  case 263:
#line 1716 "parse.y" /* yacc.c:1646  */
    { (yyval.gatetype) = PGBuiltin::RTRANIF1; }
#line 6874 "parse.cc" /* yacc.c:1646  */
    break;

  case 264:
#line 1727 "parse.y" /* yacc.c:1646  */
    { (yyval.pform_name) = new pform_name_t;
	  (yyval.pform_name)->push_back(name_component_t(lex_strings.make((yyvsp[0].text))));
	  delete[](yyvsp[0].text);
	}
#line 6883 "parse.cc" /* yacc.c:1646  */
    break;

  case 265:
#line 1732 "parse.y" /* yacc.c:1646  */
    { pform_name_t * tmp = (yyvsp[-2].pform_name);
	  tmp->push_back(name_component_t(lex_strings.make((yyvsp[0].text))));
	  delete[](yyvsp[0].text);
	  (yyval.pform_name) = tmp;
	}
#line 6893 "parse.cc" /* yacc.c:1646  */
    break;

  case 266:
#line 1738 "parse.y" /* yacc.c:1646  */
    { pform_name_t * tmp = (yyvsp[-3].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_BIT;
	  itmp.msb = (yyvsp[-1].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	}
#line 6906 "parse.cc" /* yacc.c:1646  */
    break;

  case 267:
#line 1747 "parse.y" /* yacc.c:1646  */
    { pform_name_t * tmp = (yyvsp[-5].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_PART;
	  itmp.msb = (yyvsp[-3].expr);
	  itmp.lsb = (yyvsp[-1].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	}
#line 6920 "parse.cc" /* yacc.c:1646  */
    break;

  case 268:
#line 1757 "parse.y" /* yacc.c:1646  */
    { pform_name_t * tmp = (yyvsp[-5].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_IDX_UP;
	  itmp.msb = (yyvsp[-3].expr);
	  itmp.lsb = (yyvsp[-1].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	}
#line 6934 "parse.cc" /* yacc.c:1646  */
    break;

  case 269:
#line 1767 "parse.y" /* yacc.c:1646  */
    { pform_name_t * tmp = (yyvsp[-5].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_IDX_DO;
	  itmp.msb = (yyvsp[-3].expr);
	  itmp.lsb = (yyvsp[-1].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	}
#line 6948 "parse.cc" /* yacc.c:1646  */
    break;

  case 270:
#line 1783 "parse.y" /* yacc.c:1646  */
    { (yyval.perm_strings) = list_from_identifier((yyvsp[0].text)); }
#line 6954 "parse.cc" /* yacc.c:1646  */
    break;

  case 271:
#line 1785 "parse.y" /* yacc.c:1646  */
    { (yyval.perm_strings) = list_from_identifier((yyvsp[-2].perm_strings), (yyvsp[0].text)); }
#line 6960 "parse.cc" /* yacc.c:1646  */
    break;

  case 272:
#line 1790 "parse.y" /* yacc.c:1646  */
    { (yyval.port_list) = make_port_list((yyvsp[0].text), 0); }
#line 6966 "parse.cc" /* yacc.c:1646  */
    break;

  case 273:
#line 1792 "parse.y" /* yacc.c:1646  */
    { (yyval.port_list) = make_port_list((yyvsp[-2].text), (yyvsp[0].expr)); }
#line 6972 "parse.cc" /* yacc.c:1646  */
    break;

  case 274:
#line 1794 "parse.y" /* yacc.c:1646  */
    { (yyval.port_list) = make_port_list((yyvsp[-2].port_list), (yyvsp[0].text), 0); }
#line 6978 "parse.cc" /* yacc.c:1646  */
    break;

  case 275:
#line 1796 "parse.y" /* yacc.c:1646  */
    { (yyval.port_list) = make_port_list((yyvsp[-4].port_list), (yyvsp[-2].text), (yyvsp[0].expr)); }
#line 6984 "parse.cc" /* yacc.c:1646  */
    break;

  case 276:
#line 1818 "parse.y" /* yacc.c:1646  */
    { vector<Module::port_t*>*tmp
			  = new vector<Module::port_t*>(1);
		  (*tmp)[0] = (yyvsp[0].mport);
		  (yyval.mports) = tmp;
		}
#line 6994 "parse.cc" /* yacc.c:1646  */
    break;

  case 277:
#line 1824 "parse.y" /* yacc.c:1646  */
    { vector<Module::port_t*>*tmp = (yyvsp[-2].mports);
		  tmp->push_back((yyvsp[0].mport));
		  (yyval.mports) = tmp;
		}
#line 7003 "parse.cc" /* yacc.c:1646  */
    break;

  case 278:
#line 1832 "parse.y" /* yacc.c:1646  */
    { vector<Module::port_t*>*tmp
			  = new vector<Module::port_t*>(1);
		  (*tmp)[0] = (yyvsp[0].mport);
		  (yyval.mports) = tmp;
		}
#line 7013 "parse.cc" /* yacc.c:1646  */
    break;

  case 279:
#line 1838 "parse.y" /* yacc.c:1646  */
    { vector<Module::port_t*>*tmp = (yyvsp[-2].mports);
		  tmp->push_back((yyvsp[0].mport));
		  (yyval.mports) = tmp;
		}
#line 7022 "parse.cc" /* yacc.c:1646  */
    break;

  case 280:
#line 1843 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
		  perm_string name = lex_strings.make((yyvsp[0].text));
		  ptmp = pform_module_port_reference(name, (yylsp[0]).text,
						     (yylsp[0]).first_line);
		  vector<Module::port_t*>*tmp = (yyvsp[-2].mports);
		  tmp->push_back(ptmp);

		    /* Get the port declaration details, the port type
		       and what not, from context data stored by the
		       last port_declaration rule. */
		  pform_module_define_port((yylsp[0]), name,
					port_declaration_context.port_type,
					port_declaration_context.port_net_type,
					port_declaration_context.sign_flag,
					port_declaration_context.range, 0);
		  delete[](yyvsp[0].text);
		  (yyval.mports) = tmp;
		}
#line 7045 "parse.cc" /* yacc.c:1646  */
    break;

  case 281:
#line 1862 "parse.y" /* yacc.c:1646  */
    {
		  yyerror((yylsp[0]), "error: NULL port declarations are not "
		              "allowed.");
		}
#line 7054 "parse.cc" /* yacc.c:1646  */
    break;

  case 282:
#line 1867 "parse.y" /* yacc.c:1646  */
    {
		  yyerror((yylsp[0]), "error: ';' is an invalid port declaration "
		              "separator.");
		}
#line 7063 "parse.cc" /* yacc.c:1646  */
    break;

  case 283:
#line 1876 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[0].text));
	ptmp = pform_module_port_reference(name, (yylsp[-4]).text,
					   (yylsp[-4]).first_line);
	pform_module_define_port((yylsp[-4]), name, NetNet::PINPUT,
				 (yyvsp[-3].nettype), (yyvsp[-2].flag), (yyvsp[-1].exprs), (yyvsp[-5].named_pexprs));
	port_declaration_context.port_type = NetNet::PINPUT;
	port_declaration_context.port_net_type = (yyvsp[-3].nettype);
	port_declaration_context.sign_flag = (yyvsp[-2].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[-1].exprs);
	delete (yyvsp[-5].named_pexprs);
	delete[](yyvsp[0].text);
	(yyval.mport) = ptmp;
      }
#line 7083 "parse.cc" /* yacc.c:1646  */
    break;

  case 284:
#line 1893 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[0].text));
	ptmp = pform_module_port_reference(name, (yylsp[-4]).text,
					   (yylsp[-4]).first_line);
	pform_module_define_port((yylsp[-4]), name, NetNet::PINOUT,
				 (yyvsp[-3].nettype), (yyvsp[-2].flag), (yyvsp[-1].exprs), (yyvsp[-5].named_pexprs));
	port_declaration_context.port_type = NetNet::PINOUT;
	port_declaration_context.port_net_type = (yyvsp[-3].nettype);
	port_declaration_context.sign_flag = (yyvsp[-2].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[-1].exprs);
	delete (yyvsp[-5].named_pexprs);
	delete[](yyvsp[0].text);
	(yyval.mport) = ptmp;
      }
#line 7103 "parse.cc" /* yacc.c:1646  */
    break;

  case 285:
#line 1910 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[0].text));
	ptmp = pform_module_port_reference(name, (yylsp[-4]).text,
					   (yylsp[-4]).first_line);
	pform_module_define_port((yylsp[-4]), name, NetNet::POUTPUT,
				 (yyvsp[-3].nettype), (yyvsp[-2].flag), (yyvsp[-1].exprs), (yyvsp[-5].named_pexprs));
	port_declaration_context.port_type = NetNet::POUTPUT;
	port_declaration_context.port_net_type = (yyvsp[-3].nettype);
	port_declaration_context.sign_flag = (yyvsp[-2].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[-1].exprs);
	delete (yyvsp[-5].named_pexprs);
	delete[](yyvsp[0].text);
	(yyval.mport) = ptmp;
      }
#line 7123 "parse.cc" /* yacc.c:1646  */
    break;

  case 286:
#line 1927 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[0].text));
	ptmp = pform_module_port_reference(name, (yylsp[-4]).text,
					   (yylsp[-4]).first_line);
	pform_module_define_port((yylsp[-4]), name, NetNet::POUTPUT,
				 (yyvsp[-3].nettype), (yyvsp[-2].flag), (yyvsp[-1].exprs), (yyvsp[-5].named_pexprs));
	port_declaration_context.port_type = NetNet::POUTPUT;
	port_declaration_context.port_net_type = (yyvsp[-3].nettype);
	port_declaration_context.sign_flag = (yyvsp[-2].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[-1].exprs);
	delete (yyvsp[-5].named_pexprs);
	delete[](yyvsp[0].text);
	(yyval.mport) = ptmp;
      }
#line 7143 "parse.cc" /* yacc.c:1646  */
    break;

  case 287:
#line 1944 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[-2].text));
	ptmp = pform_module_port_reference(name, (yylsp[-6]).text,
					   (yylsp[-6]).first_line);
	pform_module_define_port((yylsp[-6]), name, NetNet::POUTPUT,
				 (yyvsp[-5].nettype), (yyvsp[-4].flag), (yyvsp[-3].exprs), (yyvsp[-7].named_pexprs));
	port_declaration_context.port_type = NetNet::POUTPUT;
	port_declaration_context.port_net_type = (yyvsp[-5].nettype);
	port_declaration_context.sign_flag = (yyvsp[-4].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[-3].exprs);

	pform_make_reginit((yylsp[-2]), name, (yyvsp[0].expr));

	delete (yyvsp[-7].named_pexprs);
	delete[](yyvsp[-2].text);
	(yyval.mport) = ptmp;
      }
#line 7166 "parse.cc" /* yacc.c:1646  */
    break;

  case 288:
#line 1967 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = (yyvsp[0].nettype); }
#line 7172 "parse.cc" /* yacc.c:1646  */
    break;

  case 289:
#line 1968 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::IMPLICIT; }
#line 7178 "parse.cc" /* yacc.c:1646  */
    break;

  case 290:
#line 1971 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 7184 "parse.cc" /* yacc.c:1646  */
    break;

  case 291:
#line 1971 "parse.y" /* yacc.c:1646  */
    {(yyval.flag) = false; }
#line 7190 "parse.cc" /* yacc.c:1646  */
    break;

  case 292:
#line 1979 "parse.y" /* yacc.c:1646  */
    { PEIdent*tmp = new PEIdent(*(yyvsp[0].pform_name));
	  FILE_NAME(tmp, (yylsp[0]));
	  (yyval.expr) = tmp;
	  delete (yyvsp[0].pform_name);
	}
#line 7200 "parse.cc" /* yacc.c:1646  */
    break;

  case 293:
#line 1985 "parse.y" /* yacc.c:1646  */
    { PEConcat*tmp = new PEConcat(*(yyvsp[-1].exprs));
	  FILE_NAME(tmp, (yylsp[-2]));
	  delete (yyvsp[-1].exprs);
	  (yyval.expr) = tmp;
	}
#line 7210 "parse.cc" /* yacc.c:1646  */
    break;

  case 294:
#line 1997 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(2);
		  (*tmp)[0] = (yyvsp[-2].expr);
		  (*tmp)[1] = (yyvsp[0].expr);
		  (yyval.exprs) = tmp;
		}
#line 7220 "parse.cc" /* yacc.c:1646  */
    break;

  case 295:
#line 2006 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[-2].exprs), *(yyvsp[0].exprs));
		  delete (yyvsp[-2].exprs);
		  delete (yyvsp[0].exprs);
		  (yyval.exprs) = tmp;
		}
#line 7230 "parse.cc" /* yacc.c:1646  */
    break;

  case 296:
#line 2012 "parse.y" /* yacc.c:1646  */
    { (yyval.exprs) = (yyvsp[0].exprs); }
#line 7236 "parse.cc" /* yacc.c:1646  */
    break;

  case 297:
#line 2021 "parse.y" /* yacc.c:1646  */
    { pform_startmodule((yyvsp[0].text), (yylsp[-1]).text, (yylsp[-1]).first_line, (yyvsp[-2].named_pexprs)); }
#line 7242 "parse.cc" /* yacc.c:1646  */
    break;

  case 298:
#line 2025 "parse.y" /* yacc.c:1646  */
    { pform_module_set_ports((yyvsp[-2].mports)); }
#line 7248 "parse.cc" /* yacc.c:1646  */
    break;

  case 299:
#line 2028 "parse.y" /* yacc.c:1646  */
    { Module::UCDriveType ucd;
		  switch (uc_drive) {
		      case UCD_NONE:
		      default:
			ucd = Module::UCD_NONE;
			break;
		      case UCD_PULL0:
			ucd = Module::UCD_PULL0;
			break;
		      case UCD_PULL1:
			ucd = Module::UCD_PULL1;
			break;
		  }
		  pform_endmodule((yyvsp[-8].text), in_celldefine, ucd);
		  delete[](yyvsp[-8].text);
		}
#line 7269 "parse.cc" /* yacc.c:1646  */
    break;

  case 302:
#line 2050 "parse.y" /* yacc.c:1646  */
    { (yyval.mports) = 0; }
#line 7275 "parse.cc" /* yacc.c:1646  */
    break;

  case 303:
#line 2051 "parse.y" /* yacc.c:1646  */
    { (yyval.mports) = 0; }
#line 7281 "parse.cc" /* yacc.c:1646  */
    break;

  case 304:
#line 2055 "parse.y" /* yacc.c:1646  */
    { (yyval.mports) = (yyvsp[-1].mports); }
#line 7287 "parse.cc" /* yacc.c:1646  */
    break;

  case 305:
#line 2056 "parse.y" /* yacc.c:1646  */
    { (yyval.mports) = (yyvsp[-1].mports); }
#line 7293 "parse.cc" /* yacc.c:1646  */
    break;

  case 306:
#line 2057 "parse.y" /* yacc.c:1646  */
    { (yyval.mports) = 0; }
#line 7299 "parse.cc" /* yacc.c:1646  */
    break;

  case 312:
#line 2087 "parse.y" /* yacc.c:1646  */
    { ivl_variable_type_t dtype = (yyvsp[-5].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_makewire((yylsp[-6]), (yyvsp[-3].exprs), (yyvsp[-4].flag), (yyvsp[-1].perm_strings), (yyvsp[-6].nettype),
				 NetNet::NOT_A_PORT, dtype, (yyvsp[-7].named_pexprs));
		  if ((yyvsp[-2].exprs) != 0) {
			yyerror((yylsp[-2]), "sorry: net delays not supported.");
			delete (yyvsp[-2].exprs);
		  }
		}
#line 7314 "parse.cc" /* yacc.c:1646  */
    break;

  case 313:
#line 2106 "parse.y" /* yacc.c:1646  */
    { ivl_variable_type_t dtype = (yyvsp[-5].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_makewire((yylsp[-6]), (yyvsp[-3].exprs), (yyvsp[-4].flag), (yyvsp[-2].exprs),
				 str_strength, (yyvsp[-1].net_decl_assign), (yyvsp[-6].nettype), dtype);
		  if ((yyvsp[-7].named_pexprs)) {
			yyerror((yylsp[-6]), "sorry: Attributes not supported "
				"on net declaration assignments.");
			delete (yyvsp[-7].named_pexprs);
		  }
		}
#line 7330 "parse.cc" /* yacc.c:1646  */
    break;

  case 314:
#line 2125 "parse.y" /* yacc.c:1646  */
    { ivl_variable_type_t dtype = (yyvsp[-4].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_makewire((yylsp[-5]), 0, (yyvsp[-3].flag), 0, (yyvsp[-2].drive), (yyvsp[-1].net_decl_assign), (yyvsp[-5].nettype), dtype);
		  if ((yyvsp[-6].named_pexprs)) {
			yyerror((yylsp[-5]), "sorry: Attributes not supported "
				"on net declaration assignments.");
			delete (yyvsp[-6].named_pexprs);
		  }
		}
#line 7345 "parse.cc" /* yacc.c:1646  */
    break;

  case 315:
#line 2137 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-5]), "sorry: trireg nets not supported.");
		  delete (yyvsp[-3].exprs);
		  delete (yyvsp[-2].exprs);
		}
#line 7354 "parse.cc" /* yacc.c:1646  */
    break;

  case 316:
#line 2143 "parse.y" /* yacc.c:1646  */
    { pform_set_port_type((yylsp[-5]), (yyvsp[-1].perm_strings), (yyvsp[-3].exprs), (yyvsp[-4].flag), (yyvsp[-5].porttype), (yyvsp[-6].named_pexprs)); }
#line 7360 "parse.cc" /* yacc.c:1646  */
    break;

  case 317:
#line 2150 "parse.y" /* yacc.c:1646  */
    { pform_makewire((yylsp[-5]), (yyvsp[-2].exprs), (yyvsp[-3].flag), (yyvsp[-1].perm_strings), (yyvsp[-4].nettype), (yyvsp[-5].porttype), IVL_VT_NO_TYPE, (yyvsp[-6].named_pexprs), SR_BOTH); }
#line 7366 "parse.cc" /* yacc.c:1646  */
    break;

  case 318:
#line 2153 "parse.y" /* yacc.c:1646  */
    { list<pair<perm_string,PExpr*> >::const_iterator pp;
	list<perm_string>*tmp = new list<perm_string>;
	for (pp = (yyvsp[-1].port_list)->begin(); pp != (yyvsp[-1].port_list)->end(); ++ pp ) {
	      tmp->push_back((*pp).first);
	}
	pform_makewire((yylsp[-5]), (yyvsp[-2].exprs), (yyvsp[-3].flag), tmp, (yyvsp[-4].nettype), NetNet::POUTPUT,
		       IVL_VT_NO_TYPE, (yyvsp[-6].named_pexprs), SR_BOTH);
	for (pp = (yyvsp[-1].port_list)->begin(); pp != (yyvsp[-1].port_list)->end(); ++ pp ) {
	      if ((*pp).second) {
		   pform_make_reginit((yylsp[-5]), (*pp).first, (*pp).second);
	      }
	}
	delete (yyvsp[-1].port_list);
      }
#line 7385 "parse.cc" /* yacc.c:1646  */
    break;

  case 319:
#line 2173 "parse.y" /* yacc.c:1646  */
    { pform_makewire((yylsp[-5]), (yyvsp[-2].exprs), (yyvsp[-3].flag), (yyvsp[-1].perm_strings), (yyvsp[-4].nettype), NetNet::PINPUT,
		       IVL_VT_NO_TYPE, (yyvsp[-6].named_pexprs));
	yyerror((yylsp[-4]), "error: reg variables cannot be inputs.");
      }
#line 7394 "parse.cc" /* yacc.c:1646  */
    break;

  case 320:
#line 2179 "parse.y" /* yacc.c:1646  */
    { pform_makewire((yylsp[-5]), (yyvsp[-2].exprs), (yyvsp[-3].flag), (yyvsp[-1].perm_strings), (yyvsp[-4].nettype), NetNet::PINOUT,
		       IVL_VT_NO_TYPE, (yyvsp[-6].named_pexprs));
	yyerror((yylsp[-4]), "error: reg variables cannot be inouts.");
      }
#line 7403 "parse.cc" /* yacc.c:1646  */
    break;

  case 321:
#line 2185 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-5]), "error: Invalid variable list in port declaration.");
	if ((yyvsp[-6].named_pexprs)) delete (yyvsp[-6].named_pexprs);
	if ((yyvsp[-3].exprs)) delete (yyvsp[-3].exprs);
	if ((yyvsp[-2].exprs)) delete (yyvsp[-2].exprs);
	yyerrok;
      }
#line 7414 "parse.cc" /* yacc.c:1646  */
    break;

  case 322:
#line 2196 "parse.y" /* yacc.c:1646  */
    { pform_attach_discipline((yylsp[-2]), (yyvsp[-2].discipline), (yyvsp[-1].perm_strings)); }
#line 7420 "parse.cc" /* yacc.c:1646  */
    break;

  case 325:
#line 2212 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yyvsp[-2].gatetype), str_strength, 0, (yyvsp[-1].gates), (yyvsp[-3].named_pexprs));
		}
#line 7427 "parse.cc" /* yacc.c:1646  */
    break;

  case 326:
#line 2216 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yyvsp[-3].gatetype), str_strength, (yyvsp[-2].exprs), (yyvsp[-1].gates), (yyvsp[-4].named_pexprs));
		}
#line 7434 "parse.cc" /* yacc.c:1646  */
    break;

  case 327:
#line 2220 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yyvsp[-3].gatetype), (yyvsp[-2].drive), 0, (yyvsp[-1].gates), (yyvsp[-4].named_pexprs));
		}
#line 7441 "parse.cc" /* yacc.c:1646  */
    break;

  case 328:
#line 2224 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yyvsp[-4].gatetype), (yyvsp[-3].drive), (yyvsp[-2].exprs), (yyvsp[-1].gates), (yyvsp[-5].named_pexprs));
		}
#line 7448 "parse.cc" /* yacc.c:1646  */
    break;

  case 329:
#line 2229 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yyvsp[-2].gatetype), str_strength, 0, (yyvsp[-1].gates), (yyvsp[-3].named_pexprs));
		}
#line 7455 "parse.cc" /* yacc.c:1646  */
    break;

  case 330:
#line 2233 "parse.y" /* yacc.c:1646  */
    { pform_makegates((yyvsp[-3].gatetype), str_strength, (yyvsp[-2].exprs), (yyvsp[-1].gates), (yyvsp[-4].named_pexprs));
		}
#line 7462 "parse.cc" /* yacc.c:1646  */
    break;

  case 331:
#line 2240 "parse.y" /* yacc.c:1646  */
    { pform_makegates(PGBuiltin::PULLUP, pull_strength, 0,
				  (yyvsp[-1].gates), 0);
		}
#line 7470 "parse.cc" /* yacc.c:1646  */
    break;

  case 332:
#line 2244 "parse.y" /* yacc.c:1646  */
    { pform_makegates(PGBuiltin::PULLDOWN, pull_strength,
				  0, (yyvsp[-1].gates), 0);
		}
#line 7478 "parse.cc" /* yacc.c:1646  */
    break;

  case 333:
#line 2249 "parse.y" /* yacc.c:1646  */
    { pform_makegates(PGBuiltin::PULLUP, (yyvsp[-3].drive), 0, (yyvsp[-1].gates), 0);
		}
#line 7485 "parse.cc" /* yacc.c:1646  */
    break;

  case 334:
#line 2253 "parse.y" /* yacc.c:1646  */
    { pform_makegates(PGBuiltin::PULLUP, (yyvsp[-5].drive), 0, (yyvsp[-1].gates), 0);
		}
#line 7492 "parse.cc" /* yacc.c:1646  */
    break;

  case 335:
#line 2257 "parse.y" /* yacc.c:1646  */
    { pform_makegates(PGBuiltin::PULLUP, (yyvsp[-3].drive), 0, (yyvsp[-1].gates), 0);
		}
#line 7499 "parse.cc" /* yacc.c:1646  */
    break;

  case 336:
#line 2261 "parse.y" /* yacc.c:1646  */
    { pform_makegates(PGBuiltin::PULLDOWN, (yyvsp[-3].drive), 0, (yyvsp[-1].gates), 0);
		}
#line 7506 "parse.cc" /* yacc.c:1646  */
    break;

  case 337:
#line 2265 "parse.y" /* yacc.c:1646  */
    { pform_makegates(PGBuiltin::PULLDOWN, (yyvsp[-3].drive), 0, (yyvsp[-1].gates), 0);
		}
#line 7513 "parse.cc" /* yacc.c:1646  */
    break;

  case 338:
#line 2269 "parse.y" /* yacc.c:1646  */
    { pform_makegates(PGBuiltin::PULLDOWN, (yyvsp[-5].drive), 0, (yyvsp[-1].gates), 0);
		}
#line 7520 "parse.cc" /* yacc.c:1646  */
    break;

  case 339:
#line 2278 "parse.y" /* yacc.c:1646  */
    { perm_string tmp1 = lex_strings.make((yyvsp[-3].text));
		  pform_make_modgates(tmp1, (yyvsp[-2].parmvalue), (yyvsp[-1].gates));
		  delete[](yyvsp[-3].text);
		  if ((yyvsp[-4].named_pexprs)) delete (yyvsp[-4].named_pexprs);
		}
#line 7530 "parse.cc" /* yacc.c:1646  */
    break;

  case 340:
#line 2286 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "error: Invalid module instantiation");
		  delete[](yyvsp[-3].text);
		  if ((yyvsp[-4].named_pexprs)) delete (yyvsp[-4].named_pexprs);
		}
#line 7539 "parse.cc" /* yacc.c:1646  */
    break;

  case 341:
#line 2296 "parse.y" /* yacc.c:1646  */
    { pform_make_pgassign_list((yyvsp[-1].exprs), (yyvsp[-2].exprs), (yyvsp[-3].drive), (yylsp[-4]).text, (yylsp[-4]).first_line); }
#line 7545 "parse.cc" /* yacc.c:1646  */
    break;

  case 342:
#line 2301 "parse.y" /* yacc.c:1646  */
    { PProcess*tmp = pform_make_behavior(IVL_PR_ALWAYS, (yyvsp[0].statement), (yyvsp[-2].named_pexprs));
	FILE_NAME(tmp, (yylsp[-1]));
      }
#line 7553 "parse.cc" /* yacc.c:1646  */
    break;

  case 343:
#line 2305 "parse.y" /* yacc.c:1646  */
    { PProcess*tmp = pform_make_behavior(IVL_PR_INITIAL, (yyvsp[0].statement), (yyvsp[-2].named_pexprs));
	FILE_NAME(tmp, (yylsp[-1]));
      }
#line 7561 "parse.cc" /* yacc.c:1646  */
    break;

  case 344:
#line 2310 "parse.y" /* yacc.c:1646  */
    { pform_make_analog_behavior((yylsp[-1]), IVL_PR_ALWAYS, (yyvsp[0].statement)); }
#line 7567 "parse.cc" /* yacc.c:1646  */
    break;

  case 345:
#line 2321 "parse.y" /* yacc.c:1646  */
    { assert(current_task == 0);
	current_task = pform_push_task_scope((yylsp[-3]), (yyvsp[-1].text), (yyvsp[-2].flag));
      }
#line 7575 "parse.cc" /* yacc.c:1646  */
    break;

  case 346:
#line 2327 "parse.y" /* yacc.c:1646  */
    { current_task->set_ports((yyvsp[-2].wires));
	current_task->set_statement((yyvsp[-1].statement));
	pform_pop_scope();
	current_task = 0;
	delete[](yyvsp[-5].text);
      }
#line 7586 "parse.cc" /* yacc.c:1646  */
    break;

  case 347:
#line 2335 "parse.y" /* yacc.c:1646  */
    { assert(current_task == 0);
	current_task = pform_push_task_scope((yylsp[-3]), (yyvsp[-1].text), (yyvsp[-2].flag));
      }
#line 7594 "parse.cc" /* yacc.c:1646  */
    break;

  case 348:
#line 2342 "parse.y" /* yacc.c:1646  */
    { current_task->set_ports((yyvsp[-5].wires));
	current_task->set_statement((yyvsp[-1].statement));
	pform_pop_scope();
	current_task = 0;
	delete[](yyvsp[-8].text);
      }
#line 7605 "parse.cc" /* yacc.c:1646  */
    break;

  case 349:
#line 2350 "parse.y" /* yacc.c:1646  */
    { assert(current_task == 0);
	current_task = pform_push_task_scope((yylsp[-5]), (yyvsp[-3].text), (yyvsp[-4].flag));
      }
#line 7613 "parse.cc" /* yacc.c:1646  */
    break;

  case 350:
#line 2356 "parse.y" /* yacc.c:1646  */
    { current_task->set_ports(0);
	current_task->set_statement((yyvsp[-1].statement));
	pform_pop_scope();
	current_task = 0;
	cerr << (yylsp[-7]) << ": warning: task definition for \"" << (yyvsp[-7].text)
	     << "\" has an empty port declaration list!" << endl;
	delete[](yyvsp[-7].text);
      }
#line 7626 "parse.cc" /* yacc.c:1646  */
    break;

  case 351:
#line 2366 "parse.y" /* yacc.c:1646  */
    {
	assert(current_task == 0);
	delete[](yyvsp[-2].text);
      }
#line 7635 "parse.cc" /* yacc.c:1646  */
    break;

  case 352:
#line 2377 "parse.y" /* yacc.c:1646  */
    { assert(current_function == 0);
	current_function = pform_push_function_scope((yylsp[-4]), (yyvsp[-1].text), (yyvsp[-3].flag));
      }
#line 7643 "parse.cc" /* yacc.c:1646  */
    break;

  case 353:
#line 2382 "parse.y" /* yacc.c:1646  */
    { current_function->set_ports((yyvsp[-2].wires));
	current_function->set_statement((yyvsp[-1].statement));
	current_function->set_return((yyvsp[-6].function_type));
	pform_pop_scope();
	current_function = 0;
	delete[](yyvsp[-5].text);
      }
#line 7655 "parse.cc" /* yacc.c:1646  */
    break;

  case 354:
#line 2391 "parse.y" /* yacc.c:1646  */
    { assert(current_function == 0);
	current_function = pform_push_function_scope((yylsp[-3]), (yyvsp[0].text), (yyvsp[-2].flag));
      }
#line 7663 "parse.cc" /* yacc.c:1646  */
    break;

  case 355:
#line 2398 "parse.y" /* yacc.c:1646  */
    { current_function->set_ports((yyvsp[-5].wires));
	current_function->set_statement((yyvsp[-1].statement));
	current_function->set_return((yyvsp[-9].function_type));
	pform_pop_scope();
	current_function = 0;
	delete[](yyvsp[-8].text);
      }
#line 7675 "parse.cc" /* yacc.c:1646  */
    break;

  case 356:
#line 2406 "parse.y" /* yacc.c:1646  */
    {
	if (current_function != 0) {
	      pform_pop_scope();
	      current_function = 0;
	}
	delete[](yyvsp[-2].text);
      }
#line 7687 "parse.cc" /* yacc.c:1646  */
    break;

  case 358:
#line 2421 "parse.y" /* yacc.c:1646  */
    { pform_genvars((yylsp[-2]), (yyvsp[-1].perm_strings)); }
#line 7693 "parse.cc" /* yacc.c:1646  */
    break;

  case 359:
#line 2426 "parse.y" /* yacc.c:1646  */
    { pform_start_generate_for((yylsp[-11]), (yyvsp[-9].text), (yyvsp[-7].expr), (yyvsp[-5].expr), (yyvsp[-3].text), (yyvsp[-1].expr)); }
#line 7699 "parse.cc" /* yacc.c:1646  */
    break;

  case 360:
#line 2428 "parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 7705 "parse.cc" /* yacc.c:1646  */
    break;

  case 361:
#line 2433 "parse.y" /* yacc.c:1646  */
    { pform_start_generate_else((yylsp[-2])); }
#line 7711 "parse.cc" /* yacc.c:1646  */
    break;

  case 362:
#line 2435 "parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 7717 "parse.cc" /* yacc.c:1646  */
    break;

  case 363:
#line 2439 "parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 7723 "parse.cc" /* yacc.c:1646  */
    break;

  case 364:
#line 2442 "parse.y" /* yacc.c:1646  */
    { pform_start_generate_case((yylsp[-3]), (yyvsp[-1].expr)); }
#line 7729 "parse.cc" /* yacc.c:1646  */
    break;

  case 365:
#line 2445 "parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 7735 "parse.cc" /* yacc.c:1646  */
    break;

  case 366:
#line 2449 "parse.y" /* yacc.c:1646  */
    { /* Detect and warn about anachronistic begin/end use */
	if (generation_flag > GN_VER2001) {
	      warn_count += 1;
	      cerr << (yylsp[-3]) << ": warning: Anachronistic use of begin/end to surround generate schemes." << endl;
	}
      }
#line 7746 "parse.cc" /* yacc.c:1646  */
    break;

  case 367:
#line 2455 "parse.y" /* yacc.c:1646  */
    {
	pform_start_generate_nblock((yylsp[-2]), (yyvsp[0].text));
      }
#line 7754 "parse.cc" /* yacc.c:1646  */
    break;

  case 368:
#line 2458 "parse.y" /* yacc.c:1646  */
    { /* Detect and warn about anachronistic named begin/end use */
	if (generation_flag > GN_VER2001) {
	      warn_count += 1;
	      cerr << (yylsp[-6]) << ": warning: Anachronistic use of named begin/end to surround generate schemes." << endl;
	}
	pform_endgenerate();
      }
#line 7766 "parse.cc" /* yacc.c:1646  */
    break;

  case 369:
#line 2469 "parse.y" /* yacc.c:1646  */
    { /* empty lists are legal syntax. */ }
#line 7772 "parse.cc" /* yacc.c:1646  */
    break;

  case 370:
#line 2472 "parse.y" /* yacc.c:1646  */
    {
		}
#line 7779 "parse.cc" /* yacc.c:1646  */
    break;

  case 371:
#line 2476 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in specify block");
		  yyerrok;
		}
#line 7787 "parse.cc" /* yacc.c:1646  */
    break;

  case 372:
#line 2485 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: missing endmodule or attempt to "
		              "nest modules.");
		  pform_error_nested_modules();
		  yyerrok;
		}
#line 7797 "parse.cc" /* yacc.c:1646  */
    break;

  case 373:
#line 2492 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[0]), "error: invalid module item.");
		  yyerrok;
		}
#line 7805 "parse.cc" /* yacc.c:1646  */
    break;

  case 374:
#line 2497 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-4]), "error: syntax error in left side "
			  "of continuous assignment.");
		  yyerrok;
		}
#line 7814 "parse.cc" /* yacc.c:1646  */
    break;

  case 375:
#line 2503 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: syntax error in "
			  "continuous assignment");
		  yyerrok;
		}
#line 7823 "parse.cc" /* yacc.c:1646  */
    break;

  case 376:
#line 2509 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: I give up on this "
			  "function definition.");
		  yyerrok;
		}
#line 7832 "parse.cc" /* yacc.c:1646  */
    break;

  case 377:
#line 2518 "parse.y" /* yacc.c:1646  */
    { perm_string tmp3 = lex_strings.make((yyvsp[-6].text));
		  perm_string tmp5 = lex_strings.make((yyvsp[-4].text));
		  pform_set_attrib(tmp3, tmp5, (yyvsp[-2].text));
		  delete[] (yyvsp[-6].text);
		  delete[] (yyvsp[-4].text);
		}
#line 7843 "parse.cc" /* yacc.c:1646  */
    break;

  case 378:
#line 2525 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-4]), "error: Malformed $attribute parameter list."); }
#line 7849 "parse.cc" /* yacc.c:1646  */
    break;

  case 379:
#line 2529 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 7855 "parse.cc" /* yacc.c:1646  */
    break;

  case 380:
#line 2530 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false;}
#line 7861 "parse.cc" /* yacc.c:1646  */
    break;

  case 381:
#line 2533 "parse.y" /* yacc.c:1646  */
    { pform_start_generate_if((yylsp[-3]), (yyvsp[-1].expr)); }
#line 7867 "parse.cc" /* yacc.c:1646  */
    break;

  case 384:
#line 2541 "parse.y" /* yacc.c:1646  */
    { pform_generate_case_item((yylsp[-1]), (yyvsp[-1].exprs)); }
#line 7873 "parse.cc" /* yacc.c:1646  */
    break;

  case 385:
#line 2542 "parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 7879 "parse.cc" /* yacc.c:1646  */
    break;

  case 386:
#line 2543 "parse.y" /* yacc.c:1646  */
    { pform_generate_case_item((yylsp[-1]), 0); }
#line 7885 "parse.cc" /* yacc.c:1646  */
    break;

  case 387:
#line 2544 "parse.y" /* yacc.c:1646  */
    { pform_endgenerate(); }
#line 7891 "parse.cc" /* yacc.c:1646  */
    break;

  case 394:
#line 2567 "parse.y" /* yacc.c:1646  */
    { pform_generate_block_name((yyvsp[-2].text)); }
#line 7897 "parse.cc" /* yacc.c:1646  */
    break;

  case 397:
#line 2582 "parse.y" /* yacc.c:1646  */
    { net_decl_assign_t*tmp = new net_decl_assign_t;
	tmp->next = tmp;
	tmp->name = lex_strings.make((yyvsp[-2].text));
	tmp->expr = (yyvsp[0].expr);
	delete[](yyvsp[-2].text);
	(yyval.net_decl_assign) = tmp;
      }
#line 7909 "parse.cc" /* yacc.c:1646  */
    break;

  case 398:
#line 2593 "parse.y" /* yacc.c:1646  */
    { net_decl_assign_t*tmp = (yyvsp[-2].net_decl_assign);
		  (yyvsp[0].net_decl_assign)->next = tmp->next;
		  tmp->next = (yyvsp[0].net_decl_assign);
		  (yyval.net_decl_assign) = tmp;
		}
#line 7919 "parse.cc" /* yacc.c:1646  */
    break;

  case 399:
#line 2599 "parse.y" /* yacc.c:1646  */
    { (yyval.net_decl_assign) = (yyvsp[0].net_decl_assign);
		}
#line 7926 "parse.cc" /* yacc.c:1646  */
    break;

  case 400:
#line 2604 "parse.y" /* yacc.c:1646  */
    { (yyval.datatype) = IVL_VT_LOGIC; }
#line 7932 "parse.cc" /* yacc.c:1646  */
    break;

  case 401:
#line 2605 "parse.y" /* yacc.c:1646  */
    { (yyval.datatype) = IVL_VT_BOOL; }
#line 7938 "parse.cc" /* yacc.c:1646  */
    break;

  case 402:
#line 2606 "parse.y" /* yacc.c:1646  */
    { (yyval.datatype) = IVL_VT_REAL; }
#line 7944 "parse.cc" /* yacc.c:1646  */
    break;

  case 403:
#line 2609 "parse.y" /* yacc.c:1646  */
    { (yyval.datatype) = (yyvsp[0].datatype); }
#line 7950 "parse.cc" /* yacc.c:1646  */
    break;

  case 404:
#line 2609 "parse.y" /* yacc.c:1646  */
    { (yyval.datatype) = IVL_VT_NO_TYPE; }
#line 7956 "parse.cc" /* yacc.c:1646  */
    break;

  case 405:
#line 2612 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::WIRE; }
#line 7962 "parse.cc" /* yacc.c:1646  */
    break;

  case 406:
#line 2613 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::TRI; }
#line 7968 "parse.cc" /* yacc.c:1646  */
    break;

  case 407:
#line 2614 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::TRI1; }
#line 7974 "parse.cc" /* yacc.c:1646  */
    break;

  case 408:
#line 2615 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::SUPPLY0; }
#line 7980 "parse.cc" /* yacc.c:1646  */
    break;

  case 409:
#line 2616 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::WAND; }
#line 7986 "parse.cc" /* yacc.c:1646  */
    break;

  case 410:
#line 2617 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::TRIAND; }
#line 7992 "parse.cc" /* yacc.c:1646  */
    break;

  case 411:
#line 2618 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::TRI0; }
#line 7998 "parse.cc" /* yacc.c:1646  */
    break;

  case 412:
#line 2619 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::SUPPLY1; }
#line 8004 "parse.cc" /* yacc.c:1646  */
    break;

  case 413:
#line 2620 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::WOR; }
#line 8010 "parse.cc" /* yacc.c:1646  */
    break;

  case 414:
#line 2621 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::TRIOR; }
#line 8016 "parse.cc" /* yacc.c:1646  */
    break;

  case 415:
#line 2622 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::UWIRE;
		      cerr << (yylsp[0]).text << ":" << (yylsp[0]).first_line << ": warning: "
		              "'wone' is deprecated, please use 'uwire' "
		              "instead." << endl;
		    }
#line 8026 "parse.cc" /* yacc.c:1646  */
    break;

  case 416:
#line 2627 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::UWIRE; }
#line 8032 "parse.cc" /* yacc.c:1646  */
    break;

  case 417:
#line 2631 "parse.y" /* yacc.c:1646  */
    { (yyval.nettype) = NetNet::REG; }
#line 8038 "parse.cc" /* yacc.c:1646  */
    break;

  case 418:
#line 2636 "parse.y" /* yacc.c:1646  */
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8047 "parse.cc" /* yacc.c:1646  */
    break;

  case 419:
#line 2641 "parse.y" /* yacc.c:1646  */
    { param_active_range = (yyvsp[0].exprs);
        param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8056 "parse.cc" /* yacc.c:1646  */
    break;

  case 420:
#line 2646 "parse.y" /* yacc.c:1646  */
    { param_active_range = 0;
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8065 "parse.cc" /* yacc.c:1646  */
    break;

  case 421:
#line 2651 "parse.y" /* yacc.c:1646  */
    { param_active_range = (yyvsp[0].exprs);
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8074 "parse.cc" /* yacc.c:1646  */
    break;

  case 422:
#line 2656 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
        PExpr*re;
        re = new PENumber(new verinum(integer_width-1, integer_width));
        (*range_stub)[0] = re;
        re = new PENumber(new verinum((uint64_t)0, integer_width));
        (*range_stub)[1] = re;
        /* The default range is [31:0] */
        param_active_range = range_stub;
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8090 "parse.cc" /* yacc.c:1646  */
    break;

  case 423:
#line 2668 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
        PExpr*re;
        re = new PENumber(new verinum((uint64_t)63, integer_width));
        (*range_stub)[0] = re;
        re = new PENumber(new verinum((uint64_t)0, integer_width));
        (*range_stub)[1] = re;
        /* The range is [63:0] */
        param_active_range = range_stub;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
#line 8106 "parse.cc" /* yacc.c:1646  */
    break;

  case 424:
#line 2680 "parse.y" /* yacc.c:1646  */
    { param_active_range = 0;
	param_active_signed = true;
	param_active_type = IVL_VT_REAL;
      }
#line 8115 "parse.cc" /* yacc.c:1646  */
    break;

  case 429:
#line 2703 "parse.y" /* yacc.c:1646  */
    { PExpr*tmp = (yyvsp[-1].expr);
	pform_set_parameter((yylsp[-3]), lex_strings.make((yyvsp[-3].text)), param_active_type,
			    param_active_signed, param_active_range, tmp, (yyvsp[0].value_range));
	delete[](yyvsp[-3].text);
      }
#line 8125 "parse.cc" /* yacc.c:1646  */
    break;

  case 430:
#line 2712 "parse.y" /* yacc.c:1646  */
    { PExpr*tmp = (yyvsp[0].expr);
	pform_set_localparam((yylsp[-2]), lex_strings.make((yyvsp[-2].text)), param_active_type,
			     param_active_signed, param_active_range, tmp);
	delete[](yyvsp[-2].text);
      }
#line 8135 "parse.cc" /* yacc.c:1646  */
    break;

  case 431:
#line 2719 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = (yyvsp[0].value_range); }
#line 8141 "parse.cc" /* yacc.c:1646  */
    break;

  case 432:
#line 2719 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = 0; }
#line 8147 "parse.cc" /* yacc.c:1646  */
    break;

  case 433:
#line 2723 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = (yyvsp[0].value_range); (yyval.value_range)->next = (yyvsp[-1].value_range); }
#line 8153 "parse.cc" /* yacc.c:1646  */
    break;

  case 434:
#line 2725 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = (yyvsp[0].value_range); (yyval.value_range)->next = 0; }
#line 8159 "parse.cc" /* yacc.c:1646  */
    break;

  case 435:
#line 2730 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[-5].flag), false, (yyvsp[-3].expr), false, (yyvsp[-1].expr)); }
#line 8165 "parse.cc" /* yacc.c:1646  */
    break;

  case 436:
#line 2732 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[-5].flag), false, (yyvsp[-3].expr), true, (yyvsp[-1].expr)); }
#line 8171 "parse.cc" /* yacc.c:1646  */
    break;

  case 437:
#line 2734 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[-5].flag), true, (yyvsp[-3].expr), false, (yyvsp[-1].expr)); }
#line 8177 "parse.cc" /* yacc.c:1646  */
    break;

  case 438:
#line 2736 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[-5].flag), true, (yyvsp[-3].expr), true, (yyvsp[-1].expr)); }
#line 8183 "parse.cc" /* yacc.c:1646  */
    break;

  case 439:
#line 2738 "parse.y" /* yacc.c:1646  */
    { (yyval.value_range) = pform_parameter_value_range(true, false, (yyvsp[0].expr), false, (yyvsp[0].expr)); }
#line 8189 "parse.cc" /* yacc.c:1646  */
    break;

  case 440:
#line 2742 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 8195 "parse.cc" /* yacc.c:1646  */
    break;

  case 441:
#line 2743 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 8201 "parse.cc" /* yacc.c:1646  */
    break;

  case 442:
#line 2744 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 8207 "parse.cc" /* yacc.c:1646  */
    break;

  case 443:
#line 2745 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 8213 "parse.cc" /* yacc.c:1646  */
    break;

  case 444:
#line 2748 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 8219 "parse.cc" /* yacc.c:1646  */
    break;

  case 445:
#line 2748 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 8225 "parse.cc" /* yacc.c:1646  */
    break;

  case 446:
#line 2768 "parse.y" /* yacc.c:1646  */
    { struct parmvalue_t*tmp = new struct parmvalue_t;
		  tmp->by_order = (yyvsp[-1].exprs);
		  tmp->by_name = 0;
		  (yyval.parmvalue) = tmp;
		}
#line 8235 "parse.cc" /* yacc.c:1646  */
    break;

  case 447:
#line 2774 "parse.y" /* yacc.c:1646  */
    { struct parmvalue_t*tmp = new struct parmvalue_t;
		  tmp->by_order = 0;
		  tmp->by_name = (yyvsp[-1].named_pexprs);
		  (yyval.parmvalue) = tmp;
		}
#line 8245 "parse.cc" /* yacc.c:1646  */
    break;

  case 448:
#line 2780 "parse.y" /* yacc.c:1646  */
    { assert((yyvsp[0].number));
		  PENumber*tmp = new PENumber((yyvsp[0].number));
		  FILE_NAME(tmp, (yylsp[-1]));

		  struct parmvalue_t*lst = new struct parmvalue_t;
		  lst->by_order = new svector<PExpr*>(1);
		  (*lst->by_order)[0] = tmp;
		  lst->by_name = 0;
		  (yyval.parmvalue) = lst;
		  based_size = 0;
		}
#line 8261 "parse.cc" /* yacc.c:1646  */
    break;

  case 449:
#line 2792 "parse.y" /* yacc.c:1646  */
    { assert((yyvsp[0].realtime));
		  PEFNumber*tmp = new PEFNumber((yyvsp[0].realtime));
		  FILE_NAME(tmp, (yylsp[-1]));

		  struct parmvalue_t*lst = new struct parmvalue_t;
		  lst->by_order = new svector<PExpr*>(1);
		  (*lst->by_order)[0] = tmp;
		  lst->by_name = 0;
		  (yyval.parmvalue) = lst;
		}
#line 8276 "parse.cc" /* yacc.c:1646  */
    break;

  case 450:
#line 2803 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-1]), "error: syntax error in parameter value "
			  "assignment list.");
		  (yyval.parmvalue) = 0;
		}
#line 8285 "parse.cc" /* yacc.c:1646  */
    break;

  case 451:
#line 2808 "parse.y" /* yacc.c:1646  */
    { (yyval.parmvalue) = 0; }
#line 8291 "parse.cc" /* yacc.c:1646  */
    break;

  case 452:
#line 2813 "parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[-3].text));
		  tmp->parm = (yyvsp[-1].expr);
		  delete[](yyvsp[-3].text);
		  (yyval.named_pexpr) = tmp;
		}
#line 8302 "parse.cc" /* yacc.c:1646  */
    break;

  case 453:
#line 2820 "parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[-2].text));
		  tmp->parm = 0;
		  delete[](yyvsp[-2].text);
		  (yyval.named_pexpr) = tmp;
		}
#line 8313 "parse.cc" /* yacc.c:1646  */
    break;

  case 454:
#line 2830 "parse.y" /* yacc.c:1646  */
    { svector<named_pexpr_t*>*tmp = new svector<named_pexpr_t*>(1);
		  (*tmp)[0] = (yyvsp[0].named_pexpr);
		  (yyval.named_pexprs) = tmp;
		}
#line 8322 "parse.cc" /* yacc.c:1646  */
    break;

  case 455:
#line 2835 "parse.y" /* yacc.c:1646  */
    { svector<named_pexpr_t*>*tmp =
			new svector<named_pexpr_t*>(*(yyvsp[-2].named_pexprs),(yyvsp[0].named_pexpr));
		  delete (yyvsp[-2].named_pexprs);
		  (yyval.named_pexprs) = tmp;
		}
#line 8332 "parse.cc" /* yacc.c:1646  */
    break;

  case 456:
#line 2858 "parse.y" /* yacc.c:1646  */
    { (yyval.mport) = (yyvsp[0].mport); }
#line 8338 "parse.cc" /* yacc.c:1646  */
    break;

  case 457:
#line 2866 "parse.y" /* yacc.c:1646  */
    { Module::port_t*tmp = (yyvsp[-1].mport);
		  tmp->name = lex_strings.make((yyvsp[-3].text));
		  delete[](yyvsp[-3].text);
		  (yyval.mport) = tmp;
		}
#line 8348 "parse.cc" /* yacc.c:1646  */
    break;

  case 458:
#line 2877 "parse.y" /* yacc.c:1646  */
    { Module::port_t*tmp = (yyvsp[-1].mport);
		  tmp->name = perm_string();
		  (yyval.mport) = tmp;
		}
#line 8357 "parse.cc" /* yacc.c:1646  */
    break;

  case 459:
#line 2886 "parse.y" /* yacc.c:1646  */
    { Module::port_t*tmp = (yyvsp[-2].mport);
		  tmp->name = lex_strings.make((yyvsp[-5].text));
		  delete[](yyvsp[-5].text);
		  (yyval.mport) = tmp;
		}
#line 8367 "parse.cc" /* yacc.c:1646  */
    break;

  case 460:
#line 2894 "parse.y" /* yacc.c:1646  */
    { (yyval.mport) = (yyvsp[0].mport); }
#line 8373 "parse.cc" /* yacc.c:1646  */
    break;

  case 461:
#line 2895 "parse.y" /* yacc.c:1646  */
    { (yyval.mport) = 0; }
#line 8379 "parse.cc" /* yacc.c:1646  */
    break;

  case 462:
#line 2912 "parse.y" /* yacc.c:1646  */
    { Module::port_t*ptmp;
	  perm_string name = lex_strings.make((yyvsp[0].text));
	  ptmp = pform_module_port_reference(name, (yylsp[0]).text, (yylsp[0]).first_line);
	  delete[](yyvsp[0].text);
	  (yyval.mport) = ptmp;
	}
#line 8390 "parse.cc" /* yacc.c:1646  */
    break;

  case 463:
#line 2920 "parse.y" /* yacc.c:1646  */
    { index_component_t itmp;
	  itmp.sel = index_component_t::SEL_PART;
	  itmp.msb = (yyvsp[-3].expr);
	  itmp.lsb = (yyvsp[-1].expr);

	  name_component_t ntmp (lex_strings.make((yyvsp[-5].text)));
	  ntmp.index.push_back(itmp);

	  pform_name_t pname;
	  pname.push_back(ntmp);

	  PEIdent*wtmp = new PEIdent(pname);
	  FILE_NAME(wtmp, (yylsp[-5]));

	  Module::port_t*ptmp = new Module::port_t;
	  ptmp->name = perm_string();
	  ptmp->expr.push_back(wtmp);

	  delete[](yyvsp[-5].text);
	  (yyval.mport) = ptmp;
	}
#line 8416 "parse.cc" /* yacc.c:1646  */
    break;

  case 464:
#line 2943 "parse.y" /* yacc.c:1646  */
    { index_component_t itmp;
	  itmp.sel = index_component_t::SEL_BIT;
	  itmp.msb = (yyvsp[-1].expr);
	  itmp.lsb = 0;

	  name_component_t ntmp (lex_strings.make((yyvsp[-3].text)));
	  ntmp.index.push_back(itmp);

	  pform_name_t pname;
	  pname.push_back(ntmp);

	  PEIdent*tmp = new PEIdent(pname);
	  FILE_NAME(tmp, (yylsp[-3]));

	  Module::port_t*ptmp = new Module::port_t;
	  ptmp->name = perm_string();
	  ptmp->expr.push_back(tmp);
	  delete[](yyvsp[-3].text);
	  (yyval.mport) = ptmp;
	}
#line 8441 "parse.cc" /* yacc.c:1646  */
    break;

  case 465:
#line 2965 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-3]), "error: invalid port bit select");
	  Module::port_t*ptmp = new Module::port_t;
	  PEIdent*wtmp = new PEIdent(lex_strings.make((yyvsp[-3].text)));
	  FILE_NAME(wtmp, (yylsp[-3]));
	  ptmp->name = lex_strings.make((yyvsp[-3].text));
	  ptmp->expr.push_back(wtmp);
	  delete[](yyvsp[-3].text);
	  (yyval.mport) = ptmp;
	}
#line 8455 "parse.cc" /* yacc.c:1646  */
    break;

  case 466:
#line 2979 "parse.y" /* yacc.c:1646  */
    { (yyval.mport) = (yyvsp[0].mport); }
#line 8461 "parse.cc" /* yacc.c:1646  */
    break;

  case 467:
#line 2981 "parse.y" /* yacc.c:1646  */
    { Module::port_t*tmp = (yyvsp[-2].mport);
		  append(tmp->expr, (yyvsp[0].mport)->expr);
		  delete (yyvsp[0].mport);
		  (yyval.mport) = tmp;
		}
#line 8471 "parse.cc" /* yacc.c:1646  */
    break;

  case 468:
#line 2994 "parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[-3].text));
		  tmp->parm = (yyvsp[-1].expr);
		  delete[](yyvsp[-3].text);
		  (yyval.named_pexpr) = tmp;
		}
#line 8482 "parse.cc" /* yacc.c:1646  */
    break;

  case 469:
#line 3001 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "error: invalid port connection expression.");
		  named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[-3].text));
		  tmp->parm = 0;
		  delete[](yyvsp[-3].text);
		  (yyval.named_pexpr) = tmp;
		}
#line 8494 "parse.cc" /* yacc.c:1646  */
    break;

  case 470:
#line 3009 "parse.y" /* yacc.c:1646  */
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[-2].text));
		  tmp->parm = 0;
		  delete[](yyvsp[-2].text);
		  (yyval.named_pexpr) = tmp;
		}
#line 8505 "parse.cc" /* yacc.c:1646  */
    break;

  case 471:
#line 3019 "parse.y" /* yacc.c:1646  */
    { svector<named_pexpr_t*>*tmp;
		  tmp = new svector<named_pexpr_t*>(*(yyvsp[-2].named_pexprs), (yyvsp[0].named_pexpr));
		  delete (yyvsp[-2].named_pexprs);
		  (yyval.named_pexprs) = tmp;
		}
#line 8515 "parse.cc" /* yacc.c:1646  */
    break;

  case 472:
#line 3025 "parse.y" /* yacc.c:1646  */
    { svector<named_pexpr_t*>*tmp = new svector<named_pexpr_t*>(1);
		  (*tmp)[0] = (yyvsp[0].named_pexpr);
		  (yyval.named_pexprs) = tmp;
		}
#line 8524 "parse.cc" /* yacc.c:1646  */
    break;

  case 473:
#line 3032 "parse.y" /* yacc.c:1646  */
    { (yyval.porttype) = NetNet::PINPUT; }
#line 8530 "parse.cc" /* yacc.c:1646  */
    break;

  case 474:
#line 3033 "parse.y" /* yacc.c:1646  */
    { (yyval.porttype) = NetNet::POUTPUT; }
#line 8536 "parse.cc" /* yacc.c:1646  */
    break;

  case 475:
#line 3034 "parse.y" /* yacc.c:1646  */
    { (yyval.porttype) = NetNet::PINOUT; }
#line 8542 "parse.cc" /* yacc.c:1646  */
    break;

  case 476:
#line 3039 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*> (2);
		  (*tmp)[0] = (yyvsp[-3].expr);
		  (*tmp)[1] = (yyvsp[-1].expr);
		  (yyval.exprs) = tmp;
		}
#line 8552 "parse.cc" /* yacc.c:1646  */
    break;

  case 478:
#line 3048 "parse.y" /* yacc.c:1646  */
    { (yyval.exprs) = 0; }
#line 8558 "parse.cc" /* yacc.c:1646  */
    break;

  case 479:
#line 3051 "parse.y" /* yacc.c:1646  */
    { (yyval.dimensions) = 0; }
#line 8564 "parse.cc" /* yacc.c:1646  */
    break;

  case 480:
#line 3052 "parse.y" /* yacc.c:1646  */
    { (yyval.dimensions) = (yyvsp[0].dimensions); }
#line 8570 "parse.cc" /* yacc.c:1646  */
    break;

  case 481:
#line 3057 "parse.y" /* yacc.c:1646  */
    { list<index_component_t> *tmp = new list<index_component_t>;
		  index_component_t index;
		  index.msb = (yyvsp[-3].expr);
		  index.lsb = (yyvsp[-1].expr);
		  tmp->push_back(index);
		  (yyval.dimensions) = tmp;
		}
#line 8582 "parse.cc" /* yacc.c:1646  */
    break;

  case 482:
#line 3065 "parse.y" /* yacc.c:1646  */
    { list<index_component_t> *tmp = (yyvsp[-5].dimensions);
		  index_component_t index;
		  index.msb = (yyvsp[-3].expr);
		  index.lsb = (yyvsp[-1].expr);
		  tmp->push_back(index);
		  (yyval.dimensions) = tmp;
		}
#line 8594 "parse.cc" /* yacc.c:1646  */
    break;

  case 483:
#line 3076 "parse.y" /* yacc.c:1646  */
    { (yyval.function_type).range = (yyvsp[0].exprs); (yyval.function_type).type = PTF_REG; }
#line 8600 "parse.cc" /* yacc.c:1646  */
    break;

  case 484:
#line 3077 "parse.y" /* yacc.c:1646  */
    { (yyval.function_type).range = (yyvsp[0].exprs); (yyval.function_type).type = PTF_REG_S; }
#line 8606 "parse.cc" /* yacc.c:1646  */
    break;

  case 485:
#line 3078 "parse.y" /* yacc.c:1646  */
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_INTEGER; }
#line 8612 "parse.cc" /* yacc.c:1646  */
    break;

  case 486:
#line 3079 "parse.y" /* yacc.c:1646  */
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_REAL; }
#line 8618 "parse.cc" /* yacc.c:1646  */
    break;

  case 487:
#line 3080 "parse.y" /* yacc.c:1646  */
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_REALTIME; }
#line 8624 "parse.cc" /* yacc.c:1646  */
    break;

  case 488:
#line 3081 "parse.y" /* yacc.c:1646  */
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_TIME; }
#line 8630 "parse.cc" /* yacc.c:1646  */
    break;

  case 489:
#line 3082 "parse.y" /* yacc.c:1646  */
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_REG; }
#line 8636 "parse.cc" /* yacc.c:1646  */
    break;

  case 490:
#line 3092 "parse.y" /* yacc.c:1646  */
    { perm_string ident_name = lex_strings.make((yyvsp[-1].text));
	pform_makewire((yylsp[-1]), ident_name, NetNet::REG,
		       NetNet::NOT_A_PORT, IVL_VT_NO_TYPE, 0);
	if ((yyvsp[0].dimensions) != 0) {
	      index_component_t index;
	      if ((yyvsp[0].dimensions)->size() > 1) {
		    yyerror((yylsp[0]), "sorry: only 1 dimensional arrays "
			    "are currently supported.");
	      }
	      index = (yyvsp[0].dimensions)->front();
	      pform_set_reg_idx(ident_name, index.msb, index.lsb);
	      delete (yyvsp[0].dimensions);
	}
	(yyval.text) = (yyvsp[-1].text);
      }
#line 8656 "parse.cc" /* yacc.c:1646  */
    break;

  case 491:
#line 3108 "parse.y" /* yacc.c:1646  */
    { perm_string ident_name = lex_strings.make((yyvsp[-2].text));
	pform_makewire((yylsp[-2]), ident_name, NetNet::REG,
		       NetNet::NOT_A_PORT, IVL_VT_NO_TYPE, 0);
	pform_make_reginit((yylsp[-2]), ident_name, (yyvsp[0].expr));
	(yyval.text) = (yyvsp[-2].text);
      }
#line 8667 "parse.cc" /* yacc.c:1646  */
    break;

  case 492:
#line 3118 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 8677 "parse.cc" /* yacc.c:1646  */
    break;

  case 493:
#line 3124 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-2].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 8687 "parse.cc" /* yacc.c:1646  */
    break;

  case 494:
#line 3133 "parse.y" /* yacc.c:1646  */
    { perm_string name = lex_strings.make((yyvsp[-1].text));
        pform_makewire((yylsp[-1]), name, NetNet::REG, NetNet::NOT_A_PORT, IVL_VT_REAL, 0);
        if ((yyvsp[0].dimensions) != 0) {
	      index_component_t index;
	      if ((yyvsp[0].dimensions)->size() > 1) {
		    yyerror((yylsp[0]), "sorry: only 1 dimensional arrays "
			    "are currently supported.");
	      }
	      index = (yyvsp[0].dimensions)->front();
	      pform_set_reg_idx(name, index.msb, index.lsb);
	      delete (yyvsp[0].dimensions);
        }
	(yyval.text) = (yyvsp[-1].text);
      }
#line 8706 "parse.cc" /* yacc.c:1646  */
    break;

  case 495:
#line 3148 "parse.y" /* yacc.c:1646  */
    { perm_string name = lex_strings.make((yyvsp[-2].text));
	pform_makewire((yylsp[-2]), name, NetNet::REG, NetNet::NOT_A_PORT, IVL_VT_REAL, 0);
	pform_make_reginit((yylsp[-2]), name, (yyvsp[0].expr));
	(yyval.text) = (yyvsp[-2].text);
      }
#line 8716 "parse.cc" /* yacc.c:1646  */
    break;

  case 496:
#line 3157 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
	tmp->push_back(lex_strings.make((yyvsp[0].text)));
	(yyval.perm_strings) = tmp;
	delete[](yyvsp[0].text);
      }
#line 8726 "parse.cc" /* yacc.c:1646  */
    break;

  case 497:
#line 3163 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-2].perm_strings);
	tmp->push_back(lex_strings.make((yyvsp[0].text)));
	(yyval.perm_strings) = tmp;
	delete[](yyvsp[0].text);
      }
#line 8736 "parse.cc" /* yacc.c:1646  */
    break;

  case 498:
#line 3172 "parse.y" /* yacc.c:1646  */
    { perm_string name = lex_strings.make((yyvsp[-1].text));
	pform_makewire((yylsp[-1]), name, NetNet::IMPLICIT,
		       NetNet::NOT_A_PORT, IVL_VT_NO_TYPE, 0);
	if ((yyvsp[0].dimensions) != 0) {
	      index_component_t index;
	      if ((yyvsp[0].dimensions)->size() > 1) {
		    yyerror((yylsp[0]), "sorry: only 1 dimensional arrays "
			    "are currently supported.");
	      }
	      index = (yyvsp[0].dimensions)->front();
	      pform_set_reg_idx(name, index.msb, index.lsb);
	      delete (yyvsp[0].dimensions);
	}
	(yyval.text) = (yyvsp[-1].text);
      }
#line 8756 "parse.cc" /* yacc.c:1646  */
    break;

  case 499:
#line 3191 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 8766 "parse.cc" /* yacc.c:1646  */
    break;

  case 500:
#line 3197 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-2].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 8776 "parse.cc" /* yacc.c:1646  */
    break;

  case 502:
#line 3207 "parse.y" /* yacc.c:1646  */
    { pform_module_specify_path((yyvsp[-1].specpath));
		}
#line 8783 "parse.cc" /* yacc.c:1646  */
    break;

  case 503:
#line 3210 "parse.y" /* yacc.c:1646  */
    { pform_module_specify_path((yyvsp[-1].specpath));
		}
#line 8790 "parse.cc" /* yacc.c:1646  */
    break;

  case 504:
#line 3213 "parse.y" /* yacc.c:1646  */
    { PSpecPath*tmp = (yyvsp[-1].specpath);
		  if (tmp) {
			tmp->conditional = true;
			tmp->condition = (yyvsp[-3].expr);
		  }
		  pform_module_specify_path(tmp);
		}
#line 8802 "parse.cc" /* yacc.c:1646  */
    break;

  case 505:
#line 3221 "parse.y" /* yacc.c:1646  */
    { PSpecPath*tmp = (yyvsp[-1].specpath);
		  if (tmp) {
			tmp->conditional = true;
			tmp->condition = (yyvsp[-3].expr);
		  }
		  pform_module_specify_path(tmp);
		}
#line 8814 "parse.cc" /* yacc.c:1646  */
    break;

  case 506:
#line 3229 "parse.y" /* yacc.c:1646  */
    { PSpecPath*tmp = (yyvsp[-1].specpath);
		  if (tmp) {
			tmp->conditional = true;
			tmp->condition = 0;
		  }
		  pform_module_specify_path(tmp);
		}
#line 8826 "parse.cc" /* yacc.c:1646  */
    break;

  case 507:
#line 3237 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "Sorry: ifnone with an edge-sensitive path is "
		              "not supported.");
		  yyerrok;
		}
#line 8835 "parse.cc" /* yacc.c:1646  */
    break;

  case 508:
#line 3243 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-5].expr);
		  delete (yyvsp[-3].expr);
		}
#line 8843 "parse.cc" /* yacc.c:1646  */
    break;

  case 509:
#line 3248 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 8850 "parse.cc" /* yacc.c:1646  */
    break;

  case 510:
#line 3252 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-5].expr);
		  delete (yyvsp[-3].expr);
		}
#line 8858 "parse.cc" /* yacc.c:1646  */
    break;

  case 511:
#line 3257 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 8865 "parse.cc" /* yacc.c:1646  */
    break;

  case 512:
#line 3261 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 8872 "parse.cc" /* yacc.c:1646  */
    break;

  case 513:
#line 3265 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-5].expr);
		  delete (yyvsp[-3].expr);
		}
#line 8880 "parse.cc" /* yacc.c:1646  */
    break;

  case 514:
#line 3270 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 8887 "parse.cc" /* yacc.c:1646  */
    break;

  case 515:
#line 3274 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 8894 "parse.cc" /* yacc.c:1646  */
    break;

  case 516:
#line 3278 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-5].expr);
		  delete (yyvsp[-3].expr);
		}
#line 8902 "parse.cc" /* yacc.c:1646  */
    break;

  case 517:
#line 3283 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 8909 "parse.cc" /* yacc.c:1646  */
    break;

  case 518:
#line 3287 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-3].expr);
		}
#line 8916 "parse.cc" /* yacc.c:1646  */
    break;

  case 519:
#line 3291 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-5].expr);
		  delete (yyvsp[-3].expr);
		}
#line 8924 "parse.cc" /* yacc.c:1646  */
    break;

  case 520:
#line 3295 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-2].expr);
		}
#line 8931 "parse.cc" /* yacc.c:1646  */
    break;

  case 521:
#line 3298 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings);
		}
#line 8938 "parse.cc" /* yacc.c:1646  */
    break;

  case 522:
#line 3301 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings);
		}
#line 8945 "parse.cc" /* yacc.c:1646  */
    break;

  case 523:
#line 3304 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings);
		}
#line 8952 "parse.cc" /* yacc.c:1646  */
    break;

  case 524:
#line 3307 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-1].perm_strings);
		}
#line 8959 "parse.cc" /* yacc.c:1646  */
    break;

  case 527:
#line 3318 "parse.y" /* yacc.c:1646  */
    { (yyval.specpath) = pform_assign_path_delay((yyvsp[-4].specpath), (yyvsp[-1].exprs)); }
#line 8965 "parse.cc" /* yacc.c:1646  */
    break;

  case 528:
#line 3320 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[0].expr);
		  (yyval.specpath) = pform_assign_path_delay((yyvsp[-2].specpath), tmp);
		}
#line 8974 "parse.cc" /* yacc.c:1646  */
    break;

  case 529:
#line 3326 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 8980 "parse.cc" /* yacc.c:1646  */
    break;

  case 530:
#line 3326 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 8986 "parse.cc" /* yacc.c:1646  */
    break;

  case 531:
#line 3331 "parse.y" /* yacc.c:1646  */
    { int edge_flag = 0;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[-9]), edge_flag, (yyvsp[-8].perm_strings), (yyvsp[-7].letter), false, (yyvsp[-4].perm_strings), (yyvsp[-2].expr)); }
#line 8993 "parse.cc" /* yacc.c:1646  */
    break;

  case 532:
#line 3335 "parse.y" /* yacc.c:1646  */
    { int edge_flag = (yyvsp[-9].flag)? 1 : -1;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[-10]), edge_flag, (yyvsp[-8].perm_strings), (yyvsp[-7].letter), false, (yyvsp[-4].perm_strings), (yyvsp[-2].expr));}
#line 9000 "parse.cc" /* yacc.c:1646  */
    break;

  case 533:
#line 3339 "parse.y" /* yacc.c:1646  */
    { int edge_flag = 0;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[-9]), edge_flag, (yyvsp[-8].perm_strings), (yyvsp[-7].letter), true, (yyvsp[-4].perm_strings), (yyvsp[-2].expr)); }
#line 9007 "parse.cc" /* yacc.c:1646  */
    break;

  case 534:
#line 3343 "parse.y" /* yacc.c:1646  */
    { int edge_flag = (yyvsp[-9].flag)? 1 : -1;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[-10]), edge_flag, (yyvsp[-8].perm_strings), (yyvsp[-7].letter), true, (yyvsp[-4].perm_strings), (yyvsp[-2].expr)); }
#line 9014 "parse.cc" /* yacc.c:1646  */
    break;

  case 538:
#line 3355 "parse.y" /* yacc.c:1646  */
    { (yyval.specpath) = pform_assign_path_delay((yyvsp[-4].specpath), (yyvsp[-1].exprs)); }
#line 9020 "parse.cc" /* yacc.c:1646  */
    break;

  case 539:
#line 3357 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[0].expr);
		  (yyval.specpath) = pform_assign_path_delay((yyvsp[-2].specpath), tmp);
		}
#line 9029 "parse.cc" /* yacc.c:1646  */
    break;

  case 540:
#line 3362 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "Syntax error in delay value list.");
		  yyerrok;
		  (yyval.specpath) = 0;
		}
#line 9038 "parse.cc" /* yacc.c:1646  */
    break;

  case 541:
#line 3371 "parse.y" /* yacc.c:1646  */
    { (yyval.specpath) = pform_make_specify_path((yylsp[-5]), (yyvsp[-4].perm_strings), (yyvsp[-3].letter), false, (yyvsp[-1].perm_strings)); }
#line 9044 "parse.cc" /* yacc.c:1646  */
    break;

  case 542:
#line 3374 "parse.y" /* yacc.c:1646  */
    { (yyval.specpath) = pform_make_specify_path((yylsp[-5]), (yyvsp[-4].perm_strings), (yyvsp[-3].letter), true, (yyvsp[-1].perm_strings)); }
#line 9050 "parse.cc" /* yacc.c:1646  */
    break;

  case 543:
#line 3376 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "Invalid simple path");
		  yyerrok;
		}
#line 9058 "parse.cc" /* yacc.c:1646  */
    break;

  case 544:
#line 3383 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 9068 "parse.cc" /* yacc.c:1646  */
    break;

  case 545:
#line 3389 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[-3].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[-3].text);
		}
#line 9078 "parse.cc" /* yacc.c:1646  */
    break;

  case 546:
#line 3395 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-2].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 9088 "parse.cc" /* yacc.c:1646  */
    break;

  case 547:
#line 3401 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-5].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[-3].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[-3].text);
		}
#line 9098 "parse.cc" /* yacc.c:1646  */
    break;

  case 548:
#line 3410 "parse.y" /* yacc.c:1646  */
    { PExpr*tmp = (yyvsp[0].expr);
		  pform_set_specparam(lex_strings.make((yyvsp[-2].text)), tmp);
		  delete[](yyvsp[-2].text);
		}
#line 9107 "parse.cc" /* yacc.c:1646  */
    break;

  case 549:
#line 3415 "parse.y" /* yacc.c:1646  */
    { PExpr*tmp = 0;
		  switch (min_typ_max_flag) {
		      case MIN:
			tmp = (yyvsp[-4].expr);
			delete (yyvsp[-2].expr);
			delete (yyvsp[0].expr);
			break;
		      case TYP:
			delete (yyvsp[-4].expr);
			tmp = (yyvsp[-2].expr);
			delete (yyvsp[0].expr);
			break;
		      case MAX:
			delete (yyvsp[-4].expr);
			delete (yyvsp[-2].expr);
			tmp = (yyvsp[0].expr);
			break;
		  }
		  if (min_typ_max_warn > 0) {
		        cerr << tmp->get_fileline() << ": warning: choosing ";
		        switch (min_typ_max_flag) {
		            case MIN:
		              cerr << "min";
		              break;
		            case TYP:
		              cerr << "typ";
		              break;
		            case MAX:
		              cerr << "max";
		              break;
		        }
		        cerr << " expression." << endl;
		        min_typ_max_warn -= 1;
		  }
		  pform_set_specparam(lex_strings.make((yyvsp[-6].text)), tmp);
		  delete[](yyvsp[-6].text);
		}
#line 9149 "parse.cc" /* yacc.c:1646  */
    break;

  case 550:
#line 3453 "parse.y" /* yacc.c:1646  */
    { delete[](yyvsp[-2].text);
		  delete (yyvsp[0].expr);
		}
#line 9157 "parse.cc" /* yacc.c:1646  */
    break;

  case 551:
#line 3457 "parse.y" /* yacc.c:1646  */
    { delete[](yyvsp[-6].text);
		  delete (yyvsp[-3].expr);
		  delete (yyvsp[-1].expr);
		}
#line 9166 "parse.cc" /* yacc.c:1646  */
    break;

  case 554:
#line 3469 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '+'; }
#line 9172 "parse.cc" /* yacc.c:1646  */
    break;

  case 555:
#line 3470 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '-'; }
#line 9178 "parse.cc" /* yacc.c:1646  */
    break;

  case 556:
#line 3471 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 0;   }
#line 9184 "parse.cc" /* yacc.c:1646  */
    break;

  case 557:
#line 3476 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[0].expr); }
#line 9190 "parse.cc" /* yacc.c:1646  */
    break;

  case 558:
#line 3478 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[0].expr); }
#line 9196 "parse.cc" /* yacc.c:1646  */
    break;

  case 559:
#line 3480 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-2].expr);
      delete (yyvsp[0].expr);
    }
#line 9204 "parse.cc" /* yacc.c:1646  */
    break;

  case 560:
#line 3484 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-2].expr);
      delete (yyvsp[0].expr);
    }
#line 9212 "parse.cc" /* yacc.c:1646  */
    break;

  case 561:
#line 3488 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[0].expr); }
#line 9218 "parse.cc" /* yacc.c:1646  */
    break;

  case 562:
#line 3490 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-2].expr);
      delete (yyvsp[0].expr);
    }
#line 9226 "parse.cc" /* yacc.c:1646  */
    break;

  case 563:
#line 3494 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[-2].expr);
      delete (yyvsp[0].expr);
    }
#line 9234 "parse.cc" /* yacc.c:1646  */
    break;

  case 564:
#line 3498 "parse.y" /* yacc.c:1646  */
    { delete (yyvsp[0].expr); }
#line 9240 "parse.cc" /* yacc.c:1646  */
    break;

  case 567:
#line 3512 "parse.y" /* yacc.c:1646  */
    {  }
#line 9246 "parse.cc" /* yacc.c:1646  */
    break;

  case 568:
#line 3514 "parse.y" /* yacc.c:1646  */
    {  }
#line 9252 "parse.cc" /* yacc.c:1646  */
    break;

  case 569:
#line 3518 "parse.y" /* yacc.c:1646  */
    { args_after_notifier = 0; }
#line 9258 "parse.cc" /* yacc.c:1646  */
    break;

  case 570:
#line 3520 "parse.y" /* yacc.c:1646  */
    { args_after_notifier = 0; delete (yyvsp[0].pform_name); }
#line 9264 "parse.cc" /* yacc.c:1646  */
    break;

  case 571:
#line 3522 "parse.y" /* yacc.c:1646  */
    {  args_after_notifier += 1; }
#line 9270 "parse.cc" /* yacc.c:1646  */
    break;

  case 572:
#line 3524 "parse.y" /* yacc.c:1646  */
    { args_after_notifier += 1;
		  if (args_after_notifier >= 3)  {
                    cerr << (yylsp[0]) << ": warning: timing checks are not supported "
		                  "and delayed signal \"" << *(yyvsp[0].pform_name)
		         << "\" will not be driven." << endl;
		  }
                  delete (yyvsp[0].pform_name); }
#line 9282 "parse.cc" /* yacc.c:1646  */
    break;

  case 573:
#line 3533 "parse.y" /* yacc.c:1646  */
    { args_after_notifier = 0; delete[](yyvsp[0].text); }
#line 9288 "parse.cc" /* yacc.c:1646  */
    break;

  case 574:
#line 3545 "parse.y" /* yacc.c:1646  */
    { PCAssign*tmp = new PCAssign((yyvsp[-3].expr), (yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9297 "parse.cc" /* yacc.c:1646  */
    break;

  case 575:
#line 3551 "parse.y" /* yacc.c:1646  */
    { PDeassign*tmp = new PDeassign((yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-2]));
		  (yyval.statement) = tmp;
		}
#line 9306 "parse.cc" /* yacc.c:1646  */
    break;

  case 576:
#line 3561 "parse.y" /* yacc.c:1646  */
    { PForce*tmp = new PForce((yyvsp[-3].expr), (yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9315 "parse.cc" /* yacc.c:1646  */
    break;

  case 577:
#line 3566 "parse.y" /* yacc.c:1646  */
    { PRelease*tmp = new PRelease((yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-2]));
		  (yyval.statement) = tmp;
		}
#line 9324 "parse.cc" /* yacc.c:1646  */
    break;

  case 578:
#line 3578 "parse.y" /* yacc.c:1646  */
    { PBlock*tmp = new PBlock(PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[-1]));
	(yyval.statement) = tmp;
      }
#line 9333 "parse.cc" /* yacc.c:1646  */
    break;

  case 579:
#line 3583 "parse.y" /* yacc.c:1646  */
    { PBlock*tmp = new PBlock(PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[-2]));
	tmp->set_statement(*(yyvsp[-1].statement_list));
	delete (yyvsp[-1].statement_list);
	(yyval.statement) = tmp;
      }
#line 9344 "parse.cc" /* yacc.c:1646  */
    break;

  case 580:
#line 3590 "parse.y" /* yacc.c:1646  */
    { PBlock*tmp = pform_push_block_scope((yyvsp[0].text), PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[-2]));
	current_block_stack.push(tmp);
      }
#line 9353 "parse.cc" /* yacc.c:1646  */
    break;

  case 581:
#line 3596 "parse.y" /* yacc.c:1646  */
    { pform_pop_scope();
	assert(! current_block_stack.empty());
	PBlock*tmp = current_block_stack.top();
	current_block_stack.pop();
	if ((yyvsp[-1].statement_list)) tmp->set_statement(*(yyvsp[-1].statement_list));
	delete[](yyvsp[-4].text);
	delete (yyvsp[-1].statement_list);
	(yyval.statement) = tmp;
      }
#line 9367 "parse.cc" /* yacc.c:1646  */
    break;

  case 582:
#line 3606 "parse.y" /* yacc.c:1646  */
    { yyerrok; }
#line 9373 "parse.cc" /* yacc.c:1646  */
    break;

  case 583:
#line 3614 "parse.y" /* yacc.c:1646  */
    { PBlock*tmp = new PBlock(PBlock::BL_PAR);
	FILE_NAME(tmp, (yylsp[-1]));
	(yyval.statement) = tmp;
      }
#line 9382 "parse.cc" /* yacc.c:1646  */
    break;

  case 584:
#line 3619 "parse.y" /* yacc.c:1646  */
    { PBlock*tmp = new PBlock(PBlock::BL_PAR);
	FILE_NAME(tmp, (yylsp[-2]));
	tmp->set_statement(*(yyvsp[-1].statement_list));
	delete (yyvsp[-1].statement_list);
	(yyval.statement) = tmp;
      }
#line 9393 "parse.cc" /* yacc.c:1646  */
    break;

  case 585:
#line 3626 "parse.y" /* yacc.c:1646  */
    { PBlock*tmp = pform_push_block_scope((yyvsp[0].text), PBlock::BL_PAR);
	FILE_NAME(tmp, (yylsp[-2]));
	current_block_stack.push(tmp);
      }
#line 9402 "parse.cc" /* yacc.c:1646  */
    break;

  case 586:
#line 3632 "parse.y" /* yacc.c:1646  */
    { pform_pop_scope();
        assert(! current_block_stack.empty());
	PBlock*tmp = current_block_stack.top();
	current_block_stack.pop();
	if ((yyvsp[-1].statement_list)) tmp->set_statement(*(yyvsp[-1].statement_list));
	delete[](yyvsp[-4].text);
	delete (yyvsp[-1].statement_list);
	(yyval.statement) = tmp;
      }
#line 9416 "parse.cc" /* yacc.c:1646  */
    break;

  case 587:
#line 3642 "parse.y" /* yacc.c:1646  */
    { yyerrok; }
#line 9422 "parse.cc" /* yacc.c:1646  */
    break;

  case 588:
#line 3645 "parse.y" /* yacc.c:1646  */
    { PDisable*tmp = new PDisable(*(yyvsp[-1].pform_name));
		  FILE_NAME(tmp, (yylsp[-2]));
		  delete (yyvsp[-1].pform_name);
		  (yyval.statement) = tmp;
		}
#line 9432 "parse.cc" /* yacc.c:1646  */
    break;

  case 589:
#line 3651 "parse.y" /* yacc.c:1646  */
    { PTrigger*tmp = new PTrigger(*(yyvsp[-1].pform_name));
		  FILE_NAME(tmp, (yylsp[-2]));
		  delete (yyvsp[-1].pform_name);
		  (yyval.statement) = tmp;
		}
#line 9442 "parse.cc" /* yacc.c:1646  */
    break;

  case 590:
#line 3657 "parse.y" /* yacc.c:1646  */
    { PForever*tmp = new PForever((yyvsp[0].statement));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.statement) = tmp;
		}
#line 9451 "parse.cc" /* yacc.c:1646  */
    break;

  case 591:
#line 3662 "parse.y" /* yacc.c:1646  */
    { PRepeat*tmp = new PRepeat((yyvsp[-2].expr), (yyvsp[0].statement));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9460 "parse.cc" /* yacc.c:1646  */
    break;

  case 592:
#line 3667 "parse.y" /* yacc.c:1646  */
    { PCase*tmp = new PCase(NetCase::EQ, (yyvsp[-3].expr), (yyvsp[-1].citems));
		  FILE_NAME(tmp, (yylsp[-5]));
		  (yyval.statement) = tmp;
		}
#line 9469 "parse.cc" /* yacc.c:1646  */
    break;

  case 593:
#line 3672 "parse.y" /* yacc.c:1646  */
    { PCase*tmp = new PCase(NetCase::EQX, (yyvsp[-3].expr), (yyvsp[-1].citems));
		  FILE_NAME(tmp, (yylsp[-5]));
		  (yyval.statement) = tmp;
		}
#line 9478 "parse.cc" /* yacc.c:1646  */
    break;

  case 594:
#line 3677 "parse.y" /* yacc.c:1646  */
    { PCase*tmp = new PCase(NetCase::EQZ, (yyvsp[-3].expr), (yyvsp[-1].citems));
		  FILE_NAME(tmp, (yylsp[-5]));
		  (yyval.statement) = tmp;
		}
#line 9487 "parse.cc" /* yacc.c:1646  */
    break;

  case 595:
#line 3682 "parse.y" /* yacc.c:1646  */
    { yyerrok; }
#line 9493 "parse.cc" /* yacc.c:1646  */
    break;

  case 596:
#line 3684 "parse.y" /* yacc.c:1646  */
    { yyerrok; }
#line 9499 "parse.cc" /* yacc.c:1646  */
    break;

  case 597:
#line 3686 "parse.y" /* yacc.c:1646  */
    { yyerrok; }
#line 9505 "parse.cc" /* yacc.c:1646  */
    break;

  case 598:
#line 3688 "parse.y" /* yacc.c:1646  */
    { PCondit*tmp = new PCondit((yyvsp[-2].expr), (yyvsp[0].statement), 0);
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9514 "parse.cc" /* yacc.c:1646  */
    break;

  case 599:
#line 3693 "parse.y" /* yacc.c:1646  */
    { PCondit*tmp = new PCondit((yyvsp[-4].expr), (yyvsp[-2].statement), (yyvsp[0].statement));
		  FILE_NAME(tmp, (yylsp[-6]));
		  (yyval.statement) = tmp;
		}
#line 9523 "parse.cc" /* yacc.c:1646  */
    break;

  case 600:
#line 3698 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-4]), "error: Malformed conditional expression.");
		  (yyval.statement) = (yyvsp[0].statement);
		}
#line 9531 "parse.cc" /* yacc.c:1646  */
    break;

  case 601:
#line 3702 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-6]), "error: Malformed conditional expression.");
		  (yyval.statement) = (yyvsp[-2].statement);
		}
#line 9539 "parse.cc" /* yacc.c:1646  */
    break;

  case 602:
#line 3707 "parse.y" /* yacc.c:1646  */
    { PForStatement*tmp = new PForStatement((yyvsp[-10].expr), (yyvsp[-8].expr), (yyvsp[-6].expr), (yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].statement));
		  FILE_NAME(tmp, (yylsp[-12]));
		  (yyval.statement) = tmp;
		}
#line 9548 "parse.cc" /* yacc.c:1646  */
    break;

  case 603:
#line 3713 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0;
		  yyerror((yylsp[-10]), "error: Error in for loop step assignment.");
		}
#line 9556 "parse.cc" /* yacc.c:1646  */
    break;

  case 604:
#line 3718 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0;
		  yyerror((yylsp[-12]), "error: Error in for loop condition expression.");
		}
#line 9564 "parse.cc" /* yacc.c:1646  */
    break;

  case 605:
#line 3722 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0;
		  yyerror((yylsp[-4]), "error: Incomprehensible for loop.");
		}
#line 9572 "parse.cc" /* yacc.c:1646  */
    break;

  case 606:
#line 3726 "parse.y" /* yacc.c:1646  */
    { PWhile*tmp = new PWhile((yyvsp[-2].expr), (yyvsp[0].statement));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9581 "parse.cc" /* yacc.c:1646  */
    break;

  case 607:
#line 3731 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0;
		  yyerror((yylsp[-4]), "error: Error in while loop condition.");
		}
#line 9589 "parse.cc" /* yacc.c:1646  */
    break;

  case 608:
#line 3735 "parse.y" /* yacc.c:1646  */
    { PExpr*del = (*(yyvsp[-1].exprs))[0];
		  assert((yyvsp[-1].exprs)->count() == 1);
		  PDelayStatement*tmp = new PDelayStatement(del, (yyvsp[0].statement));
		  FILE_NAME(tmp, (yylsp[-1]));
		  (yyval.statement) = tmp;
		}
#line 9600 "parse.cc" /* yacc.c:1646  */
    break;

  case 609:
#line 3742 "parse.y" /* yacc.c:1646  */
    { PEventStatement*tmp = (yyvsp[-2].event_statement);
	if (tmp == 0) {
	      yyerror((yylsp[-2]), "error: Invalid event control.");
	      (yyval.statement) = 0;
	} else {
	      if ((yyvsp[0].statement)) pform_bind_attributes((yyvsp[0].statement)->attributes,(yyvsp[-1].named_pexprs));
	      tmp->set_statement((yyvsp[0].statement));
	      (yyval.statement) = tmp;
	}
      }
#line 9615 "parse.cc" /* yacc.c:1646  */
    break;

  case 610:
#line 3753 "parse.y" /* yacc.c:1646  */
    { PEventStatement*tmp = new PEventStatement;
	FILE_NAME(tmp, (yylsp[-3]));
	if ((yyvsp[0].statement)) pform_bind_attributes((yyvsp[0].statement)->attributes,(yyvsp[-1].named_pexprs));
	tmp->set_statement((yyvsp[0].statement));
	(yyval.statement) = tmp;
      }
#line 9626 "parse.cc" /* yacc.c:1646  */
    break;

  case 611:
#line 3760 "parse.y" /* yacc.c:1646  */
    { PEventStatement*tmp = new PEventStatement;
	FILE_NAME(tmp, (yylsp[-5]));
	if ((yyvsp[0].statement)) pform_bind_attributes((yyvsp[0].statement)->attributes,(yyvsp[-1].named_pexprs));
	tmp->set_statement((yyvsp[0].statement));
	(yyval.statement) = tmp;
      }
#line 9637 "parse.cc" /* yacc.c:1646  */
    break;

  case 612:
#line 3767 "parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-3].expr),(yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-3]));
		  (yyval.statement) = tmp;
		}
#line 9646 "parse.cc" /* yacc.c:1646  */
    break;

  case 613:
#line 3772 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "Syntax in assignment statement l-value.");
		  yyerrok;
		  (yyval.statement) = new PNoop;
		}
#line 9655 "parse.cc" /* yacc.c:1646  */
    break;

  case 614:
#line 3777 "parse.y" /* yacc.c:1646  */
    { PAssignNB*tmp = new PAssignNB((yyvsp[-3].expr),(yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-3]));
		  (yyval.statement) = tmp;
		}
#line 9664 "parse.cc" /* yacc.c:1646  */
    break;

  case 615:
#line 3782 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[-2]), "Syntax in assignment statement l-value.");
		  yyerrok;
		  (yyval.statement) = new PNoop;
		}
#line 9673 "parse.cc" /* yacc.c:1646  */
    break;

  case 616:
#line 3787 "parse.y" /* yacc.c:1646  */
    { assert((yyvsp[-2].exprs)->count() == 1);
		  PExpr*del = (*(yyvsp[-2].exprs))[0];
		  PAssign*tmp = new PAssign((yyvsp[-4].expr),del,(yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9684 "parse.cc" /* yacc.c:1646  */
    break;

  case 617:
#line 3794 "parse.y" /* yacc.c:1646  */
    { assert((yyvsp[-2].exprs)->count() == 1);
		  PExpr*del = (*(yyvsp[-2].exprs))[0];
		  PAssignNB*tmp = new PAssignNB((yyvsp[-4].expr),del,(yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9695 "parse.cc" /* yacc.c:1646  */
    break;

  case 618:
#line 3801 "parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-4].expr),0,(yyvsp[-2].event_statement),(yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9704 "parse.cc" /* yacc.c:1646  */
    break;

  case 619:
#line 3806 "parse.y" /* yacc.c:1646  */
    { PAssign*tmp = new PAssign((yyvsp[-8].expr),(yyvsp[-4].expr),(yyvsp[-2].event_statement),(yyvsp[-1].expr));
		  FILE_NAME(tmp,(yylsp[-8]));
		  tmp->set_lineno((yylsp[-8]).first_line);
		  (yyval.statement) = tmp;
		}
#line 9714 "parse.cc" /* yacc.c:1646  */
    break;

  case 620:
#line 3812 "parse.y" /* yacc.c:1646  */
    { PAssignNB*tmp = new PAssignNB((yyvsp[-4].expr),0,(yyvsp[-2].event_statement),(yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-4]));
		  (yyval.statement) = tmp;
		}
#line 9723 "parse.cc" /* yacc.c:1646  */
    break;

  case 621:
#line 3817 "parse.y" /* yacc.c:1646  */
    { PAssignNB*tmp = new PAssignNB((yyvsp[-8].expr),(yyvsp[-4].expr),(yyvsp[-2].event_statement),(yyvsp[-1].expr));
		  FILE_NAME(tmp, (yylsp[-8]));
		  (yyval.statement) = tmp;
		}
#line 9732 "parse.cc" /* yacc.c:1646  */
    break;

  case 622:
#line 3822 "parse.y" /* yacc.c:1646  */
    { PEventStatement*tmp;
		  PEEvent*etmp = new PEEvent(PEEvent::POSITIVE, (yyvsp[-2].expr));
		  tmp = new PEventStatement(etmp);
		  FILE_NAME(tmp,(yylsp[-4]));
		  tmp->set_statement((yyvsp[0].statement));
		  (yyval.statement) = tmp;
		}
#line 9744 "parse.cc" /* yacc.c:1646  */
    break;

  case 623:
#line 3830 "parse.y" /* yacc.c:1646  */
    { PCallTask*tmp = new PCallTask(lex_strings.make((yyvsp[-4].text)), *(yyvsp[-2].exprs));
		  FILE_NAME(tmp,(yylsp[-4]));
		  delete[](yyvsp[-4].text);
		  delete (yyvsp[-2].exprs);
		  (yyval.statement) = tmp;
		}
#line 9755 "parse.cc" /* yacc.c:1646  */
    break;

  case 624:
#line 3837 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>pt (0);
		  PCallTask*tmp = new PCallTask(lex_strings.make((yyvsp[-1].text)), pt);
		  FILE_NAME(tmp,(yylsp[-1]));
		  delete[](yyvsp[-1].text);
		  (yyval.statement) = tmp;
		}
#line 9766 "parse.cc" /* yacc.c:1646  */
    break;

  case 625:
#line 3844 "parse.y" /* yacc.c:1646  */
    { PCallTask*tmp = new PCallTask(*(yyvsp[-4].pform_name), *(yyvsp[-2].exprs));
		  FILE_NAME(tmp, (yylsp[-4]));
		  delete (yyvsp[-4].pform_name);
		  delete (yyvsp[-2].exprs);
		  (yyval.statement) = tmp;
		}
#line 9777 "parse.cc" /* yacc.c:1646  */
    break;

  case 626:
#line 3856 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>pt (0);
		  PCallTask*tmp = new PCallTask(*(yyvsp[-3].pform_name), pt);
		  FILE_NAME(tmp, (yylsp[-3]));
		  delete (yyvsp[-3].pform_name);
		  (yyval.statement) = tmp;
		}
#line 9788 "parse.cc" /* yacc.c:1646  */
    break;

  case 627:
#line 3863 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>pt (0);
		  PCallTask*tmp = new PCallTask(*(yyvsp[-1].pform_name), pt);
		  FILE_NAME(tmp, (yylsp[-1]));
		  delete (yyvsp[-1].pform_name);
		  (yyval.statement) = tmp;
		}
#line 9799 "parse.cc" /* yacc.c:1646  */
    break;

  case 628:
#line 3870 "parse.y" /* yacc.c:1646  */
    { yyerror((yylsp[0]), "error: malformed statement");
		  yyerrok;
		  (yyval.statement) = new PNoop;
		}
#line 9808 "parse.cc" /* yacc.c:1646  */
    break;

  case 629:
#line 3878 "parse.y" /* yacc.c:1646  */
    { svector<Statement*>*tmp = (yyvsp[-1].statement_list);
	if (tmp) {
	      tmp = new svector<Statement*>(*(yyvsp[-1].statement_list), (yyvsp[0].statement));
	      delete (yyvsp[-1].statement_list);
	} else {
	      tmp = new svector<Statement*>(1);
	      (*tmp)[0] = (yyvsp[0].statement);
	}
	(yyval.statement_list) = tmp;
      }
#line 9823 "parse.cc" /* yacc.c:1646  */
    break;

  case 630:
#line 3889 "parse.y" /* yacc.c:1646  */
    { (yyval.statement_list) = 0; }
#line 9829 "parse.cc" /* yacc.c:1646  */
    break;

  case 631:
#line 3894 "parse.y" /* yacc.c:1646  */
    { svector<Statement*>*tmp = new svector<Statement*>(*(yyvsp[-1].statement_list), (yyvsp[0].statement));
		  delete (yyvsp[-1].statement_list);
		  (yyval.statement_list) = tmp;
		}
#line 9838 "parse.cc" /* yacc.c:1646  */
    break;

  case 632:
#line 3899 "parse.y" /* yacc.c:1646  */
    { svector<Statement*>*tmp = new svector<Statement*>(1);
		  (*tmp)[0] = (yyvsp[0].statement);
		  (yyval.statement_list) = tmp;
		}
#line 9847 "parse.cc" /* yacc.c:1646  */
    break;

  case 633:
#line 3907 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 9853 "parse.cc" /* yacc.c:1646  */
    break;

  case 634:
#line 3909 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0; }
#line 9859 "parse.cc" /* yacc.c:1646  */
    break;

  case 635:
#line 3914 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = pform_contribution_statement((yylsp[-2]), (yyvsp[-3].expr), (yyvsp[-1].expr)); }
#line 9865 "parse.cc" /* yacc.c:1646  */
    break;

  case 636:
#line 3920 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = new svector<PWire*>(0); }
#line 9871 "parse.cc" /* yacc.c:1646  */
    break;

  case 637:
#line 3921 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 9877 "parse.cc" /* yacc.c:1646  */
    break;

  case 638:
#line 3925 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 9883 "parse.cc" /* yacc.c:1646  */
    break;

  case 639:
#line 3926 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 9889 "parse.cc" /* yacc.c:1646  */
    break;

  case 640:
#line 3931 "parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						(yyvsp[-4].flag) ? IVL_VT_LOGIC :
						     IVL_VT_NO_TYPE,
						(yyvsp[-3].flag), (yyvsp[-2].exprs), (yyvsp[-1].perm_strings),
						(yylsp[-5]).text, (yylsp[-5]).first_line);
		  (yyval.wires) = tmp;
		}
#line 9902 "parse.cc" /* yacc.c:1646  */
    break;

  case 641:
#line 3940 "parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						(yyvsp[-4].flag) ? IVL_VT_LOGIC :
						     IVL_VT_NO_TYPE,
						(yyvsp[-3].flag), (yyvsp[-2].exprs), (yyvsp[-1].perm_strings),
						(yylsp[-5]).text, (yylsp[-5]).first_line);
		  (yyval.wires) = tmp;
		}
#line 9915 "parse.cc" /* yacc.c:1646  */
    break;

  case 642:
#line 3949 "parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						(yyvsp[-4].flag) ? IVL_VT_LOGIC :
						     IVL_VT_NO_TYPE,
						(yyvsp[-3].flag), (yyvsp[-2].exprs), (yyvsp[-1].perm_strings),
						(yylsp[-5]).text, (yylsp[-5]).first_line);
		  (yyval.wires) = tmp;
		}
#line 9928 "parse.cc" /* yacc.c:1646  */
    break;

  case 643:
#line 3962 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, true,
						range_stub, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line, true);
		  (yyval.wires) = tmp;
		}
#line 9947 "parse.cc" /* yacc.c:1646  */
    break;

  case 644:
#line 3977 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, true,
						range_stub, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line, true);
		  (yyval.wires) = tmp;
		}
#line 9966 "parse.cc" /* yacc.c:1646  */
    break;

  case 645:
#line 3992 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, true,
						range_stub, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line, true);
		  (yyval.wires) = tmp;
		}
#line 9985 "parse.cc" /* yacc.c:1646  */
    break;

  case 646:
#line 4010 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, false,
						range_stub, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10003 "parse.cc" /* yacc.c:1646  */
    break;

  case 647:
#line 4024 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, false,
						range_stub, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10021 "parse.cc" /* yacc.c:1646  */
    break;

  case 648:
#line 4038 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, false,
						range_stub, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10039 "parse.cc" /* yacc.c:1646  */
    break;

  case 649:
#line 4055 "parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_REAL, false,
						0, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10051 "parse.cc" /* yacc.c:1646  */
    break;

  case 650:
#line 4063 "parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_REAL, true,
						0, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10063 "parse.cc" /* yacc.c:1646  */
    break;

  case 651:
#line 4071 "parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_REAL, true,
						0, (yyvsp[-1].perm_strings),
						(yylsp[-3]).text, (yylsp[-3]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10075 "parse.cc" /* yacc.c:1646  */
    break;

  case 652:
#line 4082 "parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[-1].wires), *(yyvsp[0].wires));
		  delete (yyvsp[-1].wires);
		  delete (yyvsp[0].wires);
		  (yyval.wires) = tmp;
		}
#line 10085 "parse.cc" /* yacc.c:1646  */
    break;

  case 653:
#line 4088 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 10091 "parse.cc" /* yacc.c:1646  */
    break;

  case 654:
#line 4093 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 10097 "parse.cc" /* yacc.c:1646  */
    break;

  case 655:
#line 4095 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = 0; }
#line 10103 "parse.cc" /* yacc.c:1646  */
    break;

  case 656:
#line 4101 "parse.y" /* yacc.c:1646  */
    { port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = (yyvsp[-2].flag);
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range((yyvsp[-1].exprs));
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, (yyvsp[-2].flag),
						(yyvsp[-1].exprs), list_from_identifier((yyvsp[0].text)),
						(yylsp[-4]).text, (yylsp[-4]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10120 "parse.cc" /* yacc.c:1646  */
    break;

  case 657:
#line 4115 "parse.y" /* yacc.c:1646  */
    { port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = (yyvsp[-2].flag);
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range((yyvsp[-1].exprs));
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, (yyvsp[-2].flag),
						(yyvsp[-1].exprs), list_from_identifier((yyvsp[0].text)),
						(yylsp[-4]).text, (yylsp[-4]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10137 "parse.cc" /* yacc.c:1646  */
    break;

  case 658:
#line 4128 "parse.y" /* yacc.c:1646  */
    { port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = (yyvsp[-2].flag);
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range((yyvsp[-1].exprs));
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, (yyvsp[-2].flag),
						(yyvsp[-1].exprs), list_from_identifier((yyvsp[0].text)),
						(yylsp[-4]).text, (yylsp[-4]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10154 "parse.cc" /* yacc.c:1646  */
    break;

  case 659:
#line 4144 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = true;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, true,
						range_stub,
						list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line, true);
		  (yyval.wires) = tmp;
		}
#line 10179 "parse.cc" /* yacc.c:1646  */
    break;

  case 660:
#line 4165 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = true;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, true,
						range_stub,
						list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line, true);
		  (yyval.wires) = tmp;
		}
#line 10204 "parse.cc" /* yacc.c:1646  */
    break;

  case 661:
#line 4186 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = true;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, true,
						range_stub,
						list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line, true);
		  (yyval.wires) = tmp;
		}
#line 10229 "parse.cc" /* yacc.c:1646  */
    break;

  case 662:
#line 4210 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, false,
						range_stub,
						list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10253 "parse.cc" /* yacc.c:1646  */
    break;

  case 663:
#line 4230 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, false,
						range_stub,
						list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10277 "parse.cc" /* yacc.c:1646  */
    break;

  case 664:
#line 4250 "parse.y" /* yacc.c:1646  */
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, false,
						range_stub,
						list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10301 "parse.cc" /* yacc.c:1646  */
    break;

  case 665:
#line 4273 "parse.y" /* yacc.c:1646  */
    { port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_REAL;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = 0;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_REAL, false,
						0, list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10318 "parse.cc" /* yacc.c:1646  */
    break;

  case 666:
#line 4286 "parse.y" /* yacc.c:1646  */
    { port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_REAL;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = 0;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_REAL, false,
						0, list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10335 "parse.cc" /* yacc.c:1646  */
    break;

  case 667:
#line 4299 "parse.y" /* yacc.c:1646  */
    { port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_REAL;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = 0;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_REAL, false,
						0, list_from_identifier((yyvsp[0].text)),
						(yylsp[-2]).text, (yylsp[-2]).first_line);
		  (yyval.wires) = tmp;
		}
#line 10352 "parse.cc" /* yacc.c:1646  */
    break;

  case 668:
#line 4315 "parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[-2].wires), *(yyvsp[0].wires));
		  delete (yyvsp[-2].wires);
		  delete (yyvsp[0].wires);
		  (yyval.wires) = tmp;
		}
#line 10362 "parse.cc" /* yacc.c:1646  */
    break;

  case 669:
#line 4321 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 10368 "parse.cc" /* yacc.c:1646  */
    break;

  case 670:
#line 4323 "parse.y" /* yacc.c:1646  */
    { svector<PWire*>*new_decl
			= pform_make_task_ports(
				port_declaration_context.port_type,
				port_declaration_context.var_type,
				port_declaration_context.sign_flag,
				copy_range(port_declaration_context.range),
				list_from_identifier((yyvsp[0].text)),
				(yylsp[0]).text, (yylsp[0]).first_line);
		  svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[-2].wires), *new_decl);
		  delete (yyvsp[-2].wires);
		  delete new_decl;
		  (yyval.wires) = tmp;
		}
#line 10386 "parse.cc" /* yacc.c:1646  */
    break;

  case 671:
#line 4337 "parse.y" /* yacc.c:1646  */
    {
		  yyerror((yylsp[0]), "error: NULL port declarations are not "
		              "allowed.");
		}
#line 10395 "parse.cc" /* yacc.c:1646  */
    break;

  case 672:
#line 4342 "parse.y" /* yacc.c:1646  */
    {
		  yyerror((yylsp[0]), "error: ';' is an invalid port declaration "
		              "separator.");
		}
#line 10404 "parse.cc" /* yacc.c:1646  */
    break;

  case 673:
#line 4349 "parse.y" /* yacc.c:1646  */
    { lex_start_table(); }
#line 10410 "parse.cc" /* yacc.c:1646  */
    break;

  case 674:
#line 4351 "parse.y" /* yacc.c:1646  */
    { lex_end_table(); (yyval.strings) = (yyvsp[-1].strings); }
#line 10416 "parse.cc" /* yacc.c:1646  */
    break;

  case 677:
#line 4361 "parse.y" /* yacc.c:1646  */
    { char*tmp = new char[strlen((yyvsp[-3].text))+3];
		  strcpy(tmp, (yyvsp[-3].text));
		  char*tp = tmp+strlen(tmp);
		  *tp++ = ':';
		  *tp++ = (yyvsp[-1].letter);
		  *tp++ = 0;
		  delete[](yyvsp[-3].text);
		  (yyval.text) = tmp;
		}
#line 10430 "parse.cc" /* yacc.c:1646  */
    break;

  case 678:
#line 4374 "parse.y" /* yacc.c:1646  */
    { list<string>*tmp = new list<string>;
		  tmp->push_back((yyvsp[0].text));
		  delete[](yyvsp[0].text);
		  (yyval.strings) = tmp;
		}
#line 10440 "parse.cc" /* yacc.c:1646  */
    break;

  case 679:
#line 4380 "parse.y" /* yacc.c:1646  */
    { list<string>*tmp = (yyvsp[-1].strings);
		  tmp->push_back((yyvsp[0].text));
		  delete[](yyvsp[0].text);
		  (yyval.strings) = tmp;
		}
#line 10450 "parse.cc" /* yacc.c:1646  */
    break;

  case 680:
#line 4389 "parse.y" /* yacc.c:1646  */
    { list<string>*tmp = new list<string>;
		  tmp->push_back((yyvsp[0].text));
		  delete[](yyvsp[0].text);
		  (yyval.strings) = tmp;
		}
#line 10460 "parse.cc" /* yacc.c:1646  */
    break;

  case 681:
#line 4395 "parse.y" /* yacc.c:1646  */
    { list<string>*tmp = (yyvsp[-1].strings);
		  tmp->push_back((yyvsp[0].text));
		  delete[](yyvsp[0].text);
		  (yyval.strings) = tmp;
		}
#line 10470 "parse.cc" /* yacc.c:1646  */
    break;

  case 682:
#line 4404 "parse.y" /* yacc.c:1646  */
    { char*tmp = new char[strlen((yyvsp[-5].text))+5];
		  strcpy(tmp, (yyvsp[-5].text));
		  char*tp = tmp+strlen(tmp);
		  *tp++ = ':';
		  *tp++ = (yyvsp[-3].letter);
		  *tp++ = ':';
		  *tp++ = (yyvsp[-1].letter);
		  *tp++ = 0;
		  (yyval.text) = tmp;
		}
#line 10485 "parse.cc" /* yacc.c:1646  */
    break;

  case 683:
#line 4418 "parse.y" /* yacc.c:1646  */
    { PExpr*etmp = new PENumber((yyvsp[-1].number));
		  PEIdent*itmp = new PEIdent(lex_strings.make((yyvsp[-3].text)));
		  PAssign*atmp = new PAssign(itmp, etmp);
		  FILE_NAME(atmp, (yylsp[-3]));
		  delete[](yyvsp[-3].text);
		  (yyval.statement) = atmp;
		}
#line 10497 "parse.cc" /* yacc.c:1646  */
    break;

  case 684:
#line 4428 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 10503 "parse.cc" /* yacc.c:1646  */
    break;

  case 685:
#line 4429 "parse.y" /* yacc.c:1646  */
    { (yyval.statement) = 0; }
#line 10509 "parse.cc" /* yacc.c:1646  */
    break;

  case 686:
#line 4434 "parse.y" /* yacc.c:1646  */
    { char*tmp = new char[2];
		  tmp[0] = (yyvsp[0].letter);
		  tmp[1] = 0;
		  (yyval.text) = tmp;
		}
#line 10519 "parse.cc" /* yacc.c:1646  */
    break;

  case 687:
#line 4440 "parse.y" /* yacc.c:1646  */
    { char*tmp = new char[strlen((yyvsp[-1].text))+2];
		  strcpy(tmp, (yyvsp[-1].text));
		  char*tp = tmp+strlen(tmp);
		  *tp++ = (yyvsp[0].letter);
		  *tp++ = 0;
		  delete[](yyvsp[-1].text);
		  (yyval.text) = tmp;
		}
#line 10532 "parse.cc" /* yacc.c:1646  */
    break;

  case 688:
#line 4451 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '0'; }
#line 10538 "parse.cc" /* yacc.c:1646  */
    break;

  case 689:
#line 4452 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '1'; }
#line 10544 "parse.cc" /* yacc.c:1646  */
    break;

  case 690:
#line 4453 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'x'; }
#line 10550 "parse.cc" /* yacc.c:1646  */
    break;

  case 691:
#line 4454 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '?'; }
#line 10556 "parse.cc" /* yacc.c:1646  */
    break;

  case 692:
#line 4455 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'b'; }
#line 10562 "parse.cc" /* yacc.c:1646  */
    break;

  case 693:
#line 4456 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '*'; }
#line 10568 "parse.cc" /* yacc.c:1646  */
    break;

  case 694:
#line 4457 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '%'; }
#line 10574 "parse.cc" /* yacc.c:1646  */
    break;

  case 695:
#line 4458 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'f'; }
#line 10580 "parse.cc" /* yacc.c:1646  */
    break;

  case 696:
#line 4459 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'F'; }
#line 10586 "parse.cc" /* yacc.c:1646  */
    break;

  case 697:
#line 4460 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'l'; }
#line 10592 "parse.cc" /* yacc.c:1646  */
    break;

  case 698:
#line 4461 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'H'; }
#line 10598 "parse.cc" /* yacc.c:1646  */
    break;

  case 699:
#line 4462 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'B'; }
#line 10604 "parse.cc" /* yacc.c:1646  */
    break;

  case 700:
#line 4463 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'r'; }
#line 10610 "parse.cc" /* yacc.c:1646  */
    break;

  case 701:
#line 4464 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'R'; }
#line 10616 "parse.cc" /* yacc.c:1646  */
    break;

  case 702:
#line 4465 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'M'; }
#line 10622 "parse.cc" /* yacc.c:1646  */
    break;

  case 703:
#line 4466 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'n'; }
#line 10628 "parse.cc" /* yacc.c:1646  */
    break;

  case 704:
#line 4467 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'N'; }
#line 10634 "parse.cc" /* yacc.c:1646  */
    break;

  case 705:
#line 4468 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'p'; }
#line 10640 "parse.cc" /* yacc.c:1646  */
    break;

  case 706:
#line 4469 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'P'; }
#line 10646 "parse.cc" /* yacc.c:1646  */
    break;

  case 707:
#line 4470 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'Q'; }
#line 10652 "parse.cc" /* yacc.c:1646  */
    break;

  case 708:
#line 4471 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'q'; }
#line 10658 "parse.cc" /* yacc.c:1646  */
    break;

  case 709:
#line 4472 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '_'; }
#line 10664 "parse.cc" /* yacc.c:1646  */
    break;

  case 710:
#line 4473 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '+'; }
#line 10670 "parse.cc" /* yacc.c:1646  */
    break;

  case 711:
#line 4477 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '0'; }
#line 10676 "parse.cc" /* yacc.c:1646  */
    break;

  case 712:
#line 4478 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '1'; }
#line 10682 "parse.cc" /* yacc.c:1646  */
    break;

  case 713:
#line 4479 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = 'x'; }
#line 10688 "parse.cc" /* yacc.c:1646  */
    break;

  case 714:
#line 4480 "parse.y" /* yacc.c:1646  */
    { (yyval.letter) = '-'; }
#line 10694 "parse.cc" /* yacc.c:1646  */
    break;

  case 715:
#line 4488 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = pform_make_udp_input_ports((yyvsp[-1].perm_strings)); }
#line 10700 "parse.cc" /* yacc.c:1646  */
    break;

  case 716:
#line 4490 "parse.y" /* yacc.c:1646  */
    { perm_string pname = lex_strings.make((yyvsp[-1].text));
	PWire*pp = new PWire(pname, NetNet::IMPLICIT, NetNet::POUTPUT, IVL_VT_LOGIC);
	svector<PWire*>*tmp = new svector<PWire*>(1);
	(*tmp)[0] = pp;
	(yyval.wires) = tmp;
	delete[](yyvsp[-1].text);
      }
#line 10712 "parse.cc" /* yacc.c:1646  */
    break;

  case 717:
#line 4498 "parse.y" /* yacc.c:1646  */
    { perm_string pname = lex_strings.make((yyvsp[-1].text));
	PWire*pp = new PWire(pname, NetNet::REG, NetNet::PIMPLICIT, IVL_VT_LOGIC);
	svector<PWire*>*tmp = new svector<PWire*>(1);
	(*tmp)[0] = pp;
	(yyval.wires) = tmp;
	delete[](yyvsp[-1].text);
      }
#line 10724 "parse.cc" /* yacc.c:1646  */
    break;

  case 718:
#line 4506 "parse.y" /* yacc.c:1646  */
    { perm_string pname = lex_strings.make((yyvsp[-1].text));
	PWire*pp = new PWire(pname, NetNet::REG, NetNet::POUTPUT, IVL_VT_LOGIC);
	svector<PWire*>*tmp = new svector<PWire*>(1);
	(*tmp)[0] = pp;
	(yyval.wires) = tmp;
	delete[](yyvsp[-1].text);
      }
#line 10736 "parse.cc" /* yacc.c:1646  */
    break;

  case 719:
#line 4517 "parse.y" /* yacc.c:1646  */
    { (yyval.wires) = (yyvsp[0].wires); }
#line 10742 "parse.cc" /* yacc.c:1646  */
    break;

  case 720:
#line 4519 "parse.y" /* yacc.c:1646  */
    { svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[-1].wires), *(yyvsp[0].wires));
		  delete (yyvsp[-1].wires);
		  delete (yyvsp[0].wires);
		  (yyval.wires) = tmp;
		}
#line 10752 "parse.cc" /* yacc.c:1646  */
    break;

  case 721:
#line 4528 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
	tmp->push_back(lex_strings.make((yyvsp[0].text)));
	delete[](yyvsp[0].text);
	(yyval.perm_strings) = tmp;
      }
#line 10762 "parse.cc" /* yacc.c:1646  */
    break;

  case 722:
#line 4534 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-2].perm_strings);
	tmp->push_back(lex_strings.make((yyvsp[0].text)));
	delete[](yyvsp[0].text);
	(yyval.perm_strings) = tmp;
      }
#line 10772 "parse.cc" /* yacc.c:1646  */
    break;

  case 723:
#line 4541 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = true; }
#line 10778 "parse.cc" /* yacc.c:1646  */
    break;

  case 724:
#line 4541 "parse.y" /* yacc.c:1646  */
    { (yyval.flag) = false; }
#line 10784 "parse.cc" /* yacc.c:1646  */
    break;

  case 725:
#line 4544 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 10790 "parse.cc" /* yacc.c:1646  */
    break;

  case 726:
#line 4545 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 10796 "parse.cc" /* yacc.c:1646  */
    break;

  case 727:
#line 4550 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 10806 "parse.cc" /* yacc.c:1646  */
    break;

  case 728:
#line 4556 "parse.y" /* yacc.c:1646  */
    { list<perm_string>*tmp = (yyvsp[-3].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[0].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[0].text);
		}
#line 10816 "parse.cc" /* yacc.c:1646  */
    break;

  case 729:
#line 4574 "parse.y" /* yacc.c:1646  */
    { perm_string tmp2 = lex_strings.make((yyvsp[-8].text));
		  pform_make_udp(tmp2, (yyvsp[-6].perm_strings), (yyvsp[-3].wires), (yyvsp[-1].strings), (yyvsp[-2].statement),
				 (yylsp[-8]).text, (yylsp[-8]).first_line);
		  delete[](yyvsp[-8].text);
		}
#line 10826 "parse.cc" /* yacc.c:1646  */
    break;

  case 730:
#line 4589 "parse.y" /* yacc.c:1646  */
    { perm_string tmp2 = lex_strings.make((yyvsp[-11].text));
		  perm_string tmp6 = lex_strings.make((yyvsp[-7].text));
		  pform_make_udp(tmp2, (yyvsp[-8].flag), tmp6, (yyvsp[-6].expr), (yyvsp[-4].perm_strings), (yyvsp[-1].strings),
				 (yylsp[-11]).text, (yylsp[-11]).first_line);
		  delete[](yyvsp[-11].text);
		  delete[](yyvsp[-7].text);
		}
#line 10838 "parse.cc" /* yacc.c:1646  */
    break;


#line 10842 "parse.cc" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
